//::///////////////////////////////////////////////
//:: Clap of Thunder
//:: cmi_s2_clapthunder
//:: Purpose: 
//:: Created By: Kaedrin (Matt)
//:: Created On: December 11, 2007
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 
#include "cmi_inc_sneakattack"

int GetSonicReserveDamageDice()
{

	if (GetHasSpell(1038))
		return 8;
	if (GetHasSpell(1820))
		return 8;
	if (GetHasSpell(1016))
		return 5;
	if (GetHasSpell(1813))
		return 5;
	if (GetHasSpell(1861))
		return 4;		
	if (GetHasSpell(1037))
		return 4;
	if (GetHasSpell(1743))
		return 4;
	if (GetHasSpell(1753))
		return 3;
	if (GetHasSpell(1829))
		return 3;
			
	return 0;
}

void main()
{

    if (!X2PreSpellCastCode())
    {
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	//Declare major variables
	object oTarget = GetSpellTargetObject();
	int nDamageDice = 0;
	
	nDamageDice = GetSonicReserveDamageDice();
		 
	if (nDamageDice == 0)
	{
		SendMessageToPC(OBJECT_SELF,"You do not have any valid spells left that can trigger this ability.");	
	}
	else
	if (GetIsObjectValid(oTarget))
	{
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
		{		
			effect eVis = EffectVisualEffect(VFX_HIT_SPELL_SONIC);
			int nDamage = d6(nDamageDice);
						
			int nMeleeTouch = TouchAttackMelee(oTarget);
			if (nMeleeTouch != TOUCH_ATTACK_RESULT_MISS)
			{
						
				if (GetHasFeat(2991,OBJECT_SELF,TRUE))
					nDamage += 2;	
				if (nMeleeTouch == TOUCH_ATTACK_RESULT_CRITICAL)
					nDamage = nDamage * 2;
										
				//include sneak attack damage
				if (StringToInt(Get2DAString("cmi_switches","SneakAttackSpells",0)))
					nDamage += EvaluateSneakAttack(oTarget, OBJECT_SELF);
									
				effect eDamage = EffectDamage(nDamage,DAMAGE_TYPE_SONIC);
				
				//Fire cast spell at event for the specified target
				SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId()));				

				//Apply the effects
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);
				
				effect eStatusEffect = EffectDeaf();	
                if  (!MySavingThrow(SAVING_THROW_FORT, oTarget, GetSpellSaveDC(), SAVING_THROW_TYPE_SONIC))
					ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eStatusEffect, oTarget, 6.0f);				
			
			}
		}	
	}			



}