//::///////////////////////////////////////////////
//:: Fiery Burst
//:: cmi_s2_fieryburst
//:: Purpose: 
//:: Created By: Kaedrin (Matt)
//:: Created On: December 12, 2007
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

int GetSonicReserveDamageDice()
{

	if (GetHasSpell(116))
		return 9;
	if (GetHasSpell(158))
		return 9;		
	if (GetHasSpell(89))
		return 8;		
	if (GetHasSpell(39))
		return 7;
	if (GetHasSpell(57))
		return 7;									
	if (GetHasSpell(61))
		return 5;
	if (GetHasSpell(440))
		return 5;
	if (GetHasSpell(446))
		return 5;
	if (GetHasSpell(869))
		return 5;
	if (GetHasSpell(871))
		return 5;
		
	if (GetHasSpell(47))
		return 4;
	if (GetHasSpell(191))
		return 4;		
	if (GetHasSpell(1826))
		return 4;
		
	if (GetHasSpell(57))
		return 7;	
	if (GetHasSpell(39))
		return 7;
	if (GetHasSpell(57))
		return 7;
		
	if (GetHasSpell(47))
		return 4;
	if (GetHasSpell(191))
		return 4;		
	if (GetHasSpell(1826))
		return 4;
		
	if (GetHasSpell(58))
		return 3;
	if (GetHasSpell(59))
		return 3;		
	if (GetHasSpell(1753))
		return 3;
	if (GetHasSpell(1759))
		return 3;
	if (GetHasSpell(1814))
		return 3;	
			
	if (GetHasSpell(518))
		return 2;
	if (GetHasSpell(542))
		return 2;
	if (GetHasSpell(851))
		return 2;		
	if (GetHasSpell(1001))
		return 2;
	if (GetHasSpell(1055))
		return 2;
	if (GetHasSpell(1747))
		return 2;		
	if (GetHasSpell(1858))
		return 2;				
																	
	return 0;
}

void main()
{

    if (!X2PreSpellCastCode())
    {
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	//Declare major variables
	int nDamageDice = 0;
	nDamageDice = GetSonicReserveDamageDice();	 
	if (nDamageDice == 0)
	{
		SendMessageToPC(OBJECT_SELF,"You do not have any valid spells left that can trigger this ability.");	
		return;	
	}

	float fDelay;
	int nDamage;
	effect eDam;
	effect eVis = EffectVisualEffect(VFX_IMP_FLAME_S);
	
	location lTarget = GetSpellTargetLocation();
    object oTarget = GetFirstObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_SMALL, lTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);
    //Cycle through the targets within the spell shape until an invalid object is captured.
    while (GetIsObjectValid(oTarget))
    {
        if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
    	{
                //Fire cast spell at event for the specified target
                SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId()));
                //Get the distance between the explosion and the target to calculate delay
                fDelay = GetDistanceBetweenLocations(lTarget, GetLocation(oTarget))/20;
				
                    //Roll damage for each target
                    nDamage = d6(nDamageDice);

                    //Adjust the damage based on the Reflex Save, Evasion and Improved Evasion.
                    nDamage = GetReflexAdjustedDamage(nDamage, oTarget, GetSpellSaveDC(), SAVING_THROW_TYPE_FIRE);
                    //Set the damage effect
                    eDam = EffectDamage(nDamage, DAMAGE_TYPE_FIRE);
                    if(nDamage > 0)
                    {
                        // Apply effects to the currently selected target.
                        DelayCommand(fDelay, ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam, oTarget));
                        //This visual effect is applied to the target object not the location as above.  This visual effect
                        //represents the flame that erupts on the target not on the ground.
                        DelayCommand(fDelay, ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget));
                    }
        }
       //Select the next target within the spell shape.
       oTarget = GetNextObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_SMALL, lTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);
    }
			



}