//::///////////////////////////////////////////////
//:: Invisible Needle
//:: cmi_s2_invisneedle
//:: Purpose: 
//:: Created By: Kaedrin (Matt)
//:: Created On: December 12, 2007
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 
#include "cmi_inc_sneakattack"

int GetForceReserveDamageDice()
{
	// Binding Chain of Fate
	if (GetHasSpell(2576))
		return 9;

	// Bigbys Crushing Hand
	if (GetHasSpell(463))
		return 9;
		
	// Bigbys Clentched Fist
	if (GetHasSpell(462))
		return 8;

	// Halasters Blacksphere
	if (GetHasSpell(2577))
		return 8;
		
	// Mordenkainens Sword
	if (GetHasSpell(123))
		return 7;

	// Bigbys Grasping Hand		
	if (GetHasSpell(461))
		return 7;
    
	// Crushing Sphere
	if (GetHasSpell(2451))
		return 6;
		
	// Isaacs Greater Missile Storm				
	if (GetHasSpell(448))
		return 6;

	// Bigbys Forceful Hand		
	if (GetHasSpell(460))
		return 6;
    
	// Mailed Might of the Magelords
	if (GetHasSpell(2583))
		return 5;

	// Nezrams Sapphire Screen of Shielding		
	if (GetHasSpell(2586))
		return 5;
    
	// Bigbys Interposing Hand		
	if (GetHasSpell(459))
		return 5;

	// Snillocs Major Missile
	if (GetHasSpell(2398))
		return 5;	
			
	// Mordenkainens Force Missiles
	if (GetHasSpell(2320))
		return 4;	
	
	// Force Orb				
	if (GetHasSpell(2346))
		return 4;	
		
	// Isaacs Lesser Missile Storm			
	if (GetHasSpell(447))
		return 4;																		

	// Steelsting
	if (GetHasSpell(2579))
		return 4;   

	// Thunderlance
	if (GetHasSpell(2341))
		return 4;   
						
	// Chain Missile
	if (GetHasSpell(2582))
		return 3;   
		
	// Laerals Silver Lance
	if (GetHasSpell(2578))
		return 3;   
		
	// Theskyns Hearty Heave
	if (GetHasSpell(2585))
		return 2;
		
	// Battering Ram
	if (GetHasSpell(2404))
		return 2;																			    
	
	// Blast of Force
	if (GetHasSpell(2482))
		return 2;																		

	// Forcewave
	if (GetHasSpell(2403))
		return 1;																		
    		
	// Magic Missile		
	if (GetHasSpell(107))
		return 1;																		
		
	return 0;
}

void main()
{

    if (!X2PreSpellCastCode())
    {
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	//Declare major variables
	object oTarget = GetSpellTargetObject();
	int nDamageDice = 0;
	
	nDamageDice = GetForceReserveDamageDice();
			 
	if (nDamageDice == 0)
	{
		SendMessageToPC(OBJECT_SELF,"You do not have any valid spells left that can trigger this ability.");	
	}
	else
	if (GetIsObjectValid(oTarget))
	{
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
		{		
			effect eVis = EffectVisualEffect(VFX_HIT_SPELL_CONJURATION);
			int nDamage = d4(nDamageDice);
						
			int nRangedTouch = TouchAttackRanged(oTarget);
			if (nRangedTouch != TOUCH_ATTACK_RESULT_MISS)
			{
						
				if (GetHasFeat(2992,OBJECT_SELF,TRUE))
					nDamage += 2;

				// For Force Specialization feat from Argent Savant.		
				if (GetHasFeat(5218,OBJECT_SELF,TRUE))
					nDamage += 1;
											
				if (nRangedTouch == TOUCH_ATTACK_RESULT_CRITICAL)
					nDamage = nDamage * 2;
					
				//include sneak attack damage
				if (StringToInt(Get2DAString("cmi_switches","SneakAttackSpells",0)))
					nDamage += EvaluateSneakAttack(oTarget, OBJECT_SELF);					
										
				effect eDamage = EffectDamage(nDamage,DAMAGE_TYPE_MAGICAL);
				
				//Fire cast spell at event for the specified target
				SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId()));				

				//Apply the effects
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);
				
				// Chain Missile
				if (GetHasSpell(2582))
				{
				    //Get the spell target location as opposed to the spell target.
				    location lTarget = GetSpellTargetLocation();
					
				    //Declare the spell shape, size and the location.  Capture the first target object in the shape.
				    object aTarget = GetFirstObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_HUGE, lTarget, TRUE, OBJECT_TYPE_CREATURE);
					
				    //Cycle through the targets within the spell shape until an invalid object is captured.
				    while (GetIsObjectValid(aTarget))
					{
						if (spellsIsTarget(aTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
						{		
							eDamage = EffectDamage(1,DAMAGE_TYPE_MAGICAL);
							ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
							ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);
						}
					
				       //Select the next target within the spell shape.
				       aTarget = GetNextObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_HUGE, lTarget, TRUE, OBJECT_TYPE_CREATURE);
					}
				}			
			}
		}	
	}			



}