//::///////////////////////////////////////////////
//:: Arcane Boost: Damage
//:: mt_f0_arcboostdamage.nss
//:: Nov 18, 2015
//:://////////////////////////////////////////////
/*
    Your damage increases.
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: Jan 7, 2002
//:://////////////////////////////////////////////

// JLR - OEI 08/24/05 -- Metamagic changes
// PKM-OEI 08.09.06 -- VFX update
//:: AFW-OEI 08/03/2007: Account for Assassins.

#include "nwn2_inc_spells"
#include "x2_inc_spellhook" 

void main()
{
/* 
  Spellcast Hook Code 
  Added 2003-06-23 by GeorgZ
  If you want to make changes to all spells,
  check x2_inc_spellhook.nss to find out more 
*/
    if (!X2PreSpellCastCode())
    {
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
// End of Spell Cast Hook

	//Declare major variables
    object oTarget = GetSpellTargetObject();
	int nLevelAbjChamp = GetLevelByClass(106, OBJECT_SELF);
	int nDuration = GetCasterLevel(OBJECT_SELF);	
    float fDuration = RoundsToSeconds(nDuration);
    
	effect eVis = EffectVisualEffect( VFX_DUR_INVISIBILITY );
    effect eEffect = EffectDamageIncrease(nLevelAbjChamp, DAMAGE_TYPE_MAGICAL);
	effect eLink = EffectLinkEffects( eEffect, eVis );

    //Fire cast spell at event for the specified target
    SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId(), FALSE));
		
    //Enter Metamagic conditions
    fDuration = ApplyMetamagicDurationMods(fDuration);
    int nDurType = ApplyMetamagicDurationTypeMods(DURATION_TYPE_TEMPORARY);

	//Apply the VFX impact and effects
    ApplyEffectToObject(nDurType, eLink, oTarget, fDuration);
}