//::///////////////////////////////////////////////
//:: Arcane Fire
//:: mt_f0_arcfire
//:: Purpose: 
//:: Based On: Reserve Feat script created by Kaedrin (Matt)
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook"
#include "x2_i0_spells"
#include "cmi_ginc_spells"
#include "cmi_inc_sneakattack"

int GetArcaneFireDamageDice()
{
    int nSpellID = JXGetSpellId();
	
	if (nSpellID == 2497)
		return 9;
								
	if (nSpellID == 2496)
		return 8;
		
	if (nSpellID == 2495)
		return 7;	
												
	if (nSpellID == 2494)
		return 6;	
		
	if (nSpellID == 2493)
		return 5;						
		
	if (nSpellID == 2492)
		return 4;
			
	if (nSpellID == 2491)
		return 3;	
				
	if (nSpellID == 2490)
		return 2;	
		
	if (nSpellID == 2477)
		return 1;	
																													
	return 0;
}

void mainSpell();
void main()
{
	AssignCommand(JXGetCaster(), mainSpell());
}

void mainSpell()
{

    if (!X2PreSpellCastCode())
    {
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        JXPostSpellCastCode();
        return;
    }

	//Declare major variables
	
	object oCaster = OBJECT_SELF;
    object oTarget = JXGetSpellTargetObject();
	int nClass = GetLevelByClass(81, oCaster);
	int nDamageDice = GetArcaneFireDamageDice();	
	int nDamage = d6(nDamageDice);
	int nDamage2 = d6(nClass);
	 
	if (nClass == 0)
	{
		SendMessageToPC(oCaster,"You are not an Archmage.");	
        JXPostSpellCastCode();
		return;	
	}
	else if (nDamageDice == 0)
	{
		SendMessageToPC(oCaster,"Spell level too low.");	
        JXPostSpellCastCode();
		return;	
	}
	else
	{
		int nTouch = TouchAttackRanged(oTarget);
		
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, oCaster))
		{		
			SignalEvent(oTarget, EventSpellCastAt(oCaster, JXGetSpellId()));
					
			if (nTouch != TOUCH_ATTACK_RESULT_MISS)
			{
				if(!MyResistSpell(oCaster, oTarget))
				{
					nDamage = nDamage + nDamage2;
					nDamage += GetRangedTouchSpecDamage(oCaster, nDamageDice, FALSE);	
								
					if (nTouch == TOUCH_ATTACK_RESULT_CRITICAL && !GetIsImmune(oTarget, IMMUNITY_TYPE_CRITICAL_HIT))
					{
						nDamage = nDamage * 2;
					}				

					//include sneak attack damage
					if (StringToInt(Get2DAString("cmi_options","Value",CMI_OPTIONS_SneakAttackSpells)))
					{
						nDamage += EvaluateSneakAttack(oTarget, oCaster);
					}
		
				    effect eDam = EffectDamage(nDamage, DAMAGE_TYPE_MAGICAL);
				    effect eVis = EffectVisualEffect(VFX_HIT_SPELL_EVOCATION);
	
		        	//----------------------------------------------------------------------
		        	// Apply the VFX and damage
		        	//----------------------------------------------------------------------
		       		eDam = EffectLinkEffects(eVis,eDam); // flare up
		            JXApplyEffectToObject (DURATION_TYPE_INSTANT,eDam,oTarget);
				}
			}
		}
	}
	
	JXPostSpellCastCode();
}