//::///////////////////////////////////////////////
//:: Hellfire Shield
//:: mt_f0_hellfireshield
//:: Created By: Joshua Kalis (Greg)
//:: Created On: January 4, 2008
//:://////////////////////////////////////////////


#include "nwn2_inc_spells"
#include "x2_inc_spellhook"
#include "x0_i0_spells"

void main()
{

    /*
      Spellcast Hook Code
      Added 2003-07-07 by Georg Zoeller
      If you want to make changes to all spells,
      check x2_inc_spellhook.nss to find out more

    */

    if (!X2PreSpellCastCode())
    {
    // If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

    // End of Spell Cast Hook
    object oTarget = GetSpellTargetObject();

    float fDuration = TurnsToSeconds(10);
    int nCasterLvl = GetCasterLevel(oTarget)/2;
    if(nCasterLvl > 10)
    {
        nCasterLvl = 5;
    }

	
	// 1. Apply fire shield style effect.
    effect eShield = EffectDamageShield(nCasterLvl, DAMAGE_BONUS_2d12, DAMAGE_TYPE_POSITIVE);
    effect eDur = EffectVisualEffect( VFX_DUR_FIRE );

    //Link effects
    effect eLink = EffectLinkEffects( eDur, eShield );

    //Fire cast spell at event for the specified target
    SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId(), FALSE));

    //Enter Metamagic conditions
    fDuration = ApplyMetamagicDurationMods(fDuration);
    //int nDurType = ApplyMetamagicDurationTypeMods(DURATION_TYPE_TEMPORARY);

    //Stacking Spellpass, 2003-07-07, Georg
    RemoveEffectsFromSpell(oTarget, GetSpellId());	
    ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLink, oTarget, fDuration);
	
	// 2. Apply constitution damage.
	effect eHurt = EffectAbilityDecrease(ABILITY_CONSTITUTION, 1);
    ApplyEffectToObject(DURATION_TYPE_PERMANENT, eHurt, OBJECT_SELF);
	
}