//::///////////////////////////////////////////////
//:: Improved Counterspell
//:: mt_s0_improvedcounterspell
//:: Purpose: Spell - Improved Counterspell
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Sept 24, 2015
//:: Description: 
//::
//:: You quickly target an enemy and go into counterspell mode.
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	//Declare major variables
	object oCaster = OBJECT_SELF;
	object oTarget = GetSpellTargetObject();
	int nCasterLvl = GetCasterLevel(oCaster);
		
	effect eVis;	
	effect eCounterspell;
	int nDamageType;
	int nSpellId = GetSpellId();
	
	eVis = EffectVisualEffect(VFX_HIT_SPELL_AVASCULATE);
		  
	if (GetIsObjectValid(oTarget))
	{
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, oCaster))
		{				
			//Fire cast spell at event for the specified target
			SignalEvent(oTarget, EventSpellCastAt(oCaster, GetSpellId()));				
			
			//Apply the effects
			ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
			ActionCounterSpell(oTarget);				
		}	
	}			
}