//::///////////////////////////////////////////////
//:: Summon Shadow Servant
//:: mt_f0_summonshadowservant
//:: Purpose: Summon a Shadow Servant
//:: Created By: Joshua Kalis (Greg)
//:: Created On: October 16, 2015
//:://////////////////////////////////////////////

#include "x2_inc_spellhook"
#include "x0_i0_spells"

void main()
{
    if (!X2PreSpellCastCode())
    {
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	// Define main variables	 	
    float fDuration = TurnsToSeconds(GetCasterLevel(OBJECT_SELF));
	int nLevelShadowcaster = GetLevelByClass(99, OBJECT_SELF);
	int nLevelMasterOfShadow = GetLevelByClass(100, OBJECT_SELF);
	int nLevelNoctumancer = GetLevelByClass(101, OBJECT_SELF);
	int nCasterLvl = nLevelShadowcaster + nLevelMasterOfShadow + nLevelNoctumancer;
    nCasterLvl = (nCasterLvl + 24);
	
    if (GetHasFeat(5198)) // If have mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    if (GetHasFeat(5199)) // If have greater mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    int nBonus = 12 + nCasterLvl;
		
    if (GetHasFeat(5194)) // If have extend mystery, double it.
    {
        nCasterLvl = (nCasterLvl * 2);
    }		
	fDuration = HoursToSeconds(nCasterLvl);
	
	// Summon specific variables
	string sSummon = "shadowelemental";
    location lTarget 	= GetSpellTargetLocation();
	
	if(nLevelMasterOfShadow <= 1)
		sSummon = "c_shadowservant1";
	else if(nLevelMasterOfShadow == 2)
		sSummon = "c_shadowservant2";
	else if(nLevelMasterOfShadow == 3)
		sSummon = "c_shadowservant3";
	else if(nLevelMasterOfShadow == 4)
		sSummon = "c_shadowservant4";
	else if(nLevelMasterOfShadow == 5)
		sSummon = "c_shadowservant5";
	else if(nLevelMasterOfShadow == 6)
		sSummon = "c_shadowservant6";
	else if(nLevelMasterOfShadow == 7)
		sSummon = "c_shadowservant7";
	else if(nLevelMasterOfShadow == 8)
		sSummon = "c_shadowservant8";
	else if(nLevelMasterOfShadow == 9)
		sSummon = "c_shadowservant9";
	else if(nLevelMasterOfShadow > 9)
		sSummon = "c_shadowservant10";
	else
		sSummon = "c_shadowservant1";
		
	object oSummon = CreateObject(OBJECT_TYPE_CREATURE, sSummon, lTarget, TRUE);
	effect eUnsummon = EffectVisualEffect(VFX_IMP_UNSUMMON);
	effect eVis = EffectVisualEffect(VFX_FNF_SUMMON_EPIC_UNDEAD);
	
	if (GetHasFeat(FEAT_AUGMENT_SUMMONING))
	{
		int nStr = 4;
		int nCon = 4;
		
	    if (GetHasFeat(5198)) // If have mystery focus, add 1 more.
	    {
	        nStr = (nStr + 1);
	        nCon = (nCon + 1);
	    }	
	    if (GetHasFeat(5199)) // If have greater mystery focus, add 1 more.
	    {
	        nStr = (nStr + 2);
	        nCon = (nCon + 2);
	    }	
	
		effect eStr = EffectAbilityIncrease(ABILITY_STRENGTH, nStr);
		effect eCon = EffectAbilityIncrease(ABILITY_CONSTITUTION, nCon);
		effect eAttack = EffectAttackIncrease(nStr, ATTACK_BONUS_MISC);
		effect eHP = EffectTemporaryHitpoints(nCon * 1);
			
		effect eLink = EffectLinkEffects(eStr, eCon);
		eLink = EffectLinkEffects(eLink, eAttack);
		eLink = EffectLinkEffects(eLink, eHP);
		eLink = SupernaturalEffect(eLink);
		
		ApplyEffectToObject(DURATION_TYPE_PERMANENT, eLink, oSummon);
	}

	ChangeFaction(oSummon, OBJECT_SELF);
	int nHenchies = GetMaxHenchmen();
	SetMaxHenchmen(nHenchies+50);
	AddHenchman(OBJECT_SELF, oSummon);
	SetMaxHenchmen(nHenchies);

	ApplyEffectAtLocation(DURATION_TYPE_INSTANT, eVis, lTarget);

	DelayCommand(fDuration, RemoveHenchman(OBJECT_SELF, oSummon));
	DelayCommand(fDuration, DestroyObject(oSummon, 0.1f));
	DelayCommand(fDuration, ApplyEffectAtLocation(DURATION_TYPE_INSTANT, eUnsummon, GetLocation(oSummon)));		
		
} 