//::///////////////////////////////////////////////
//:: Initiate of the Sevenfold Veil: Blue Veil
//:: mt_f0_veilblue
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Nov 12, 2015
//:://////////////////////////////////////////////

//Petrification effect + immune to divination and mind effect

#include "nwn2_inc_spells"
#include "x2_inc_spellhook"
#include "x0_i0_spells"

void main()
{
    /*
      Spellcast Hook Code
      Added 2003-07-07 by Georg Zoeller
      If you want to make changes to all spells,
      check x2_inc_spellhook.nss to find out more

    */
    if (!X2PreSpellCastCode())
    {
    // If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

    // End of Spell Cast Hook
    object oTarget = GetSpellTargetObject();

    int nCasterLvl = GetCasterLevel(oTarget);

	// Extended Abjuration doubles the duration.
	if(GetHasFeat(5238, OBJECT_SELF))
		nCasterLvl = nCasterLvl * 2;
		
    float fDuration = TurnsToSeconds(nCasterLvl);
	
	// 1. Apply fire shield style effect.
    effect eDur = EffectVisualEffect( VFX_DUR_ELEMENTAL_SHIELD );
    effect eShield = EffectDamageShield(nCasterLvl, (4 * DAMAGE_BONUS_40), DAMAGE_TYPE_MAGICAL);
	effect eMind = EffectImmunity(IMMUNITY_TYPE_MIND_SPELLS);
	effect eSlow = EffectImmunity(IMMUNITY_TYPE_SLOW);
	effect eKnockdown = EffectImmunity(IMMUNITY_TYPE_KNOCKDOWN);
	
    //Link effects
    effect eLink = EffectLinkEffects( eDur, eShield );
	eLink = EffectLinkEffects( eLink, eMind );
	eLink = EffectLinkEffects( eLink, eSlow );
	eLink = EffectLinkEffects( eLink, eKnockdown );

    //Fire cast spell at event for the specified target
    SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId(), FALSE));

    //Enter Metamagic conditions
    fDuration = ApplyMetamagicDurationMods(fDuration);
    //int nDurType = ApplyMetamagicDurationTypeMods(DURATION_TYPE_TEMPORARY);

    //Stacking Spellpass, 2003-07-07, Georg
    RemoveEffectsFromSpell(oTarget, GetSpellId());	
    ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLink, oTarget, fDuration);	
}