//::///////////////////////////////////////////////
//:: Initiate of the Sevenfold Veil: Violet Veil
//:: mt_f0_veilviolet
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Nov 12, 2015
//:://////////////////////////////////////////////

// Fire shield effect + protection from normal missiles

#include "nwn2_inc_spells"
#include "x2_inc_spellhook"
#include "x0_i0_spells"

void main()
{
    /*
      Spellcast Hook Code
      Added 2003-07-07 by Georg Zoeller
      If you want to make changes to all spells,
      check x2_inc_spellhook.nss to find out more

    */
    if (!X2PreSpellCastCode())
    {
    // If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

    // End of Spell Cast Hook
    object oTarget = GetSpellTargetObject();

    int nCasterLvl = GetCasterLevel(oTarget);
	
	// Extended Abjuration doubles the duration.
	if(GetHasFeat(5238, OBJECT_SELF))
		nCasterLvl = nCasterLvl * 2;
	
    float fDuration = TurnsToSeconds(nCasterLvl);
	
	// 1. Apply fire shield style effect.
    effect eShield = EffectDamageShield(nCasterLvl, (40 * DAMAGE_BONUS_2d10), DAMAGE_TYPE_MAGICAL);
    effect eProt = EffectACIncrease(30, AC_DODGE_BONUS, DAMAGE_TYPE_ALL);
    effect eProt2 = EffectDamageResistance(DAMAGE_TYPE_ALL, 20, 0); 
    effect eDur = EffectVisualEffect( VFX_DUR_FIRE );

    //Link effects
    effect eLink = EffectLinkEffects( eDur, eShield );
	eLink = EffectLinkEffects( eLink, eProt );
	eLink = EffectLinkEffects( eLink, eProt2 );

    //Fire cast spell at event for the specified target
    SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId(), FALSE));

    //Enter Metamagic conditions
    fDuration = ApplyMetamagicDurationMods(fDuration);
    //int nDurType = ApplyMetamagicDurationTypeMods(DURATION_TYPE_TEMPORARY);

    //Stacking Spellpass, 2003-07-07, Georg
    RemoveEffectsFromSpell(oTarget, GetSpellId());	
    ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLink, oTarget, fDuration);	
}