//::///////////////////////////////////////////////
//:: Initiate of the Sevenfold Veil: Yellow Veil
//:: mt_f0_veilyellow
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Nov 12, 2015
//:://////////////////////////////////////////////

// Electricity shield effect + protection from gas/cloud/poison/petrification

#include "nwn2_inc_spells"
#include "x2_inc_spellhook"
#include "x0_i0_spells"

void main()
{
    /*
      Spellcast Hook Code
      Added 2003-07-07 by Georg Zoeller
      If you want to make changes to all spells,
      check x2_inc_spellhook.nss to find out more

    */
    if (!X2PreSpellCastCode())
    {
    // If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

    // End of Spell Cast Hook
    object oTarget = GetSpellTargetObject();

    int nCasterLvl = GetCasterLevel(oTarget);

	// Extended Abjuration doubles the duration.
	if(GetHasFeat(5238, OBJECT_SELF))
		nCasterLvl = nCasterLvl * 2;
		
    float fDuration = TurnsToSeconds(nCasterLvl);
	
	// 1. Apply fire shield style effect.
    effect eDur = EffectVisualEffect( VFX_DUR_AURA_POISON );
    effect eShield = EffectDamageShield(nCasterLvl, (2 * DAMAGE_BONUS_40), DAMAGE_TYPE_ELECTRICAL);
	effect ePoison = EffectImmunity(IMMUNITY_TYPE_POISON);
	effect eDaze = EffectImmunity(IMMUNITY_TYPE_DAZED);
	effect eParalyze = EffectImmunity(IMMUNITY_TYPE_PARALYSIS);
	effect eStun = EffectImmunity(IMMUNITY_TYPE_STUN);
		// Petrification spells and effects
	effect eSpell1 = EffectSpellImmunity(485);
	effect eSpell2 = EffectSpellImmunity(495);
	effect eSpell3 = EffectSpellImmunity(496);
	effect eSpell4 = EffectSpellImmunity(497);
	effect eSpell5 = EffectSpellImmunity(498);
	effect eSpell6 = EffectSpellImmunity(1012);
	
    //Link effects
    effect eLink = EffectLinkEffects( eDur, eShield );
	eLink = EffectLinkEffects( eLink, ePoison );
	eLink = EffectLinkEffects( eLink, eDaze );
	eLink = EffectLinkEffects( eLink, eParalyze );
	eLink = EffectLinkEffects( eLink, eStun );
	eLink = EffectLinkEffects( eLink, eSpell1 );
	eLink = EffectLinkEffects( eLink, eSpell2 );
	eLink = EffectLinkEffects( eLink, eSpell3 );
	eLink = EffectLinkEffects( eLink, eSpell4 );
	eLink = EffectLinkEffects( eLink, eSpell5 );
	eLink = EffectLinkEffects( eLink, eSpell6 );

    //Fire cast spell at event for the specified target
    SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId(), FALSE));

    //Enter Metamagic conditions
    fDuration = ApplyMetamagicDurationMods(fDuration);
    //int nDurType = ApplyMetamagicDurationTypeMods(DURATION_TYPE_TEMPORARY);

    //Stacking Spellpass, 2003-07-07, Georg
    RemoveEffectsFromSpell(oTarget, GetSpellId());	
    ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLink, oTarget, fDuration);	
}