//::///////////////////////////////////////////////
//:: Mestil's Acid Ball
//:: mt_s0_acidball
//:: Purpose: Spell - Acidball
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Dec 29, 2007
//:: Description:
//:: Acid Storm 
//:: Evocation, Wiz/Sor 3
//:: 1D6 Acid in 20ft radius, maximum 10D6.
//::
//:: You throw a ball of expanding acid. The acid deals
//:: 1D6 points of acid damage per level (maximum 
//:: 10D6.)
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{
	//Declare major variables
	object oTarget = GetSpellTargetObject();
	int nCasterLvl = GetCasterLevel(OBJECT_SELF);
	
	if (nCasterLvl > 10)
		nCasterLvl = 10;

    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nCasterLvl = (nCasterLvl + 3);
    }	
    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nCasterLvl = (nCasterLvl + 2);
    }	
    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
	
    if (GetHasFeat(3092)) // If have acidic splatter, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
		
	int nDamage = d6(nCasterLvl);	
		
	effect eVis;	
	effect eOrbEffect;
	int nDamageType;
	int nSpellId = GetSpellId();
	
    //Get the spell target location as opposed to the spell target.
    location lTarget = GetLocation(oTarget);

	// Calculate the damage type.
	nDamageType	= DAMAGE_TYPE_ACID;
	eVis = EffectVisualEffect(VFX_HIT_SPELL_ACID);
		  
	//if (GetIsObjectValid(oTarget))
	//{
	//	if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
	//	{		
			int nMax = (nCasterLvl*8)+2;
			nDamage = ApplyMetamagicVariableMods( nDamage, nMax );					
			effect eDamage = EffectDamage(nDamage,nDamageType);
				
		    //Declare the spell shape, size and the location.  Capture the first target object in the shape.
		    oTarget = GetFirstObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_HUGE, lTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);

			//Cycle through the targets within the spell shape until an invalid object is captured.
		    while (GetIsObjectValid(oTarget))
		    {
				if(!MyResistSpell(OBJECT_SELF, oTarget))
				{							
					if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
					{		
						//Fire cast spell at event for the specified target
						SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, nSpellId));				

						//Apply the effects
						ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
						ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);
						
						if (GetHasFeat(5212,OBJECT_SELF,TRUE)) // Diabolism
						{
							int nLevelDiabolist = GetLevelByClass(96, OBJECT_SELF);
							if(nLevelDiabolist == 10)
								nDamage = 3;
							else if(nLevelDiabolist == 5)
								nDamage = 2;
							else
								nDamage = 1;	
							
			                effect eDam2 = EffectDamage(nDamage, DAMAGE_TYPE_NEGATIVE);
							ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam2, oTarget);
						}
	
						if (GetHasFeat(5213,OBJECT_SELF,TRUE)) // Vile Diabolism
						{
							nDamage = 1;
			                effect eDam3 = EffectDamage(nDamage, DAMAGE_TYPE_MAGICAL);
							ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam3, oTarget);
						}						
					}
				}
				
				//Select the next target within the spell shape.
		        oTarget = GetNextObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_HUGE, lTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);
		    }
			
			
			
			// Do not need extra damage.	
            //if (!MySavingThrow(SAVING_THROW_FORT, oTarget, GetSpellSaveDC(), SAVING_THROW_TYPE_ACID))
			//		ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eOrbEffect, oTarget, 6.0f);
				
				
	//	}	
	//}				
}