//::///////////////////////////////////////////////
//:: Acid Rain
//:: mt_s0_acidrain
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Jan 24, 2008
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void mainSpell();
void main()
{
    if (!X2PreSpellCastCode())
    {
	    // If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
		return;
    }
	// End of Spell Cast Hook

    //Declare major variables
	object oTarget = GetSpellTargetObject();
	int damageStarter = 7;
    if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        damageStarter = (damageStarter + 1);
    }	
    if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        damageStarter = (damageStarter + 2);
    }	
    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        damageStarter = (damageStarter + 3);
    }	
    if (GetHasFeat(3092)) // If have acidic splatter, add 1 more.
    {
        damageStarter = (damageStarter + 1);
    }		
	
	int nDamage = d6(damageStarter);
	
    location lTarget = GetSpellTargetLocation();
    int nDuration = GetCasterLevel(OBJECT_SELF);
	int nMetaMagic = GetMetaMagicFeat();
	
	//Check Extend metamagic feat.
    if (nMetaMagic & METAMAGIC_EXTEND) {
	   nDuration = nDuration * 2;	//Duration is +100%
    }
	if (nMetaMagic & METAMAGIC_MAXIMIZE) {
		nDamage = damageStarter * 6;
	}
	else if (nMetaMagic & METAMAGIC_EMPOWER) {
		nDamage = d6(damageStarter) * 2;
	}

	
    //Declare the spell shape, size and the location.  Capture the first target object in the shape.
    effect eAOE = EffectDamage(nDamage, DAMAGE_TYPE_ACID);
	effect eVis = EffectVisualEffect(VFX_HIT_AOE_ACID);
	effect eSlow = EffectSlow();
    oTarget = GetFirstObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_HUGE, lTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);

	//Cycle through the targets within the spell shape until an invalid object is captured.
    while (GetIsObjectValid(oTarget))
    {
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
		{		
			//Fire cast spell at event for the specified target
			SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId()));				

			//Apply the effects
			ApplyEffectToObject(DURATION_TYPE_INSTANT, eAOE, oTarget);
			ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
			ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eSlow, oTarget, RoundsToSeconds(nDuration));

			if (GetHasFeat(5212,OBJECT_SELF,TRUE)) // Diabolism
			{
				int nLevelDiabolist = GetLevelByClass(96, OBJECT_SELF);
				if(nLevelDiabolist == 10)
					nDamage = 3;
				else if(nLevelDiabolist == 5)
					nDamage = 2;
				else
					nDamage = 1;
				
				
                effect eDam2 = EffectDamage(nDamage, DAMAGE_TYPE_NEGATIVE);
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam2, oTarget);
			}

			if (GetHasFeat(5213,OBJECT_SELF,TRUE)) // Vile Diabolism
			{
				nDamage = 1;
                effect eDam3 = EffectDamage(nDamage, DAMAGE_TYPE_MAGICAL);
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam3, oTarget);
			}						
			
			//Select the next target within the spell shape.
	        oTarget = GetNextObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_HUGE, lTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);
		}
    }		
}