//::///////////////////////////////////////////////
//:: Mestil's Acid Sheath
//:: mt_s0_acidsheath
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    This spell creates an acid shield around your
    person. Any creature striking you with its body
    does normal damage, but at the same time the
    attacker takes 1d6 points +2 points per caster
    level of acid damage. Weapons with exceptional
    reach do not endanger thier uses in this way.
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: Jan 7, 2002
//:: 2003-07-07: Stacking Spell Pass, Georg Zoeller
//:://////////////////////////////////////////////

#include "x2_inc_spellhook"
#include "x0_i0_spells"

void main()
{
    if (!X2PreSpellCastCode())
    {
	    // If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
		return;
    }

// End of Spell Cast Hook


    //Declare major variables
    effect eVis = EffectVisualEffect(448);
    int nDuration = GetCasterLevel(OBJECT_SELF);
	int nDamageBonus = DAMAGE_BONUS_1d6;

    if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nDuration = (nDuration + 1);
		nDamageBonus = nDamageBonus + DAMAGE_BONUS_1d6;
    }	
    if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nDuration = (nDuration + 2);
		nDamageBonus = nDamageBonus + DAMAGE_BONUS_1d6;
    }	
    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nDuration = (nDuration + 3);
		nDamageBonus = nDamageBonus + DAMAGE_BONUS_1d6;
    }	
    if (GetHasFeat(3092)) // If have acidic splatter, add 1 more.
    {
        nDuration = (nDuration + 1);
		nDamageBonus = nDamageBonus + DAMAGE_BONUS_1d6;
    }	
	
    int nDamage = nDuration * 2;
    int nMetaMagic = GetMetaMagicFeat();
    object oTarget = OBJECT_SELF;
    effect eShield = EffectDamageShield(nDamage, nDamageBonus, DAMAGE_TYPE_ACID);
    effect eDur = EffectVisualEffect(VFX_DUR_CESSATE_POSITIVE);
	
    //Link effects
    effect eLink = EffectLinkEffects(eShield, eDur);
    eLink = EffectLinkEffects(eLink, eVis);

    //Fire cast spell at event for the specified target
    SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId(), FALSE));

    //Enter Metamagic conditions
    if (nMetaMagic & METAMAGIC_EXTEND)
    {
        nDuration = nDuration *2; //Duration is +100%
    }

    // 2003-07-07: Stacking Spell Pass, Georg
    RemoveEffectsFromSpell(oTarget, GetSpellId());

    //Apply the VFX impact and effects
    ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLink, oTarget, RoundsToSeconds(nDuration));		
}