//::///////////////////////////////////////////////
//:: Afraid of the Dark
//:: mt_s0_afraidofdark
//:: Purpose: Afraid of the Dark
//:: Created By: Joshua Kalis (Greg)
//:: Created On: September 19, 2015
//:: Description: Ability damage
//:: Mystery
//::
//:: Touch attack with ability damage.
//:://////////////////////////////////////////////

#include "nwn2_inc_spells"
#include "x2_inc_spellhook"

void main()
{
    if (!X2PreSpellCastCode())
    {
	    // If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	// Get necessary objects
	object oCaster		= OBJECT_SELF;
	location lTarget	= GetLocation(oCaster);
    object oTarget = GetSpellTargetObject();
	
	// Get caster level and alignment	
	int nLevelShadowcaster = GetLevelByClass(99, OBJECT_SELF);
	int nLevelMasterOfShadow = GetLevelByClass(100, OBJECT_SELF);
	int nLevelNoctumancer = GetLevelByClass(101, OBJECT_SELF);
	int nLevelShadowTheurge = GetLevelByClass(103, OBJECT_SELF);
	int nCasterLvl = nLevelShadowcaster + nLevelMasterOfShadow + nLevelNoctumancer + nLevelShadowTheurge;
	int nDamage = d6(1);
	
    if (GetHasFeat(5198)) // If have mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    if (GetHasFeat(5199)) // If have greater mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    int nBonus = 12 + nCasterLvl;
		
    if (GetHasFeat(5194)) // If have extend mystery, double it.
    {
        nCasterLvl = (nCasterLvl * 2);
    }		

	if(nCasterLvl < 5)
		nDamage = nDamage + 1;
	else if(nCasterLvl < 10)
		nDamage = nDamage + 2;
	else if(nCasterLvl < 15)
		nDamage = nDamage + 3;
	else if(nCasterLvl < 20)
		nDamage = nDamage + 4;
	else
		nDamage = nDamage + 5;
	
	// Effects
	effect eWis         = EffectAbilityDecrease(ABILITY_WISDOM, nDamage);
	effect eHit			= EffectVisualEffect(VFX_HIT_SPELL_CASTIGATE);
	effect eVisual		= EffectVisualEffect(VFX_AOE_SPELL_CASTIGATE);
	effect eLink;

	ApplyEffectAtLocation(DURATION_TYPE_INSTANT, eVisual, lTarget);
	eLink = EffectLinkEffects(eHit, eWis);
	ApplyEffectToObject(DURATION_TYPE_INSTANT, eLink, oTarget);
   	SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId(), TRUE));
}