//::///////////////////////////////////////////////
//:: Antimagic Ray
//:: mt_s0_antimagicray
//:: Purpose: Touched ranged attack that gives 100% spell failure for 1 round / level to target. SR=yes, save=no
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Nov 5, 2015
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	//Declare major variables
	object oTarget = GetSpellTargetObject();
    int nMetaMagic = GetMetaMagicFeat();
    float fDelay;
		
	if (GetIsObjectValid(oTarget))
	{
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
		{
			int nRangedTouch = TouchAttackRanged(oTarget);
			if (nRangedTouch != TOUCH_ATTACK_RESULT_MISS)
			{
			    //Declare major variables
			    object oCaster = OBJECT_SELF;
			    int nCasterLvl = GetCasterLevel(oCaster);
			    int nDamage, nDamage2;
				
			    effect eVis = EffectVisualEffect(VFX_HIT_SPELL_ABJURATION);
			    effect eDamage;
				effect eLink;
				
                if (!MyResistSpell(OBJECT_SELF, oTarget, fDelay))
        	    {
					eDamage = EffectSpellFailure(100, SPELL_SCHOOL_GENERAL);
					eLink = EffectLinkEffects(eDamage, eVis);
		        	ApplyEffectToObject( DURATION_TYPE_TEMPORARY, eLink, oTarget, RoundsToSeconds(nCasterLvl));					
				}
			}						
		}	
	}			
}