//::///////////////////////////////////////////////
//:: Arcane Bolts
//:: mt_s0_arcanebolts
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Jan 1, 2007
//:://////////////////////////////////////////////
//:: Purpose: 
/*
// A missile of magical energy darts forth from your
// fingertip and strikes its target. The
// missile deals 1d6+1 points of damage.  Target gets
// to make a reflex saving throw for half damage.
//
// For every two extra levels of experience past 1st, you
// gain an additional missile.
*/


// JLR - OEI 08/23/05 -- Metamagic changes
#include "nwn2_inc_spells"
#include "NW_I0_SPELLS"    
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
// End of Spell Cast Hook


    //Declare major variables
    object oTarget = GetSpellTargetObject();
    int nCasterLvl = GetCasterLevel(OBJECT_SELF);
    int nMissiles = (nCasterLvl + 1)/2;
    effect eVis = EffectVisualEffect(VFX_IMP_MAGBLUE);
    float fDelay, fTime, fTime2;
	int nSpell = GetSpellId();
	int nPathType = PROJECTILE_PATH_TYPE_DEFAULT;
	location lSourceLoc = GetLocation( OBJECT_SELF );
	location lTarget = GetLocation( oTarget );
    int nCnt;
	float fTravelTime;

	// For Force Specialization feat from Argent Savant.		
	int nSpecialization = 1; 	
	if (GetHasFeat(5218,OBJECT_SELF,TRUE))
		nSpecialization = 2;

	// Invisible Needle		
	if (GetHasFeat(3096,OBJECT_SELF,TRUE))
		nSpecialization += 1;
		
    if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
    {
        //Fire cast spell at event for the specified target
        SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, SPELL_MAGIC_MISSILE));
        
		//Limit missiles to five
        if (nMissiles > 5)
        {
            nMissiles = 5;
        }
		
		int nLevelForceMissileMage = GetLevelByClass(104, OBJECT_SELF);
		if (GetHasFeat(5226,OBJECT_SELF,TRUE)) // Bonus missile.
		{
			if(nLevelForceMissileMage == 5)
				nMissiles = nMissiles + 2;
			else
				nMissiles = nMissiles + 1;
		}		

		//Apply a single damage hit for each missile instead of as a single mass
		for (nCnt = 1; nCnt <= nMissiles; nCnt++)
		{
			fTravelTime = GetProjectileTravelTime( lSourceLoc, lTarget, nPathType );
			if ( nCnt == 0 )	fDelay = 0.0f;
			else				fDelay = GetRandomDelay( 0.1f, 0.5f ) + (0.5f * IntToFloat(nCnt));
			
			/*
			fTime = fDelay + ((nCnt - 1) * 0.25);
			fTime2 = ((nCnt - 1) * 0.25);
			*/			        
			
				//Make SR Check
		        if (!MyResistSpell(OBJECT_SELF, oTarget, fDelay))
			  	{
	                //Roll damage
	                int nDam = d6(1) + nSpecialization;
					
	     	          //Enter Metamagic conditions
	                nDam = ApplyMetamagicVariableMods(nDam, 5);
	
					// Do reflex saving throw for half damage.
	                if (MySavingThrow(SAVING_THROW_REFLEX, oTarget, GetSpellSaveDC(), SAVING_THROW_TYPE_ALL))
						nDam = (nDam + 1) / 2;
									
	                //Set damage effect
	                effect eDam = EffectDamage(nDam, DAMAGE_TYPE_MAGICAL);
					
					
	                //Apply the MIRV and damage effect
	                DelayCommand(fDelay + fTravelTime, ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam, oTarget));	                
					
					if (GetHasFeat(5212,OBJECT_SELF,TRUE)) // Diabolism
					{
						int nLevelDiabolist = GetLevelByClass(96, OBJECT_SELF);
						if(nLevelDiabolist == 10)
							nDam = 3;
						else if(nLevelDiabolist == 5)
							nDam = 2;
						else
							nDam = 1;
												
		                effect eDam2 = EffectDamage(nDam, DAMAGE_TYPE_NEGATIVE);
						DelayCommand(fDelay + fTravelTime, ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam2, oTarget));
					}

					if (GetHasFeat(5213,OBJECT_SELF,TRUE)) // Vile Diabolism
					{
						nDam = 1;
		                effect eDam3 = EffectDamage(nDam, DAMAGE_TYPE_MAGICAL);
						DelayCommand(fDelay + fTravelTime, ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam3, oTarget));
					}
										
	                DelayCommand(fDelay + fTravelTime, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis, oTarget));
				}
				DelayCommand( fDelay, SpawnSpellProjectile(OBJECT_SELF, oTarget, lSourceLoc, lTarget, nSpell, nPathType) );
       	}
	}	
}