//::///////////////////////////////////////////////
//:: Acid Orb
//:: mt_s0_arrowdusk
//:: Purpose: Fundamental Mystery - Arrow of Dusk
//:: Created By: Joshua Kalis (Greg)
//:: Created On: September 16, 2015
//:: Description: Ranged cold based damage
//:: Fundamental Mystery
//:: 1D6 Cold to target on ranged touch attack, modified by mysteries
//::
//:: You cause a black arrow to fly at a single target. If it hits it causes cold damage.
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	//Declare major variables
	object oTarget = GetSpellTargetObject();
	int nCasterLvl = 1;
	
	if (nCasterLvl > 1)
		nCasterLvl = 1;

    if (GetHasFeat(5198)) // If have mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    if (GetHasFeat(5199)) // If have greater mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    if (GetHasFeat(3101)) // If have winter's grasp, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
		
	int nDamage = d6(nCasterLvl);	
		
	effect eVis;	
	effect eOrbEffect;
	int nDamageType;
	int nSpellId = GetSpellId();
	
	nDamageType	= DAMAGE_TYPE_COLD;
	eVis = EffectVisualEffect(VFX_HIT_SPELL_ICE);
	eOrbEffect = EffectStunned();
		  
	if (GetIsObjectValid(oTarget))
	{
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
		{		
		
			int nRangedTouch = TouchAttackRanged(oTarget);
			if (nRangedTouch != TOUCH_ATTACK_RESULT_MISS)
			{			
                nDamage = d6(nCasterLvl);
				if (GetHasFeat(5197)) // maximize mystery
				{
					nDamage = 6 * nCasterLvl;
				}	
			
				if (GetHasFeat(2992,OBJECT_SELF,TRUE)) // ranged touch specialization
					nDamage += 2;
					
				if (nRangedTouch == TOUCH_ATTACK_RESULT_CRITICAL)
					nDamage = nDamage * 3; // most of time its x2, this mystery = x3
					
				if (GetHasFeat(5196)) // empower mystery
				{
					nDamage = nDamage * 2;
				}	
				
				effect eDamage = EffectDamage(nDamage,nDamageType);
				
				//Fire cast spell at event for the specified target
				SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId()));				

				//Apply the effects
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);	
			}
		}	
	}			
}