//::///////////////////////////////////////////////
//:: Aura of Shade
//:: mt_s0_auraofshade
//:: Purpose: Protection cold, evasion, cold damage
//:: Created By: Joshua Kalis (Greg)
//:: Created On: September 22, 2015
//:: Description: Cold protection
//:: Initiate Mystery
//::
//:: 15 cold prot.
//:://////////////////////////////////////////////

#include "x2_inc_spellhook" 
#include "nwn2_inc_spells"
#include "X0_I0_SPELLS"

void main()
{
    if (!X2PreSpellCastCode())
    {
		// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

    //Declare major variables
	int nLevelShadowcaster = GetLevelByClass(99, OBJECT_SELF);
	int nLevelMasterOfShadow = GetLevelByClass(100, OBJECT_SELF);
	int nLevelNoctumancer = GetLevelByClass(101, OBJECT_SELF);
	int nLevelShadowTheurge = GetLevelByClass(103, OBJECT_SELF);
	int nCasterLvl = nLevelShadowcaster + nLevelMasterOfShadow + nLevelNoctumancer + nLevelShadowTheurge;
	int nBonus = d6(1);
	
    if (GetHasFeat(5198)) // If have mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    if (GetHasFeat(5199)) // If have greater mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }			
    if (GetHasFeat(5194)) // If have extend mystery, double it.
    {
        nCasterLvl = (nCasterLvl * 2);
    }		

    //Get the spell target location as opposed to the spell target.
    location lTarget = GetSpellTargetLocation();
    float fDelay;
	
    effect eAOE = EffectAreaOfEffect(AOE_PER_DARKNESS);
	effect eVis = EffectVisualEffect(VFX_BEAM_HOLY);
	effect eCold = EffectDamageResistance(DAMAGE_TYPE_COLD, 15, 2000);
	effect eColdAtk = EffectDamageIncrease(nBonus, DAMAGE_TYPE_COLD);
	effect eDodge = EffectACIncrease(3, AC_DODGE_BONUS);
	
	ApplyEffectAtLocation(DURATION_TYPE_INSTANT, eAOE, GetSpellTargetLocation());    

    object oTarget = GetFirstObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_HUGE, lTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);
    //Cycle through the targets within the spell shape until an invalid object is captured.
    while (GetIsObjectValid(oTarget))
    {
        if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
    	{
            if((GetSpellId() == 341) || GetSpellId() == 58)
            {
                //Fire cast spell at event for the specified target
                SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId()));
                //Get the distance between the explosion and the target to calculate delay
                fDelay = GetDistanceBetweenLocations(lTarget, GetLocation(oTarget))/20;
				
                // Apply effects to the currently selected target.
                DelayCommand(fDelay, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eCold, oTarget, IntToFloat(nCasterLvl)));
                DelayCommand(fDelay, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eColdAtk, oTarget, IntToFloat(nCasterLvl)));
                DelayCommand(fDelay, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eDodge, oTarget, IntToFloat(nCasterLvl)));
				
                //This visual effect is applied to the target object not the location as above.  This visual effect
                //represents the flame that erupts on the target not on the ground.
             	DelayCommand(fDelay, ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget));
             }
        }
		
       //Select the next target within the spell shape.
       oTarget = GetNextObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_HUGE, lTarget, TRUE, OBJECT_TYPE_CREATURE);
    }		
}