//::///////////////////////////////////////////////
//:: Sinsabur's Baleful Bolt
//:: mt_s0_balefulbolt
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Jan 19, 2007
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	//Declare major variables
	object oTarget = GetSpellTargetObject();
	int nCasterLvl = GetCasterLevel(OBJECT_SELF);

    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nCasterLvl = (nCasterLvl + 3);
    }	
    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nCasterLvl = (nCasterLvl + 2);
    }	
    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
			
	effect eVis;	
	effect eOrbEffect;
	int nSpellId = GetSpellId();
	
	eVis = EffectVisualEffect(VFX_HIT_SPELL_AVASCULATE);
		  
	if (GetIsObjectValid(oTarget))
	{
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
		{		
			effect eCon = EffectAbilityDecrease(ABILITY_CONSTITUTION, d3(1));
			effect eCha = EffectAbilityDecrease(ABILITY_STRENGTH, d3(1));
							
			//Fire cast spell at event for the specified target
			SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId()));				

			//Apply the effects
			ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
			ApplyEffectToObject(DURATION_TYPE_INSTANT, eCha, oTarget, RoundsToSeconds(nCasterLvl/4));
			ApplyEffectToObject(DURATION_TYPE_INSTANT, eCon, oTarget, RoundsToSeconds(nCasterLvl/4));
			
			int nDamage = 0;
			if (GetHasFeat(5212,OBJECT_SELF,TRUE)) // Diabolism
			{
				int nLevelDiabolist = GetLevelByClass(96, OBJECT_SELF);
				if(nLevelDiabolist == 10)
					nDamage = 3;
				else if(nLevelDiabolist == 5)
					nDamage = 2;
				else
					nDamage = 1;
								
	            effect eDam2 = EffectDamage(nDamage, DAMAGE_TYPE_NEGATIVE);
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam2, oTarget);
			}
	
			if (GetHasFeat(5213,OBJECT_SELF,TRUE)) // Vile Diabolism
			{
				nDamage = 1;
	            effect eDam3 = EffectDamage(nDamage, DAMAGE_TYPE_MAGICAL);
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam3, oTarget);
			}									
		}	
	}
}