//::///////////////////////////////////////////////
//:: Baleful Transposition
//:: mt_s0_balefultransposition
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Nov 4, 2015
//:://////////////////////////////////////////////

#include "NW_I0_SPELLS"
#include "x2_inc_spellhook"

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
// End of Spell Cast Hook

    //Declare major variables
    object oTarget = GetSpellTargetObject();
    object oCaster = OBJECT_SELF;
	int nDoSwap = 1;
	int nFactor = 1;

    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nFactor = (nFactor + 3);
    }	
    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nFactor = (nFactor + 2);
    }	
    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nFactor = (nFactor + 1);
    }	
		
    location lTarget = GetSpellTargetLocation();
    location lCasterLoc = GetLocation(oCaster);
    location lTargetLoc = GetLocation(oTarget);

	if (lTargetLoc != lTarget)
	{
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
		{
			if (MySavingThrow(SAVING_THROW_WILL, oTarget, GetSpellSaveDC()+nFactor, SAVING_THROW_TYPE_ALL))
				nDoSwap = 0;
		}
	
		if(nDoSwap == 1)
		{
			ApplyEffectAtLocation (DURATION_TYPE_INSTANT, EffectVisualEffect (VFX_FNF_SUMMON_MONSTER_3), lCasterLoc);
			ApplyEffectAtLocation (DURATION_TYPE_INSTANT, EffectVisualEffect (VFX_FNF_SUMMON_MONSTER_3), lTargetLoc);
			AssignCommand(oCaster, ActionJumpToLocation(lTargetLoc));
			AssignCommand(oTarget, ActionJumpToLocation(lCasterLoc));
		}
	}			
}