//::///////////////////////////////////////////////
//:: Bands of Steel
//:: mt_s0_bandsofsteel
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Nov 9, 2015
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	//Declare major variables
	object oTarget = GetSpellTargetObject();
	int nCasterLvl = GetCasterLevel(OBJECT_SELF);
	effect eVis;	
	effect eStun = EffectStunned();
	effect eEntangle = EffectEntangle();
	int nSpellId = GetSpellId();
	
	// For Force Specialization feat from Argent Savant.		
	int nSpecialization = 0; 	
	if (GetHasFeat(5218,OBJECT_SELF,TRUE))
		nSpecialization = 1;

	// Invisible Needle		
	if (GetHasFeat(3096,OBJECT_SELF,TRUE))
		nSpecialization += 1;

    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nSpecialization = (nSpecialization + 3);
    }	
    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nSpecialization = (nSpecialization + 2);
    }	
    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nSpecialization = (nSpecialization + 1);
    }	
					
	eVis = EffectVisualEffect(VFX_HIT_SPELL_SONIC);
		  
	if (GetIsObjectValid(oTarget))
	{		
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
		{		
			if (MySavingThrow(SAVING_THROW_REFLEX, oTarget, GetSpellSaveDC()+nSpecialization, SAVING_THROW_TYPE_ALL))
			{				
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
				ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eEntangle, oTarget, 12.0f);
			}
			else
			{
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
				ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eStun, oTarget, RoundsToSeconds(nCasterLvl));
			}
		}	
	}				
}