//::///////////////////////////////////////////////
//:: Beltyn's Burning Blood
//:: mt_s0_beltynblood
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Jan 1, 2007
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {
	    // If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
 		return;
    }

	//Declare major variables
	object oTarget = GetSpellTargetObject();
	int nCasterLvl = GetCasterLevel(OBJECT_SELF);
	
	if (nCasterLvl > 10)
		nCasterLvl = 10;

    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nCasterLvl = (nCasterLvl + 3);
    }	
    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nCasterLvl = (nCasterLvl + 2);
    }	
    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
					
    if (GetHasFeat(3092)) // Acidic Splatter
    {
        nCasterLvl = (nCasterLvl + 1);
    }
    if (GetHasFeat(5036)) // Fire Adept
    {
        nCasterLvl = (nCasterLvl + 1);
    }
    if (GetHasFeat(3094)) // Fiery Burst
    {
        nCasterLvl = (nCasterLvl + 1);
    }
    if (GetHasFeat(5264)) // Bloodline of Fire
    {
        nCasterLvl = (nCasterLvl + 2);
    }

	float nDuration = RoundsToSeconds(nCasterLvl);
	int nDamage = d8(1);	
		
	effect eVis;	
	effect eOrbEffect;
	int nDamageType;
	int nSpellId = GetSpellId();
	
    //Get the spell target location as opposed to the spell target.
    location lTarget = GetSpellTargetLocation();

	if (GetIsObjectValid(oTarget))
	{
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
		{				
			if(!MyResistSpell(OBJECT_SELF, oTarget))
			{							
				nDamageType	= DAMAGE_TYPE_FIRE;
				eVis = EffectVisualEffect(VFX_HIT_SPELL_FIRE);
				effect eDamage = EffectDamage(nDamage,nDamageType);
				
				//Fire cast spell at event for the specified target
				SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId()));				
	
				//Apply the effects
				ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eDamage, oTarget, nDuration);
				ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis, oTarget, nDuration);

				nDamageType	= DAMAGE_TYPE_ACID;
				eVis = EffectVisualEffect(VFX_HIT_SPELL_ACID);
				eDamage = EffectDamage(nDamage,nDamageType);
				
				//Fire cast spell at event for the specified target
				SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId()));				
	
				//Apply the effects
				ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eDamage, oTarget, nDuration);
								
				if (GetHasFeat(5212,OBJECT_SELF,TRUE)) // Diabolism
				{
					int nLevelDiabolist = GetLevelByClass(96, OBJECT_SELF);
					if(nLevelDiabolist == 10)
						nDamage = 3;
					else if(nLevelDiabolist == 5)
						nDamage = 2;
					else
						nDamage = 1;
											
	                effect eDam2 = EffectDamage(nDamage, DAMAGE_TYPE_NEGATIVE);
					ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam2, oTarget);
				}

				if (GetHasFeat(5213,OBJECT_SELF,TRUE)) // Vile Diabolism
				{
					nDamage = 1;
	                effect eDam3 = EffectDamage(nDamage, DAMAGE_TYPE_MAGICAL);
					ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam3, oTarget);
				}
			}
		}	
	}			
}