//::///////////////////////////////////////////////
//:: Bigby's Helpful Hand
//:: mt_s0_bigbyhelpfulhand
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Jan 24, 2008
//:://////////////////////////////////////////////

#include "x2_inc_spellhook"

void mainSpell();
void main()
{
	AssignCommand(JXGetCaster(), mainSpell());
}

void mainSpell()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        JXPostSpellCastCode();
        return;
    }

// End of Spell Cast Hook


    //Declare major variables
    object oTarget = JXGetSpellTargetObject();
    int nLevel = JXGetCasterLevel(oTarget);
    int nBonus = 2;

	effect eLore1 = EffectSkillIncrease(SKILL_CRAFT_ALCHEMY, nBonus);
    effect eLore2 = EffectSkillIncrease(SKILL_CRAFT_ARMOR, nBonus);
    effect eLore3 = EffectSkillIncrease(SKILL_CRAFT_TRAP, nBonus);
    effect eLore4 = EffectSkillIncrease(SKILL_CRAFT_WEAPON, nBonus);
    effect eLore5 = EffectSkillIncrease(SKILL_DISABLE_TRAP, nBonus);
    effect eLore6 = EffectSkillIncrease(SKILL_OPEN_LOCK, nBonus);
    effect eVis = EffectVisualEffect( VFX_DUR_SPELL_LEGEND_LORE );

    int nMetaMagic = JXGetMetaMagicFeat();
    //Meta-Magic checks
    if(nMetaMagic & METAMAGIC_PERSISTENT)
    {
        nLevel = 24;
    }
    else if(nMetaMagic & METAMAGIC_EXTEND)
    {
        nLevel = nLevel * 2;
    }
    //Make sure the spell has not already been applied
    if(!GetHasSpellEffect(SPELL_IDENTIFY, oTarget) || !GetHasSpellEffect(SPELL_LEGEND_LORE, oTarget))
    {
         SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, JXGetSpellId(), FALSE));

		 //Apply linked and VFX effects
         JXApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLore1, oTarget, HoursToSeconds(nLevel));
         JXApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLore2, oTarget, HoursToSeconds(nLevel));
         JXApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLore3, oTarget, HoursToSeconds(nLevel));
         JXApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLore4, oTarget, HoursToSeconds(nLevel));
         JXApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLore5, oTarget, HoursToSeconds(nLevel));
         JXApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLore6, oTarget, HoursToSeconds(nLevel));
         JXApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
    }
	
	JXPostSpellCastCode();
}