//::///////////////////////////////////////////////
//:: Bigby's Tripping Hand
//:: mt_s0_bigbystrippinghand
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Oct 25, 2015
//:://////////////////////////////////////////////

#include "NW_I0_SPELLS"
#include "x2_inc_spellhook"

void main()
{
/* 
  Spellcast Hook Code 
  Added 2003-06-20 by Georg
  If you want to make changes to all spells,
  check x2_inc_spellhook.nss to find out more
  
*/
    if (!X2PreSpellCastCode())
    {
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
// End of Spell Cast Hook

    object oTarget = GetSpellTargetObject();
    int nDuration = GetCasterLevel(OBJECT_SELF);
    int nMetaMagic = GetMetaMagicFeat();
	int nStr = 18;
	
    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nStr = (nStr + 3);
    }	
    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nStr = (nStr + 2);
    }	
    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nStr = (nStr + 1);
    }		

    if (GetHasFeat(5218)) // Force Specialization
    {
        nStr = (nStr + 1);
        nDuration = (nDuration + 1);
    }	
	
    if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
    {
        //Fire cast spell at event for the specified target
        SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF,
                                              SPELL_BIGBYS_INTERPOSING_HAND,
                                              TRUE));
        //Check for metamagic extend
        if (nMetaMagic == METAMAGIC_EXTEND)	//Duration is +100%
        {
             nDuration = nDuration * 2;
        }
        if (!MyResistSpell(OBJECT_SELF, oTarget))
        {

        	effect eAC1 = EffectKnockdown();
        	effect eVis = EffectVisualEffect(VFX_DUR_BIGBYS_INTERPOSING_HAND);
        	effect eLink = EffectLinkEffects(eAC1, eVis);

       		//Apply the TO HIT PENALTIES bonuses and the VFX impact
            if (d20() + GetAbilityScore(oTarget, ABILITY_STRENGTH) <= nStr + d20() )
			{
	        	ApplyEffectToObject( DURATION_TYPE_TEMPORARY, eLink, oTarget, RoundsToSeconds(nDuration) );
			}			
        }
    }	
}