//::///////////////////////////////////////////////
//:: Bigby's Warding Hand
//:: mt_s0_bigwrdhand
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Nov 12, 2015
//:://////////////////////////////////////////////
/*
Evocation [Force]
Level: Sorcerer / Wizard 2
Components: V, S
Casting Time: 1 standard action
Range: Medium (100 ft. + 10 ft./level)
Effect: One hand of force
Duration: 1 round/level (D)
Saving Throw: None
Spell Resistance: Yes

A spectral human hand springs into existence. You designate a target when casting this spell. It pushes into the target, forcing him back as he attempts to move.

You can change the spell's target by taking a move action to do so. This spell has no effect on Huge or larger creatures.

If the target of the spell attempts to move, it must make a Strength check (DC 12 + your key ability modifier). If this check fails, the creature moves at half speed.

The target must make a new check each round to overcome the hand's hindering force. 
*/

#include "nw_i0_spells"
#include "x2_inc_spellhook" 

void main()
{
/* 
  Spellcast Hook Code 
  Added 2003-06-20 by Georg
  If you want to make changes to all spells,
  check x2_inc_spellhook.nss to find out more
*/
    if (!X2PreSpellCastCode())
    {
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
// End of Spell Cast Hook


    //Declare major variables
    object oTarget = GetSpellTargetObject();
    int nDuration = GetCasterLevel(OBJECT_SELF);
    int nMetaMagic = GetMetaMagicFeat();
	int nSpeed = 50;

    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nSpeed = (nSpeed + 10);
    }	
    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nSpeed = (nSpeed + 6);
    }	
    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nSpeed = (nSpeed + 4);
    }		

    if (GetHasFeat(5218)) // Force Specialization
    {
        nSpeed = (nSpeed + 4);
    }	
	

    if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
    {
        //Fire cast spell at event for the specified target
        SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF,
                                              SPELL_BIGBYS_INTERPOSING_HAND,
                                              TRUE));
        //Check for metamagic extend
        if (nMetaMagic == METAMAGIC_EXTEND)	//Duration is +100%
        {
             nDuration = nDuration * 2;
        }
        if (!MyResistSpell(OBJECT_SELF, oTarget))
        {

        	effect eAC1 = EffectMovementSpeedDecrease(nSpeed);
        	effect eVis = EffectVisualEffect(VFX_DUR_BIGBYS_INTERPOSING_HAND);
        	effect eLink = EffectLinkEffects(eAC1, eVis);

       		//Apply the TO HIT PENALTIES bonuses and the VFX impact
        	ApplyEffectToObject( DURATION_TYPE_TEMPORARY, eLink, oTarget, RoundsToSeconds(nDuration) );
        }
    }
}