//::///////////////////////////////////////////////
//:: Binding Chain of Fate
//:: mt_s0_batteringram
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Jan 19, 2008
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	//Declare major variables
	object oTarget = GetSpellTargetObject();
	int nCasterLvl = GetCasterLevel(OBJECT_SELF);
	
    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nCasterLvl = (nCasterLvl + 3);
    }	
    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nCasterLvl = (nCasterLvl + 2);
    }	
    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
	
	effect eVis;	
	effect eOrbEffect;
	int nDamageType;
	int nSpellId = GetSpellId();
	int nDuration = nCasterLvl;
	
	// For Force Specialization feat from Argent Savant.		
	int nSpecialization = 0; 	
	if (GetHasFeat(5218,OBJECT_SELF,TRUE))
	{
		nSpecialization = 1;
		nDuration = (nDuration + 1);
	}

	// Invisible Needle		
	if (GetHasFeat(3096,OBJECT_SELF,TRUE))
	{
		nSpecialization += 1;
		nDuration = (nDuration + 1);
	}
	
	int nDamage = d6(2) + nSpecialization;			
	
	nDamageType	= DAMAGE_TYPE_MAGICAL;
	eVis = EffectVisualEffect(VFX_HIT_SPELL_SONIC);
	eOrbEffect = EffectKnockdown();
		  
	if (GetIsObjectValid(oTarget))
	{		
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
		{		
			if(!MyResistSpell(OBJECT_SELF, oTarget))
			{	
				// Do will saving throw to avoid the ill effects.
                if (MySavingThrow(SAVING_THROW_WILL, oTarget, GetSpellSaveDC() + nSpecialization, SAVING_THROW_TYPE_ALL))
				{
					effect eDamage = EffectDamage(nDamage,nDamageType);
					effect eNoMagic = EffectSpellFailure(100, SPELL_SCHOOL_GENERAL);
					effect eStun = EffectStunned();
					
					//Apply the effects
					ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);					
					ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eDamage, oTarget, RoundsToSeconds(nDuration));
					ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eNoMagic, oTarget, RoundsToSeconds(nDuration));
					ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eStun, oTarget, RoundsToSeconds(nDuration));
					
					if (GetHasFeat(5212,OBJECT_SELF,TRUE)) // Diabolism
					{
						int nLevelDiabolist = GetLevelByClass(96, OBJECT_SELF);
						if(nLevelDiabolist == 10)
							nDamage = 3;
						else if(nLevelDiabolist == 5)
							nDamage = 2;
						else
							nDamage = 1;
												
		                effect eDam2 = EffectDamage(nDamage, DAMAGE_TYPE_NEGATIVE);
						ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam2, oTarget);
					}

					if (GetHasFeat(5213,OBJECT_SELF,TRUE)) // Vile Diabolism
					{
						nDamage = 1;
		                effect eDam3 = EffectDamage(nDamage, DAMAGE_TYPE_MAGICAL);
						ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam3, oTarget);
					}					
				}						
			}
		}	
	}				
}