//::///////////////////////////////////////////////
//:: Blistering Radiance
//:: mt_s0_blisteringradiance
//:: Created By: Joshua Kalis
//:: Created On: Feb 23, 2008
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{
/* 
  Spellcast Hook Code 
  Added 2003-06-20 by Georg
  If you want to make changes to all spells,
  check x2_inc_spellhook.nss to find out more 
*/
    if (!X2PreSpellCastCode())
    {
	    // If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
		return;
    }
// End of Spell Cast Hook

    //Declare major variables
    object oCaster = OBJECT_SELF;
    int nCasterLvl = GetCasterLevel(oCaster);

    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nCasterLvl = (nCasterLvl + 3);
    }	
    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nCasterLvl = (nCasterLvl + 2);
    }	
    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
		
    if (GetHasFeat(5036)) // Fire Adept
    {
        nCasterLvl = (nCasterLvl + 1);
    }
    if (GetHasFeat(5264)) // Bloodline of Fire
    {
        nCasterLvl = (nCasterLvl + 2);
    }
    if (GetHasFeat(3034)) // Fiery Burst
    {
        nCasterLvl = (nCasterLvl + 1);
    }
	
    int nMetaMagic = GetMetaMagicFeat();
    int nDamage, nDamage2;
    int nVariable = nCasterLvl/3;
    float fDelay;
    effect eVis = EffectVisualEffect(VFX_HIT_SPELL_FIRE);
    effect eDam,eDam2, eSlow;
	
    //Get the spell target location as opposed to the spell target.
    location lTarget = GetSpellTargetLocation();
	
    //Declare the spell shape, size and the location.  Capture the first target object in the shape.
    object oTarget = GetFirstObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_HUGE, lTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);
	
    //Cycle through the targets within the spell shape until an invalid object is captured.
    while (GetIsObjectValid(oTarget))
    {
        if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
    	{
            //fDelay = GetRandomDelay(0.75, 2.25);
            //Fire cast spell at event for the specified target
            SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, SPELL_ICE_STORM));
			
            if (!MyResistSpell(OBJECT_SELF, oTarget, fDelay))
    	    {
                nDamage = d6(2);
                //Resolve metamagic
        	    if (nMetaMagic & METAMAGIC_MAXIMIZE)
                {
                    nDamage = 12;
                }
    	        else if (nMetaMagic & METAMAGIC_EMPOWER)
                {
                   nDamage = nDamage + (nDamage / 2);
                }

				//Set the damage effect
                eDam = EffectDamage(nDamage, DAMAGE_TYPE_FIRE);
				eSlow = EffectDazed();
				
				// Apply effects to the currently selected target.
                ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam, oTarget, RoundsToSeconds(nCasterLvl));

				//This visual effect is applied to the target object not the location as above.  This visual effect
                //represents the impact that erupts on the target not on the ground.
                ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
				
                ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eSlow, oTarget, RoundsToSeconds(nCasterLvl));					
				
				if (GetHasFeat(5212,OBJECT_SELF,TRUE)) // Diabolism
				{
					int nLevelDiabolist = GetLevelByClass(96, OBJECT_SELF);
					if(nLevelDiabolist == 10)
						nDamage = 3;
					else if(nLevelDiabolist == 5)
						nDamage = 2;
					else
						nDamage = 1;
											
	                effect eDam2 = EffectDamage(nDamage, DAMAGE_TYPE_NEGATIVE);
					ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam2, oTarget);
				}

				if (GetHasFeat(5213,OBJECT_SELF,TRUE)) // Vile Diabolism
				{
					nDamage = 1;
	                effect eDam3 = EffectDamage(nDamage, DAMAGE_TYPE_MAGICAL);
					ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam3, oTarget);
				}									
             }
        }
       //Select the next target within the spell shape.
       oTarget = GetNextObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_HUGE, lTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);
    }
}