//::///////////////////////////////////////////////
//:: Bolster
//:: mt_s0_bolster
//:: Purpose: Bolster
//:: Created By: Joshua Kalis (Greg)
//:: Created On: September 20, 2015
//:: Description: HP bonus
//:: Fundamental Mystery
//::
//:: You give the target a HP bonus.
//:://////////////////////////////////////////////

#include "x2_inc_spellhook"

void main()
{
   // If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run
    // this spell.
    if (!X2PreSpellCastCode())
    {
        return;
    }

    //Declare major variables
    object oTarget = GetSpellTargetObject();

	int nLevelShadowcaster = GetLevelByClass(99, OBJECT_SELF);
	int nLevelMasterOfShadow = GetLevelByClass(100, OBJECT_SELF);
	int nLevelNoctumancer = GetLevelByClass(101, OBJECT_SELF);
	int nLevelShadowTheurge = GetLevelByClass(103, OBJECT_SELF);
	int nCasterLvl = nLevelShadowcaster + nLevelMasterOfShadow + nLevelNoctumancer + nLevelShadowTheurge;
	int nBonus = 1;
    int nDuration = 1;
	
    if (GetHasFeat(5198)) // If have mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    if (GetHasFeat(5199)) // If have greater mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
	
	if(nCasterLvl < 7)
		nBonus = 10;
	else if(nCasterLvl < 13)
		nBonus = 25;
	else if(nCasterLvl < 19)
		nBonus = 50;
	else
		nBonus = 75;
	
    if (GetHasFeat(5194)) // If have extend mystery, double it.
    {
        nCasterLvl = (nCasterLvl * 2);
    }	
	
    nDuration = nCasterLvl;	
	
    float fDuration = HoursToSeconds(nDuration);

    //Fire cast spell at event for the specified target
    SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, SPELL_MAGE_ARMOR, FALSE));

    //Set the armor bonuses
    effect eAC = EffectBonusHitpoints(nBonus);
    effect eDur = EffectVisualEffect(VFX_DUR_SPELL_MAGE_ARMOR);
    effect eLink = EffectLinkEffects(eAC, eDur);

    //Apply the armor bonuses and the VFX impact
    ApplyEffectToObject(2, eLink, oTarget, fDuration);
}