//::///////////////////////////////////////////////
//:: Chain Missle
//:: mt_s0_chainmissle
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Oct 17, 2015
//:://////////////////////////////////////////////
//:: Purpose: 

// JLR - OEI 08/23/05 -- Metamagic changes
#include "nwn2_inc_spells"
#include "NW_I0_SPELLS"    
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
// End of Spell Cast Hook

    //Declare major variables
    object oTarget = GetSpellTargetObject();
    int nCasterLvl = GetCasterLevel(OBJECT_SELF);
	

    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nCasterLvl = (nCasterLvl + 3);
    }	
    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nCasterLvl = (nCasterLvl + 2);
    }	
    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
	
    if (GetHasFeat(3092)) // If have acidic splatter, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
	
    int nMissiles = (nCasterLvl + 1)/2;
    effect eVis = EffectVisualEffect(VFX_IMP_MAGBLUE);
    float fDelay, fTime, fTime2;
	int nSpell = GetSpellId();
	int nPathType = PROJECTILE_PATH_TYPE_DEFAULT;
	location lSourceLoc = GetLocation( OBJECT_SELF );
	location lTarget = GetLocation( oTarget );
    int nCnt;
	float fTravelTime;
	
	// For Force Specialization feat from Argent Savant.		
	int nSpecialization = 1; 	
	if (GetHasFeat(5218,OBJECT_SELF,TRUE))
		nSpecialization = 2;	

	// Invisible Needle		
	if (GetHasFeat(3096,OBJECT_SELF,TRUE))
		nSpecialization += 1;
			
    if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
    {
        //Fire cast spell at event for the specified target
        SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, SPELL_MAGIC_MISSILE));
        
		//Limit missiles to ten
        if (nMissiles > 10)
        {
            nMissiles = 10;			
        }

		// Bonus Missile		
		int nLevelForceMissileMage = GetLevelByClass(104, OBJECT_SELF);
		if (GetHasFeat(5226,OBJECT_SELF,TRUE))
		{
			if(nLevelForceMissileMage == 5)
				nMissiles = nMissiles + 2;
			else
				nMissiles = nMissiles + 1;
		}		

		//Apply a single damage hit for each missile instead of as a single mass
		for (nCnt = 1; nCnt <= nMissiles; nCnt++)
		{
			fTravelTime = GetProjectileTravelTime( lSourceLoc, lTarget, nPathType );
			if ( nCnt == 0 )	
				fDelay = 0.0f;
			else
				fDelay = GetRandomDelay( 0.1f, 0.5f ) + (0.5f * IntToFloat(nCnt));
			
			/*
			fTime = fDelay + ((nCnt - 1) * 0.25);
			fTime2 = ((nCnt - 1) * 0.25);
			*/			        
			
			//Make SR Check
	        if (!MyResistSpell(OBJECT_SELF, oTarget, fDelay))
		  	{
                //Roll damage
                int nDam = d4(1) + nSpecialization;

				//Enter Metamagic conditions
                nDam = ApplyMetamagicVariableMods(nDam, 15);

                //Set damage effect
                effect eDam = EffectDamage(nDam, DAMAGE_TYPE_MAGICAL);
				
                //Apply the MIRV and damage effect
                DelayCommand(fDelay + fTravelTime, ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam, oTarget));
                DelayCommand(fDelay + fTravelTime, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis, oTarget));
				
			    //Get the spell target location as opposed to the spell target.
			    location lTarget = GetSpellTargetLocation();
				
			    //Declare the spell shape, size and the location.  Capture the first target object in the shape.
			    object aTarget = GetFirstObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_HUGE, lTarget, TRUE, OBJECT_TYPE_CREATURE);
				
			    //Cycle through the targets within the spell shape until an invalid object is captured.
				int nSecondaryTargets = 0;
			    while (GetIsObjectValid(aTarget))
				{
					if (spellsIsTarget(aTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
					{		
						if(nSecondaryTargets <= nMissiles) 
						{
							ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
							ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam, oTarget);
							nSecondaryTargets += 1;
						}
					}
				
			       //Select the next target within the spell shape.
			       aTarget = GetNextObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_HUGE, lTarget, TRUE, OBJECT_TYPE_CREATURE);
				}				
			}
			DelayCommand( fDelay, SpawnSpellProjectile(OBJECT_SELF, oTarget, lSourceLoc, lTarget, nSpell, nPathType) );
       	}
	}	
}