//::///////////////////////////////////////////////
//:: Choke
//:: mt_s0_choke
//:: Purpose: Choke enemies
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Nov 4, 2015
//:: Description: 1d4
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{

    if (!X2PreSpellCastCode())
    {
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	//Declare major variables
	object oTarget = GetSpellTargetObject();
	int nCasterLvl = GetCasterLevel(OBJECT_SELF);
	int nSpecialization = 0; 	
	
	if (nCasterLvl > 15)
		nCasterLvl = 15;

    if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
        nSpecialization = (nSpecialization + 1);
    }	
    if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nCasterLvl = (nCasterLvl + 2);
        nSpecialization = (nSpecialization + 2);
    }	
    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nCasterLvl = (nCasterLvl + 3);
        nSpecialization = (nSpecialization + 3);
    }	

	// For Force Specialization feat from Argent Savant.		
	if (GetHasFeat(5218,OBJECT_SELF,TRUE))
		nSpecialization += 1;

	// Invisible Needle		
	if (GetHasFeat(3096,OBJECT_SELF,TRUE))
		nSpecialization += 1;
					
	int nDamage = d4(1) + nSpecialization;	
		
	effect eVis;	
	effect eOrbEffect;
	int nDamageType;
	int nSpellId = GetSpellId();
	
	nDamageType	= DAMAGE_TYPE_BLUDGEONING;
	eVis = EffectVisualEffect(VFX_HIT_SPELL_ACID);
	eOrbEffect = EffectSpellFailure(10, SPELL_SCHOOL_GENERAL);
	effect eAttack = EffectAttackDecrease(2, ATTACK_BONUS_MISC);
			  
	if (GetIsObjectValid(oTarget))
	{
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
		{		
		
			if(!MyResistSpell(OBJECT_SELF, oTarget))
			{							
				int nMax = (nCasterLvl*8)+2;
				nDamage = ApplyMetamagicVariableMods( nDamage, nMax );					
				effect eDamage = EffectDamage(nDamage,nDamageType);
				
				//Apply the effects
				
                if(MySavingThrow(SAVING_THROW_REFLEX, oTarget, GetSpellSaveDC() + nSpecialization, SAVING_THROW_TYPE_ALL))
				{
					nDamage = d2(1) + nSpecialization;
				}
				
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
				ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eDamage, oTarget, RoundsToSeconds(nCasterLvl));
				ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eOrbEffect, oTarget, RoundsToSeconds(nCasterLvl));				
				ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eAttack, oTarget, RoundsToSeconds(nCasterLvl));				
			}
		}	
	}			



}