//::///////////////////////////////////////////////
//:: Claws of the Beast
//:: mt_s0_clawsofthebeast
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Oct 26, 2015
//:://////////////////////////////////////////////

#include "nw_i0_spells"
#include "x2_inc_spellhook"

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
    // End of Spell Cast Hook

    object oTarget = GetSpellTargetObject();

    //Declare major variables
    int nCasterLevel = GetCasterLevel(OBJECT_SELF);
    int nMetaMagic = GetMetaMagicFeat(); 
    effect eStone = EffectDamageIncrease(DAMAGE_BONUS_1d8, DAMAGE_TYPE_SLASHING, -1);
    effect eVis = EffectVisualEffect(VFX_DUR_SPELL_PREMONITION);
	eStone = EffectLinkEffects(eStone, eVis);
	float fSpellDuration = RoundsToSeconds(nCasterLevel);	
	
    //Enter Metamagic conditions
    //Fire cast spell at event for the specified target
    SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId(), FALSE));
    if (nMetaMagic & METAMAGIC_EXTEND)
    {
        fSpellDuration = fSpellDuration * 2; //Duration is +100%
    }

	
    RemoveEffectsFromSpell(oTarget, GetSpellId());
    //Apply the linked effect
    ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eStone, oTarget, fSpellDuration);
	
	// Give the feat, take it away after duration.
	FeatAdd(OBJECT_SELF, 21, FALSE, FALSE, FALSE);
	DelayCommand(fSpellDuration, FeatRemove(OBJECT_SELF, 21));
	
}