//::///////////////////////////////////////////////
//:: Elemental Shield, Cold
//:: mt_s0_coldshield
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Jan 10, 2007
//:://////////////////////////////////////////////

#include "x2_inc_spellhook"
#include "x0_i0_spells"

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
// End of Spell Cast Hook

    //Declare major variables
    effect eDur = EffectVisualEffect(VFX_DUR_ELEMENTAL_SHIELD);
    int nCasterLvl = GetCasterLevel(OBJECT_SELF);


    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nCasterLvl = (nCasterLvl + 3);
    }	
    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nCasterLvl = (nCasterLvl + 2);
    }	
    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
	
    if (GetHasFeat(3101)) // If have winters blast, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
		
	int nDuration = nCasterLvl;
	
    int nMetaMagic = GetMetaMagicFeat();
    object oTarget = OBJECT_SELF;
	
	//PKM OEI 09.29.06 - The following check is to make sure this spell maximizes properly
	effect eShield;
	
	int nDmgType = DAMAGE_TYPE_COLD;	
	
	if (nMetaMagic & METAMAGIC_MAXIMIZE)
	{
		eShield = EffectDamageShield(nDuration, DAMAGE_BONUS_6, nDmgType);
	}
	else if (nMetaMagic & METAMAGIC_EMPOWER)
	{
		eShield = EffectDamageShield(nDuration, DAMAGE_BONUS_1d8, nDmgType);
	}
	else
	{
		eShield = EffectDamageShield(nDuration, DAMAGE_BONUS_1d6, nDmgType);
	}
	
    effect eCold = EffectDamageImmunityIncrease(DAMAGE_TYPE_COLD, 50);
    effect eFire = EffectDamageImmunityIncrease(DAMAGE_TYPE_FIRE, 50);

    //Link effects
    effect eLink = EffectLinkEffects(eShield, eCold);
    eLink = EffectLinkEffects(eLink, eFire);
    eLink = EffectLinkEffects(eLink, eDur);

    //Fire cast spell at event for the specified target
    SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, SPELL_ELEMENTAL_SHIELD, FALSE));

    //  *GZ: No longer stack this spell
    if (GetHasSpellEffect(GetSpellId(),oTarget))
    {
         RemoveSpellEffects(GetSpellId(), OBJECT_SELF, oTarget);
    }

    //Enter Metamagic conditions
    if (nMetaMagic & METAMAGIC_EXTEND)
    {
        nDuration = nDuration *2; //Duration is +100%
    }
    //Apply the VFX impact and effects
    ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLink, oTarget, RoundsToSeconds(nDuration));
}