//::///////////////////////////////////////////////
//:: Consume Essence
//:: mt_s0_consumeessence
//:: Purpose: Save or die (will)
//:: Created By: Joshua Kalis (Greg)
//:: Created On: October 23, 2015
//:: Description: Target makes a will save or dies
//:: Fundamental Mystery
//::
//:: Target makes a will save or dies, if they die have them become a shadow in your control.
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	//Declare major variables
	object oTarget = GetSpellTargetObject();
	object oCaster = OBJECT_SELF;
	int nLevelShadowcaster = GetLevelByClass(99, OBJECT_SELF);
	int nLevelMasterOfShadow = GetLevelByClass(100, OBJECT_SELF);
	int nLevelNoctumancer = GetLevelByClass(101, OBJECT_SELF);
	int nLevelShadowTheurge = GetLevelByClass(103, OBJECT_SELF);
	int nCasterLvl = nLevelShadowcaster + nLevelMasterOfShadow + nLevelNoctumancer + nLevelShadowTheurge;	

	int nCasterPwr = 8;
    if (GetHasFeat(5198)) // If have mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
        nCasterPwr = (nCasterPwr + 1);
    }	
    if (GetHasFeat(5199)) // If have greater mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
        nCasterPwr = (nCasterPwr + 1);
    }	
			
    if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, oCaster))
    {		
        //Fire cast spell at event for the specified target
        SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId()));
 			
       	if(!MySavingThrow(SAVING_THROW_WILL, oTarget, GetSpellSaveDC() + nCasterPwr))
		{	
			effect eVis = EffectVisualEffect(VFX_COM_CHUNK_RED_LARGE);
			ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget, 0.5f);
			DestroyObject(oTarget, 0.75f);
			
			effect eSummon = EffectSummonCreature("shadowelemental", VFX_FNF_SUMMON_EPIC_UNDEAD, 0.2f);
		    ApplyEffectAtLocation(DURATION_TYPE_TEMPORARY, eSummon, GetSpellTargetLocation(), RoundsToSeconds(nCasterLvl));
		}
	}			  
}