//::///////////////////////////////////////////////
//:: Crushing Sphere
//:: mt_s0_crushingsphere
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Feb 23, 2007
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	//Declare major variables
	object oTarget = GetSpellTargetObject();
	int nSpellId = GetSpellId();
	int nCasterLvl = GetCasterLevel(OBJECT_SELF);
	
	if (nCasterLvl > 18)
		nCasterLvl = 18;

    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nCasterLvl = (nCasterLvl + 3);
    }	
    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nCasterLvl = (nCasterLvl + 2);
    }	
    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
			
	// For Force Specialization feat from Argent Savant.		
	int nSpecialization = 0; 	
	if (GetHasFeat(5218,OBJECT_SELF,TRUE))
		nSpecialization = 1;

	// Invisible Needle		
	if (GetHasFeat(3096,OBJECT_SELF,TRUE))
		nSpecialization += 1;
				
	int nDamage = d6(nCasterLvl) + (nSpecialization * nCasterLvl);	
		
	effect eVis;	
	effect eOrbEffect;
	int nDamageType;
	
    //Get the spell target location as opposed to the spell target.
    location lTarget = GetSpellTargetLocation();

	// Calculate the damage type.
	nDamageType	= DAMAGE_TYPE_BLUDGEONING;
	eVis = EffectVisualEffect(VFX_HIT_SPELL_TRANSMUTATION);
		  
	int nMax = (nCasterLvl*6)+2;
	nDamage = ApplyMetamagicVariableMods( nDamage, nMax );					
	effect eDamage = EffectDamage(nDamage,nDamageType);
		
    //Declare the spell shape, size and the location.  Capture the first target object in the shape.
    oTarget = GetFirstObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_MEDIUM, lTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);

	//Cycle through the targets within the spell shape until an invalid object is captured.
    while (GetIsObjectValid(oTarget))
    {
		if(!MyResistSpell(OBJECT_SELF, oTarget))
		{							
			//Fire cast spell at event for the specified target
			SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, nSpellId));				

			//Apply the effects
			ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
			ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);
		}					
		
		//Select the next target within the spell shape.
    	oTarget = GetNextObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_SMALL, lTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);
    }
}