//::///////////////////////////////////////////////
//:: Curtain of Shadow
//:: mt_s0_curtainshadow
//:: Purpose: Curtain of Shadow
//:: Created By: Joshua Kalis (Greg)
//:: Created On: September 23, 2015
//:: Description: Darkness + cold damage
//:: Initiate Mystery
//:: Creates standard darkness + cold
//::
//:: You create an area of darkness that causes cold damage.
//:://////////////////////////////////////////////

#include "x2_inc_spellhook"
#include "X0_I0_SPELLS"

void main()
{
   // If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run
    // this spell.
    if (!X2PreSpellCastCode())
    {
        return;
    }

	float fDelay;
	int nLevelShadowcaster = GetLevelByClass(99, OBJECT_SELF);
	int nLevelMasterOfShadow = GetLevelByClass(100, OBJECT_SELF);
	int nLevelNoctumancer = GetLevelByClass(101, OBJECT_SELF);
	int nLevelShadowTheurge = GetLevelByClass(103, OBJECT_SELF);
	int nCasterLvl = nLevelShadowcaster + nLevelMasterOfShadow + nLevelNoctumancer + nLevelShadowTheurge;
	int nDamage;
	
	if(nCasterLvl > 15)
		nCasterLvl = 15;
	
    if (GetHasFeat(5198)) // If have mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    if (GetHasFeat(5199)) // If have greater mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    int nDuration = nCasterLvl;	
    if (GetHasFeat(5194)) // If have extend mystery, double it.
    {
        nDuration = (nDuration * 2);
    }	
		
    //Declare major variables including Area of Effect Object
    effect eAOE = EffectAreaOfEffect(AOE_PER_DARKNESS);
			
    //Get the spell target location as opposed to the spell target.
    location lTarget = GetSpellTargetLocation();

    //Declare the spell shape, size and the location.  Capture the first target object in the shape.
    object oTarget = GetFirstObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_HUGE, lTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);

	if (GetIsObjectValid(oTarget))
		SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, SPELL_DARKNESS));
	
	//Create an instance of the AOE Object using the Apply Effect function
    ApplyEffectAtLocation(DURATION_TYPE_TEMPORARY, eAOE, lTarget, RoundsToSeconds(nDuration));	

    //Apply the fireball explosion at the location captured above.
    /* Brock H. - OEI 03/03/06 -- Handled by the ImpactSEF column in the spells.2da
    ApplyEffectAtLocation(DURATION_TYPE_INSTANT, eExplode, lTarget);*/

	effect eDam;
    effect eVis = EffectVisualEffect(VFX_HIT_SPELL_ICE);
		
    //Cycle through the targets within the spell shape until an invalid object is captured.
    while (GetIsObjectValid(oTarget))
    {
        if(spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
    	{
                //Fire cast spell at event for the specified target
                SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, SPELL_FIREBALL));
                //Get the distance between the explosion and the target to calculate delay
                fDelay = GetDistanceBetweenLocations(lTarget, GetLocation(oTarget))/20;
                if (!MyResistSpell(OBJECT_SELF, oTarget, fDelay))
        	    {
                    //Roll damage for each target
                    nDamage = d6(nCasterLvl);
					
					if (GetHasFeat(5197)) // maximize mystery
					{
						nDamage = 6 * nCasterLvl;
					}	
				
					if (GetHasFeat(5196)) // empower mystery
					{
						nDamage = nDamage * 2;
					}	
										
                    //Set the damage effect
                    eDam = EffectDamage(nDamage, DAMAGE_TYPE_COLD);
					
                    if(nDamage > 0)
                    {
                        // Apply effects to the currently selected target.
                        DelayCommand(fDelay, ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam, oTarget));
                        //This visual effect is applied to the target object not the location as above.  This visual effect
                        //represents the flame that erupts on the target not on the ground.
                        DelayCommand(fDelay, ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget));
                }
             }
        }
       //Select the next target within the spell shape.
       oTarget = GetNextObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_HUGE, lTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);
    }		
}