//::///////////////////////////////////////////////
//:: Damning Darkness
//:: mt_s0_damningdarkness
//:: Purpose: Spell - Damning Darkness
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Dec 29, 2007
//:: Description: 
//:: Evocation, Wiz/Sor 4 Cleric 4
//:: As darkness but with 2D8 negative energy damage per round.
//::
//:: This spell is similar to darkness but does 2D8 negative energy per round.
//:://////////////////////////////////////////////

#include "NW_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
// End of Spell Cast Hook

    //Declare major variables including Area of Effect Object
    effect eAOE = EffectAreaOfEffect(AOE_PER_DARKNESS);
    object oTarget = GetSpellTargetObject();

	// This is an evil spell. Casting it moves you one spot more towards evil.	
	AdjustAlignment(OBJECT_SELF, ALIGNMENT_EVIL, 1);
	
	if (GetIsObjectValid(oTarget))
		SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, SPELL_DARKNESS));
	
    location lTarget = GetSpellTargetLocation();
    int nCasterLvl = GetCasterLevel(OBJECT_SELF);

    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nCasterLvl = (nCasterLvl + 3);
    }	
    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nCasterLvl = (nCasterLvl + 2);
    }	
    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
		
	int nDuration = nCasterLvl;
		
	int nMetaMagic = GetMetaMagicFeat();
	
    //Make sure duration does no equal 0
    if (nDuration < 1)
    {
        nDuration = 1;
    }
	
    //Check Extend metamagic feat.
    if (nMetaMagic & METAMAGIC_EXTEND)
    {
	   nDuration = nDuration *2;	//Duration is +100%
    }
    //Create an instance of the AOE Object using the Apply Effect function
    ApplyEffectAtLocation(DURATION_TYPE_TEMPORARY, eAOE, lTarget, RoundsToSeconds(nDuration));

	// Now apply the special damage.	
	//Declare major variables	
	nCasterLvl = 2;
	int nDamage = d8(nCasterLvl);	
		
	effect eVis;	
	effect eOrbEffect;
	int nDamageType;
	int nSpellId = GetSpellId();
	
	// Calculate the damage type.
	nDamageType	= DAMAGE_TYPE_NEGATIVE;
	eVis = EffectVisualEffect(VFX_HIT_SPELL_FINGER_OF_DEATH);

	int nMax = (nCasterLvl*8)+2;
	//nDamage = ApplyMetamagicVariableMods( nDamage, nMax );					
	effect eDamage = EffectDamage(nDamage,nDamageType);
				
	//Declare the spell shape, size and the location.  Capture the first target object in the shape.
	oTarget = GetFirstObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_HUGE, lTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);

	//Cycle through the targets within the spell shape until an invalid object is captured.
	while (GetIsObjectValid(oTarget))
	{
		//Fire cast spell at event for the specified target
		SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId()));				

		//Apply the effects
		ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
		ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);

		//Select the next target within the spell shape.
		oTarget = GetNextObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_HUGE, lTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);
	}
}