//::///////////////////////////////////////////////
//:: Dancing Shadows
//:: mt_s0_dancingshadows
//:: Purpose: Dancing Shadows
//:: Created By: Joshua Kalis (Greg)
//:: Created On: September 19, 2015
//:: Description: Displacement
//:: Mystery
//::
//:: Gain Displacement.
//:://////////////////////////////////////////////

#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
// End of Spell Cast Hook


    //Declare major variables
    object oTarget = GetSpellTargetObject();

	int nLevelShadowcaster = GetLevelByClass(99, OBJECT_SELF);
	int nLevelMasterOfShadow = GetLevelByClass(100, OBJECT_SELF);
	int nLevelNoctumancer = GetLevelByClass(101, OBJECT_SELF);
	int nLevelShadowTheurge = GetLevelByClass(103, OBJECT_SELF);
	int nCasterLvl = nLevelShadowcaster + nLevelMasterOfShadow + nLevelNoctumancer + nLevelShadowTheurge;
	
    if (GetHasFeat(5198)) // If have mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    if (GetHasFeat(5199)) // If have greater mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
	int nProtection = 50 + nCasterLvl;
		
    if (GetHasFeat(5194)) // If have extend mystery, double it.
    {
        nCasterLvl = (nCasterLvl * 2);
    }		
	
    effect eDisplace = EffectConcealment(nProtection);
    effect eVis = EffectVisualEffect( VFX_DUR_ETHEREAL_VISAGE );
    effect eLink = EffectLinkEffects(eDisplace, eVis);
    effect eVis2 = EffectVisualEffect( VFX_DUR_DARKNESS );
    effect eLink2 = EffectLinkEffects(eLink, eVis2);

    //Fire cast spell at event for the specified target
    SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, SPELL_DISPLACEMENT, FALSE));

    //Apply the VFX impact and effects
    ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLink, oTarget, RoundsToSeconds(nCasterLvl));
}