//::///////////////////////////////////////////////
//:: Darkbolt
//:: mt_s0_darkbolt
//:: Purpose: Spell - Darkbolt
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Dec 29, 2007
//:: Description: 
//:: Evocation, Wiz/Sor 2 Cleric 2
//:: 1D4 Cold and 1D4 Divine to target, maximum 5D8.
//::
//:: You cause a bolt of cold darkness to fly at 
//:: the target, causing it to take 1D8 cold and negative per 
//:: every other caster level and possibly be stunned.
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 
#include "cmi_inc_sneakattack"

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	//Declare major variables
	object oCaster = OBJECT_SELF;
	object oTarget = GetSpellTargetObject();
	int nCasterLvl = GetCasterLevel(oCaster);
	
	nCasterLvl = nCasterLvl / 2;
	
	if (nCasterLvl > 5)
		nCasterLvl = 5;

    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nCasterLvl = (nCasterLvl + 3);
    }	
    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nCasterLvl = (nCasterLvl + 2);
    }	
    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
	
    if (GetHasFeat(3101)) // If have winters blast, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
				
	int nDamage = d4(nCasterLvl);	
		
	effect eVis;	
	effect eOrbEffect;
	int nDamageType;
	int nSpellId = GetSpellId();
	
	eVis = EffectVisualEffect(VFX_HIT_SPELL_AVASCULATE);
	eOrbEffect = EffectStunned();
		  
	if (GetIsObjectValid(oTarget))
	{
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, oCaster))
		{		
		
			int nRangedTouch = TouchAttackRanged(oTarget);
			if (nRangedTouch != TOUCH_ATTACK_RESULT_MISS)
			{
				// First do cold damge.				
				nDamageType	= DAMAGE_TYPE_COLD;
				if (GetHasFeat(FEAT_FROSTMAGE_PIERCING_COLD))
				{
					nDamageType = DAMAGE_TYPE_MAGICAL;
				}	
				if (GetHasFeat(2992,oCaster,TRUE))
					nDamage += 2;
					
				int nMax = (nCasterLvl*8)+2;
				nDamage = ApplyMetamagicVariableMods( nDamage, nMax );
				if (nRangedTouch == TOUCH_ATTACK_RESULT_CRITICAL)
					nDamage = nDamage * 2;
				if (StringToInt(Get2DAString("cmi_options","Value",CMI_OPTIONS_SneakAttackSpells)))
				{	nDamage += EvaluateSneakAttack(oTarget, OBJECT_SELF);	}
										
				effect eDamage = EffectDamage(nDamage,nDamageType);
				
				//Fire cast spell at event for the specified target
				SignalEvent(oTarget, EventSpellCastAt(oCaster, GetSpellId()));				

				//Apply the effects
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);
				
				// Then do divine or unholy damage.
				nDamageType	= DAMAGE_TYPE_NEGATIVE;
				
				if (GetHasFeat(2992,oCaster,TRUE))
					nDamage += 2;
					
				nDamage = ApplyMetamagicVariableMods( nDamage, nMax );
				if (nRangedTouch == TOUCH_ATTACK_RESULT_CRITICAL)
					nDamage = nDamage * 2;
					
				if ( IsTargetValidForSneakAttack(oTarget, oCaster) == TRUE )
				{
					int nSneak = GetTotalSneakDice(oTarget, oCaster);
					nDamage = nDamage + d6(nSneak);
				}
										
				eDamage = EffectDamage(nDamage,nDamageType);
				
				//Fire cast spell at event for the specified target
				SignalEvent(oTarget, EventSpellCastAt(oCaster, GetSpellId()));				

				//Apply the damage, not the visible effect.
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);

				if (GetHasFeat(5212,OBJECT_SELF,TRUE)) // Diabolism
				{
					int nLevelDiabolist = GetLevelByClass(96, OBJECT_SELF);
					if(nLevelDiabolist == 10)
						nDamage = 3;
					else if(nLevelDiabolist == 5)
						nDamage = 2;
					else
						nDamage = 1;
											
	                effect eDam2 = EffectDamage(nDamage, DAMAGE_TYPE_NEGATIVE);
					ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam2, oTarget);
				}

				if (GetHasFeat(5213,OBJECT_SELF,TRUE)) // Vile Diabolism
				{
					nDamage = 1;
	                effect eDam3 = EffectDamage(nDamage, DAMAGE_TYPE_MAGICAL);
					ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam3, oTarget);
				}					
								
				// Now do possible stun effect.				
				if  (!MySavingThrow(SAVING_THROW_FORT, oTarget, GetSpellSaveDC(), SAVING_THROW_TYPE_ELECTRICITY))
					ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eOrbEffect, oTarget, 6.0f);				
			}
		}	
	}			
}