//::///////////////////////////////////////////////
//:: Dark Soul
//:: mt_s0_darksoul
//:: Purpose: Dark Soul
//:: Created By: Joshua Kalis (Greg)
//:: Created On: October 18, 2015
//:: Description: Cause target to attack
//:: Mystery
//::
//:: Force an attack with weaknening
//:://////////////////////////////////////////////

#include "nwn2_inc_spells"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {
		// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
// End of Spell Cast Hook


    //Declare major variables
    object oTarget = GetSpellTargetObject();
	
    float fDuration = TurnsToSeconds(GetCasterLevel(OBJECT_SELF));
	int nLevelShadowcaster = GetLevelByClass(99, OBJECT_SELF);
	int nLevelMasterOfShadow = GetLevelByClass(100, OBJECT_SELF);
	int nLevelNoctumancer = GetLevelByClass(101, OBJECT_SELF);
	int nLevelShadowTheurge = GetLevelByClass(103, OBJECT_SELF);
	int nCasterLvl = nLevelShadowcaster + nLevelMasterOfShadow + nLevelNoctumancer + nLevelShadowTheurge;
	
    if (GetHasFeat(5198)) // If have mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    if (GetHasFeat(5199)) // If have greater mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    int nBonus = 12 + nCasterLvl;
		
    if (GetHasFeat(5194)) // If have extend mystery, double it.
    {
        nCasterLvl = (nCasterLvl * 2);
    }		
	fDuration = TurnsToSeconds(nCasterLvl);
	
	//Declare major variables
	int nDamageLimit = nCasterLvl * 10;
    effect eStone = EffectAttackDecrease(10, ATTACK_BONUS_MISC);
    effect eVis = EffectVisualEffect(VFX_DUR_SPELL_PREMONITION);
	eStone = EffectLinkEffects(eStone, eVis);
	ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eStone, oTarget, fDuration);		
	SetIsTemporaryEnemy(oTarget, OBJECT_SELF, FALSE, fDuration);
	
    //Set Adjust Ability Score effect
    int nRaise = -4;
    effect eRaise;
    eVis = EffectVisualEffect(VFX_DUR_SPELL_FOX_CUNNING);
    eRaise = EffectAbilityIncrease(ABILITY_DEXTERITY, nRaise);
    effect eLink = EffectLinkEffects(eRaise, eVis);
    ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLink, oTarget, fDuration);
}