//::///////////////////////////////////////////////
//:: Dispelling Breath
//:: mt_s0_dispellingbreath
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Jan 19, 2007
//:://////////////////////////////////////////////

//float SpellDelay (object oTarget, int nShape);

#include "NW_I0_SPELLS"
#include "x0_i0_spells"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
// End of Spell Cast Hook

    //Declare major variables
    int nCasterLevel = GetCasterLevel(OBJECT_SELF);
			
    int nDamage;
    float fDelay;
	effect eCone = EffectVisualEffect(VFX_DUR_CONE_SONIC);
	float fMaxDelay = 0.0f; // used to determine duration of eCone effect
    location lTargetLocation = GetSpellTargetLocation();
    object oTarget;

	//Declare the spell shape, size and the location.  Capture the first target object in the shape.
    oTarget = GetFirstObjectInShape(SHAPE_SPELLCONE, 14.0, lTargetLocation, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);
    //Cycle through the targets within the spell shape until an invalid object is captured.
    while(GetIsObjectValid(oTarget))
    {
    	if(spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
    	{
            //Fire cast spell at event for the specified target
            SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId()));
			
            //Get the distance between the target and caster to delay the application of effects
            fDelay = GetDistanceBetween(OBJECT_SELF, oTarget)/20.0;
			if (fDelay > fMaxDelay)
			{
				fMaxDelay = fDelay;
			}

			    effect   eVis         = EffectVisualEffect( VFX_HIT_SPELL_ABJURATION );
				effect   eImpact; // Now handled by spells.2da, the ImpactSEF column, but effect required for spellsDispelMagic
			    int      nCasterLevel = GetCasterLevel( OBJECT_SELF );
			
			    //--------------------------------------------------------------------------
			    // Dispel Magic is capped at caster level 12
			    //--------------------------------------------------------------------------
			    if(nCasterLevel >12 )
			    {
			        nCasterLevel = 12;
			    }
			
			    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
			    {
			        nCasterLevel = (nCasterLevel + 3);
			    }	
			    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
			    {
			        nCasterLevel = (nCasterLevel + 2);
			    }	
			    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
			    {
			        nCasterLevel = (nCasterLevel + 1);
			    }	
			
			    if (GetHasFeat(5255)) // If have unanswerable strike, add 1 more.
			    {
			        nCasterLevel = (nCasterLevel + 2);
			    }	
				
			    if (GetIsObjectValid(oTarget))
			    {
			        //----------------------------------------------------------------------
			        // Targeted Dispel - Dispel all
			        //----------------------------------------------------------------------
			        spellsDispelMagic(oTarget, nCasterLevel, eVis, eImpact);
			    }
        }
        //Select the next target within the spell shape.
        oTarget = GetNextObjectInShape(SHAPE_SPELLCONE, 8.0, lTargetLocation, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);
    }
	
	fMaxDelay += 0.5f;
	ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eCone, OBJECT_SELF, fMaxDelay);
}