//::///////////////////////////////////////////////
//:: Distracting Ray
//:: mt_s0_distractingray
//:: Purpose: Touched ranged attack that attempts to stop a spell being cast. Concentration/fortitude check or 100% spell failure for 3 seconds.
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Nov 5, 2015
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	//Declare major variables
	object oTarget = GetSpellTargetObject();
    int nMetaMagic = GetMetaMagicFeat();
		
	if (GetIsObjectValid(oTarget))
	{
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
		{
			int nRangedTouch = TouchAttackRanged(oTarget);
			if (nRangedTouch != TOUCH_ATTACK_RESULT_MISS)
			{
			    //Declare major variables
			    object oCaster = OBJECT_SELF;
			    int nCasterLvl = 20;
			    int nDamage, nDamage2;
				
			    effect eVis = EffectVisualEffect(VFX_HIT_SPELL_ABJURATION);
			    effect eDamage;
				effect eLink;
				
				// Fortitude Save
				if(!MySavingThrow(SAVING_THROW_FORT, oTarget, GetSpellSaveDC()+4))
		        {
					eDamage = EffectSpellFailure(100, SPELL_SCHOOL_GENERAL);
					eLink = EffectLinkEffects(eDamage, eVis);
		        	ApplyEffectToObject( DURATION_TYPE_TEMPORARY, eLink, oTarget, 9.0f);					
				}
			}						
		}	
	}			
}