//::///////////////////////////////////////////////
//:: Eldritch Disruption
//:: mt_s0_eldritchdisruption
//:: Purpose: Eldritch Disruption
//:: Created By: Joshua Kalis (Greg)
//:: Created On: September 23, 2015
//:: Blast of magic
//:: Mystery
//::
//:: Blast of magic.
//:://////////////////////////////////////////////

#include "NW_I0_SPELLS"
#include "x2_inc_spellhook"

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	//Declare major variables
    object   oTarget      = GetSpellTargetObject();
    location lLocal   =     GetSpellTargetLocation();
    int nCasterLevel = 25;
	int nDice = nCasterLevel;
	
	int nDamage = 30;		
	if (GetHasFeat(5196)) // empower mystery
	{
		nDamage = nDamage * 2;
	}	

	oTarget = GetFirstObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_LARGE, lLocal, FALSE, OBJECT_TYPE_CREATURE);
	while (GetIsObjectValid(oTarget))
	{
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
		{
			SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId()));
				
			effect eDamage = EffectDamage(nDamage,DAMAGE_TYPE_MAGICAL);
			ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);
			
			effect eDisrupt = EffectArcaneSpellFailure(25);
			ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eDisrupt, oTarget, 12.0);
			
			effect	eVis = EffectVisualEffect(VFX_HIT_SPELL_ICE);
			ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
		}	
		
		oTarget = GetNextObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_LARGE,lLocal, FALSE, OBJECT_TYPE_CREATURE);
	}
}