//::///////////////////////////////////////////////
//:: Farsight
//:: mt_s0_farsight
//:: Purpose: Farsight
//:: Created By: Joshua Kalis (Greg)
//:: Created On: October 18, 2015
//:: Description: True Seeing+Clairvoyance+Detect Undead and Spirits
//:: Mystery
//::
//:: True Seeing, +2 wisdom bonus.
//:://////////////////////////////////////////////

#include "nwn2_inc_spells"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {
		// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
// End of Spell Cast Hook


    //Declare major variables
    object oTarget = GetSpellTargetObject();
	
    float fDuration = TurnsToSeconds(GetCasterLevel(OBJECT_SELF));
	int nLevelShadowcaster = GetLevelByClass(99, OBJECT_SELF);
	int nLevelMasterOfShadow = GetLevelByClass(100, OBJECT_SELF);
	int nLevelNoctumancer = GetLevelByClass(101, OBJECT_SELF);
	int nLevelShadowTheurge = GetLevelByClass(103, OBJECT_SELF);
	int nCasterLvl = nLevelShadowcaster + nLevelMasterOfShadow + nLevelNoctumancer + nLevelShadowTheurge;
	
    if (GetHasFeat(5198)) // If have mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    if (GetHasFeat(5199)) // If have greater mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    int nBonus = 12 + nCasterLvl;
		
    if (GetHasFeat(5194)) // If have extend mystery, double it.
    {
        nCasterLvl = (nCasterLvl * 2);
    }		
	fDuration = TurnsToSeconds(nCasterLvl);
	
	//Declare major variables
    effect eVis = EffectVisualEffect(VFX_DUR_SPELL_TRUE_SEEING);
	effect eDur = EffectVisualEffect(VFX_DUR_CESSATE_POSITIVE);
    effect eSight = EffectTrueSeeing();	
    effect eLink = EffectLinkEffects(eVis, eSight);	
    eLink = EffectLinkEffects(eLink, eDur);
	effect eSpirits = EffectDetectSpirits();
	effect eUndead = EffectDetectUndead();
	effect eUltra = EffectUltravision();
	effect eSeeInvisible = EffectSeeInvisible();
    eLink = EffectLinkEffects(eLink, eSpirits);
    eLink = EffectLinkEffects(eLink, eUndead);
    eLink = EffectLinkEffects(eLink, eUltra);
    eLink = EffectLinkEffects(eLink, eSeeInvisible);
	
	ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLink, oTarget, fDuration);
	
    //Fire cast spell at event for the specified target
    SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, SPELL_FOXS_CUNNING, FALSE));

    effect eSpot = EffectSkillIncrease(SKILL_SPOT, 10);
    effect eListen = EffectSkillIncrease(SKILL_LISTEN, 10);
    eVis = EffectVisualEffect( VFX_DUR_SPELL_CLAIRAUD );	// NWN2 VFX

    eLink = EffectLinkEffects(eSpot, eListen);
    eLink = EffectLinkEffects(eLink, eVis);
    
    //Meta-Magic checks
    fDuration = ApplyMetamagicDurationMods(fDuration);
    int nDurType = ApplyMetamagicDurationTypeMods(DURATION_TYPE_TEMPORARY);

    //Make sure the spell has not already been applied
    if(!GetHasSpellEffect(SPELL_CLAIRAUDIENCE_AND_CLAIRVOYANCE, oTarget))
    {
        //Fire cast spell at event for the specified target
        SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, SPELL_CLAIRAUDIENCE_AND_CLAIRVOYANCE, FALSE));

         //Apply linked and VFX effects
         ApplyEffectToObject(nDurType, eLink, oTarget, fDuration);
    }
	
	
    //Set Adjust Ability Score effect
    int nRaise = 2;
    effect eRaise;
    eVis = EffectVisualEffect(VFX_DUR_SPELL_FOX_CUNNING);
    eRaise = EffectAbilityIncrease(ABILITY_WISDOM, nRaise);
    eLink = EffectLinkEffects(eRaise, eVis);
    ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLink, oTarget, fDuration);
}