//::///////////////////////////////////////////////
//:: Flashburst
//:: mt_s0_flashburst
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Jan 13, 2007
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {
	    // If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
 		return;
    }

	//Declare major variables
	object oTarget = GetSpellTargetObject();
	int nCasterLvl = GetCasterLevel(OBJECT_SELF);
	
	int nSpecialization = 0;

    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nSpecialization = (nSpecialization + 3);
    }	
    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nSpecialization = (nSpecialization + 2);
    }	
    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nSpecialization = (nSpecialization + 1);
    }	
		
	effect eVis;	
	int nDamageType;
	int nSpellId = GetSpellId();
	
    //Get the spell target location as opposed to the spell target.
    location lTarget = GetSpellTargetLocation();

	// Calculate the damage type.
	nDamageType	= DAMAGE_TYPE_ACID;
	eVis = EffectVisualEffect(VFX_HIT_SPELL_SEARING_LIGHT);
		  
	//if (GetIsObjectValid(oTarget))
	//{
	//	if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
	//	{		
		    //Declare the spell shape, size and the location.  Capture the first target object in the shape.
		    oTarget = GetFirstObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_HUGE, lTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);

			//Cycle through the targets within the spell shape until an invalid object is captured.
		    while (GetIsObjectValid(oTarget))
		    {
				if(!MyResistSpell(OBJECT_SELF, oTarget))
				{							
					effect eBlind = EffectBlindness();
					effect eDazed = EffectDazed();
					
					//Fire cast spell at event for the specified target
					SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId()));				

					//Apply the effects
					ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);

		            if (!MySavingThrow(SAVING_THROW_FORT, oTarget, GetSpellSaveDC() + nSpecialization, SAVING_THROW_TYPE_ALL))
						ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eBlind, oTarget, TurnsToSeconds(nCasterLvl));

					if (!MySavingThrow(SAVING_THROW_WILL, oTarget, GetSpellSaveDC() + nSpecialization, SAVING_THROW_TYPE_ALL))
						ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eDazed, oTarget, TurnsToSeconds(nCasterLvl));
				}
				
				//Select the next target within the spell shape.
		        oTarget = GetNextObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_HUGE, lTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);
		    }
			
			
			
			// Do not need extra damage.	
            //if (!MySavingThrow(SAVING_THROW_FORT, oTarget, GetSpellSaveDC(), SAVING_THROW_TYPE_ACID))
			//		ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eOrbEffect, oTarget, 6.0f);
				
				
	//	}	
	//}			
}