//::///////////////////////////////////////////////
//:: Flensing
//:: mt_s0_flensing
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Jan 10, 2007
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void mainSpell();
void main()
{
	AssignCommand(JXGetCaster(), mainSpell());
}

void mainSpell()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        JXPostSpellCastCode();
        return;
    }

	//Declare major variables
	object oTarget = JXGetSpellTargetObject();
	int nCasterLvl = JXGetCasterLevel(OBJECT_SELF);
	int nDamage = d6(2);	
		
	effect eVis;	
	effect eOrbEffect;
	int nDamageType;
	int nSpellId = JXGetSpellId();
	
	nDamageType	= DAMAGE_TYPE_SLASHING;
	eVis = EffectVisualEffect(VFX_HIT_SPELL_AVASCULATE);
	eOrbEffect = EffectStunned();
		  
	if (GetIsObjectValid(oTarget))
	{
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
		{		
			int nMax = (nCasterLvl*8)+2;
			nDamage = ApplyMetamagicVariableMods( nDamage, nMax );					
			effect eDamage = EffectDamage(nDamage,nDamageType);
			effect eCon = EffectAbilityDecrease(ABILITY_CONSTITUTION, d2(4));
			effect eCha = EffectAbilityDecrease(ABILITY_CHARISMA, d2(4));
							
			//Fire cast spell at event for the specified target
			SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, JXGetSpellId()));				

			//Apply the effects
			JXApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
			JXApplyEffectToObject(DURATION_TYPE_TEMPORARY, eDamage, oTarget, RoundsToSeconds(4));
			JXApplyEffectToObject(DURATION_TYPE_INSTANT, eCha, oTarget, RoundsToSeconds(4));
			JXApplyEffectToObject(DURATION_TYPE_INSTANT, eCon, oTarget, RoundsToSeconds(4));
		}	
	}			


	JXPostSpellCastCode();
}