//::///////////////////////////////////////////////
//:: Flensing
//:: mt_s0_flesing
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Jan 1, 2007
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void mainSpell();
void main()
{
	AssignCommand(JXGetCaster(), mainSpell());
}

void mainSpell()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        JXPostSpellCastCode();
        return;
    }

	//Declare major variables
	object oTarget = JXGetSpellTargetObject();
	int nCasterLvl = JXGetCasterLevel(OBJECT_SELF);
	
	float nDuration = RoundsToSeconds(4);
	int nDamage = d6(2);	
		
	effect eVis;	
	effect eOrbEffect;
	int nDamageType;
	int nSpellId = JXGetSpellId();
	
    //Get the spell target location as opposed to the spell target.
    location lTarget = JXGetSpellTargetLocation();

	if (GetIsObjectValid(oTarget))
	{
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
		{				
			if(!MyResistSpell(OBJECT_SELF, oTarget))
			{							
				nDamage = d6(2);	
				nDamageType	= DAMAGE_TYPE_SLASHING;
				eVis = EffectVisualEffect(VFX_HIT_SPELL_AVASCULATE);
				effect eDamage = EffectDamage(nDamage,nDamageType);
				
				//Fire cast spell at event for the specified target
				SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, JXGetSpellId()));				
	
				//Apply the effects
				JXApplyEffectToObject(DURATION_TYPE_TEMPORARY, eDamage, oTarget, nDuration);
				JXApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis, oTarget, nDuration);

				JXApplyEffectToObject(DURATION_TYPE_TEMPORARY, EffectAbilityIncrease(ABILITY_CHARISMA,-2), oTarget, nDuration);
				JXApplyEffectToObject(DURATION_TYPE_TEMPORARY, EffectAbilityIncrease(ABILITY_CONSTITUTION,-2), oTarget, nDuration);				
			}
		}	
	}			

	JXPostSpellCastCode();
}