//::///////////////////////////////////////////////
//:: Flood of Shadows
//:: mt_s0_floodofshadows
//:: Purpose: Flood of Shadows
//:: Created By: Joshua Kalis (Greg)
//:: Created On: September 20, 2015
//:: Description: Spell failure
//:: Initiate Mystery
//::
//:: Circle of spell failure.
//:://////////////////////////////////////////////

#include "x2_inc_spellhook" 
#include "X0_I0_SPELLS"

void main()
{
/* 
  Spellcast Hook Code 
  Added 2003-06-20 by Georg
  If you want to make changes to all spells,
  check x2_inc_spellhook.nss to find out more 
*/
    if (!X2PreSpellCastCode())
    {
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
// End of Spell Cast Hook

	int nLevelShadowcaster = GetLevelByClass(99, OBJECT_SELF);
	int nLevelMasterOfShadow = GetLevelByClass(100, OBJECT_SELF);
	int nLevelNoctumancer = GetLevelByClass(101, OBJECT_SELF);
	int nLevelShadowTheurge = GetLevelByClass(103, OBJECT_SELF);
	int nCasterLvl = nLevelShadowcaster + nLevelMasterOfShadow + nLevelNoctumancer + nLevelShadowTheurge;
	int nBonus = 1;
    int nDuration = 1;
	float nRadius = 5.0;
	
    if (GetHasFeat(5198)) // If have mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    if (GetHasFeat(5199)) // If have greater mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    if (GetHasFeat(5194)) // If have extend mystery, double it.
    {
        nCasterLvl = (nCasterLvl * 2);
    }	
    if (GetHasFeat(5195)) // If have enlarge mystery, double size.
    {
        nRadius = (nRadius * 2);
    }		
    nDuration = nCasterLvl;		
    float fDuration = RoundsToSeconds(nDuration);

    //Declare major variables including Area of Effect Object
    effect eAOE = EffectAreaOfEffect(AOE_PER_ENTANGLE);
    location lTarget = GetSpellTargetLocation();
	
	//Declare major variables
    effect eHold = EffectSpellFailure(80, SPELL_SCHOOL_GENERAL);
    effect eEntangle = EffectVisualEffect(VFX_DUR_ENTANGLE);
    //Link Entangle and Hold effects
    effect eLink = EffectLinkEffects(eHold, eEntangle);
    effect eAOE2 = EffectAreaOfEffect(AOE_PER_DARKNESS);
    effect eDarkness = EffectVisualEffect(VFX_DUR_DARKNESS);
	effect eLink2 = EffectLinkEffects(eAOE2, eDarkness);
	
    //Create an instance of the AOE Object using the Apply Effect function
    ApplyEffectAtLocation(DURATION_TYPE_TEMPORARY, eAOE, lTarget, RoundsToSeconds(nDuration));
	
    //Create an instance of the AOE Object using the Apply Effect function
    ApplyEffectAtLocation(DURATION_TYPE_TEMPORARY, eLink2, lTarget, fDuration);
	
	//The following lines are from nw_s0_entanglec and are included so that a creature can be entangled on the same round that the spell goes off.
	object oTarget = GetFirstObjectInShape( SHAPE_SPHERE, nRadius, lTarget );

    while(GetIsObjectValid(oTarget))
    {
	if( (GetCreatureFlag(OBJECT_SELF, CREATURE_VAR_IS_INCORPOREAL) != TRUE) )	// AFW-OEI 05/01/2006: Woodland Stride no longer protects from spells.
       {
            if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
            {
                //Fire cast spell at event for the specified target
                SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, SPELL_ENTANGLE));
				
                if(!GetHasSpellEffect(SPELL_ENTANGLE, oTarget))
                {
					//Apply linked effects
					ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLink, oTarget, fDuration);
                }
				
				SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, SPELL_DARKNESS));
				ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eAOE2, oTarget, fDuration);				
            }
        }
        //Get next target in the AOE
        oTarget = GetNextObjectInShape( SHAPE_SPHERE, 5.0, lTarget );
    }
}