//::///////////////////////////////////////////////
//:: Force Orb
//:: mt_s0_forceorb
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Jan 1, 2007
//:://////////////////////////////////////////////

#include "NW_I0_SPELLS"
#include "x2_inc_spellhook"
#include "cmi_inc_sneakattack"

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	//Declare major variables
	object oTarget = GetSpellTargetObject();
    int nCasterLevel = GetCasterLevel(OBJECT_SELF);
	int nDice = nCasterLevel;
	int nDamage = 0;
	
	// Calculate max damage.
	if (nCasterLevel > 15)
		nDice = 15;

	// For Force Specialization feat from Argent Savant.		
	int nSpecialization = 0; 	
	if (GetHasFeat(5218,OBJECT_SELF,TRUE))
		nSpecialization = 1;

	// Invisible Needle		
	if (GetHasFeat(3096,OBJECT_SELF,TRUE))
		nSpecialization += 1;
				
	// Calculate base damage	
	nDamage = d4(nDice) + nSpecialization;	
	
	if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
	{
		 SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId()));
		 int nRangedTouch = TouchAttackRanged(oTarget);
		 if (nRangedTouch != TOUCH_ATTACK_RESULT_MISS)
		 {
		 // Orb spells are not resisted!!
		 	int nMetaMagic = GetMetaMagicFeat();
			if (nMetaMagic & METAMAGIC_MAXIMIZE)
     	    {
      		   	// do MAXIMIZE 8 * nDice
				nDamage = 4 * nDice;
       	 	}
         	else if (nMetaMagic & METAMAGIC_EMPOWER)
         	{
            	// DO EMPOWER damage * 1.5
				nDamage = nDamage + (nDamage/2);
         	}
			
			// Ranged Touch Spell Specialization
			if (GetHasFeat(2992,OBJECT_SELF,TRUE))
			{
				nDamage += 2;
			}
					
			if (nRangedTouch == TOUCH_ATTACK_RESULT_CRITICAL && !GetIsImmune(oTarget, IMMUNITY_TYPE_CRITICAL_HIT, OBJECT_SELF))
				nDamage = nDamage * 2;				
					
			//include sneak attack damage
			if (StringToInt(Get2DAString("cmi_options","Value",CMI_OPTIONS_SneakAttackSpells)))
			{	nDamage += EvaluateSneakAttack(oTarget, OBJECT_SELF);}	
				
			effect eDam = EffectDamage(nDamage, DAMAGE_TYPE_BLUDGEONING);
			
			ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam, oTarget);
			
			if (GetHasFeat(5212,OBJECT_SELF,TRUE)) // Diabolism
			{
				int nLevelDiabolist = GetLevelByClass(96, OBJECT_SELF);
				if(nLevelDiabolist == 10)
					nDamage = 3;
				else if(nLevelDiabolist == 5)
					nDamage = 2;
				else
					nDamage = 1;
										
                effect eDam2 = EffectDamage(nDamage, DAMAGE_TYPE_NEGATIVE);
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam2, oTarget);
			}

			if (GetHasFeat(5213,OBJECT_SELF,TRUE)) // Vile Diabolism
			{
				nDamage = 1;
                effect eDam3 = EffectDamage(nDamage, DAMAGE_TYPE_MAGICAL);
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam3, oTarget);
			}					
		 }
	}	
}