//::///////////////////////////////////////////////
//:: Forcewave
//:: mt_s0_forcewave
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Jan 19, 2008
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	//Declare major variables
	object oTarget = GetSpellTargetObject();
	int nCasterLvl = GetCasterLevel(OBJECT_SELF);

	// For Force Specialization feat from Argent Savant.		
	int nSpecialization = 0; 	
	if (GetHasFeat(5218,OBJECT_SELF,TRUE))
		nSpecialization = 1;

	// Invisible Needle		
	if (GetHasFeat(3096,OBJECT_SELF,TRUE))
		nSpecialization += 1;

	int nDamage = d4(1) + nSpecialization;	
		
	effect eVis;	
	effect eOrbEffect;
	int nDamageType;
	int nSpellId = GetSpellId();
	
	nDamageType	= DAMAGE_TYPE_BLUDGEONING;
	eVis = EffectVisualEffect(VFX_HIT_SPELL_SONIC);
	eOrbEffect = EffectKnockdown();
		  
	if (GetIsObjectValid(oTarget))
	{
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
		{		
			if(!MyResistSpell(OBJECT_SELF, oTarget))
			{				
				effect eDamage = EffectDamage(nDamage,nDamageType);
				
				//Fire cast spell at event for the specified target
				SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId()));				

				//Apply the effects
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);
				
                // * DO a strength check vs. Strength 20
                if (d20() + GetAbilityScore(oTarget, ABILITY_STRENGTH) <= 22 + d20() )
                {
					ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eOrbEffect, oTarget, 6.0f);
				}	
				
				if (GetHasFeat(5212,OBJECT_SELF,TRUE)) // Diabolism
				{
					int nLevelDiabolist = GetLevelByClass(96, OBJECT_SELF);
					if(nLevelDiabolist == 10)
						nDamage = 3;
					else if(nLevelDiabolist == 5)
						nDamage = 2;
					else
						nDamage = 1;
											
	                effect eDam2 = EffectDamage(nDamage, DAMAGE_TYPE_NEGATIVE);
					ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam2, oTarget);
				}

				if (GetHasFeat(5213,OBJECT_SELF,TRUE)) // Vile Diabolism
				{
					nDamage = 1;
	                effect eDam3 = EffectDamage(nDamage, DAMAGE_TYPE_MAGICAL);
					ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam3, oTarget);
				}																
			}
		}	
	}				
}