//::///////////////////////////////////////////////
//:: Foresight
//:: mt_s0_foresight
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Jan 19, 2008
//:://////////////////////////////////////////////

#include "nw_i0_spells"
#include "x2_inc_spellhook"

void mainSpell();
void main()
{
	AssignCommand(JXGetCaster(), mainSpell());
}

void mainSpell()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        JXPostSpellCastCode();
        return;
    }

    // End of Spell Cast Hook

    object oTarget = JXGetSpellTargetObject();

    //Declare major variables
    int nCasterLevel = JXGetCasterLevel(OBJECT_SELF);
    int nDamageLimit = nCasterLevel * 20;
    int nMetaMagic = JXGetMetaMagicFeat(); 
    effect eStone = EffectDamageReduction(50, DAMAGE_POWER_PLUS_SIX, nDamageLimit, DR_TYPE_EPIC);
    effect eVis = EffectVisualEffect(VFX_DUR_SPELL_PREMONITION);
	eStone = EffectLinkEffects(eStone, eVis);
	float fSpellDuration = HoursToSeconds(nCasterLevel);	
	
    //Enter Metamagic conditions
    //Fire cast spell at event for the specified target
    SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, JXGetSpellId(), FALSE));
    if (nMetaMagic & METAMAGIC_EXTEND)
    {
        fSpellDuration = fSpellDuration * 2; //Duration is +100%
    }

	
    RemoveEffectsFromSpell(oTarget, JXGetSpellId());
    //Apply the linked effect
    JXApplyEffectToObject(DURATION_TYPE_TEMPORARY, eStone, oTarget, fSpellDuration);
	
	JXPostSpellCastCode();
}