//::///////////////////////////////////////////////
//:: Greater Flesh Fails
//:: mt_s0_gfleshfails
//:: Purpose: Greater Flesh Fails
//:: Created By: Joshua Kalis (Greg)
//:: Created On: September 23, 2015
//:: Description: Ability damage
//:: Mystery
//::
//:: Ranged attack with ability damage.
//:://////////////////////////////////////////////

#include "nwn2_inc_spells"
#include "x2_inc_spellhook"

void main()
{
    if (!X2PreSpellCastCode())
    {
	    // If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	// Get necessary objects
	object oCaster		= OBJECT_SELF;
	location lTarget	= GetLocation(oCaster);
	
	// Get caster level and alignment	
	int nLevelShadowcaster = GetLevelByClass(99, OBJECT_SELF);
	int nLevelMasterOfShadow = GetLevelByClass(100, OBJECT_SELF);
	int nLevelNoctumancer = GetLevelByClass(101, OBJECT_SELF);
	int nLevelShadowTheurge = GetLevelByClass(103, OBJECT_SELF);
	int nCasterLvl = nLevelShadowcaster + nLevelMasterOfShadow + nLevelNoctumancer + nLevelShadowTheurge;
	
    if (GetHasFeat(5198)) // If have mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    if (GetHasFeat(5199)) // If have greater mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    int nBonus = 12 + nCasterLvl;
		
    if (GetHasFeat(5194)) // If have extend mystery, double it.
    {
        nCasterLvl = (nCasterLvl * 2);
    }		
	
	// Effects
	effect eStr         = EffectAbilityDecrease(ABILITY_STRENGTH, 6);
	effect eDex         = EffectAbilityDecrease(ABILITY_DEXTERITY, 6);
	effect eCon         = EffectAbilityDecrease(ABILITY_CONSTITUTION, 4);
	effect eHit			= EffectVisualEffect(VFX_HIT_SPELL_CASTIGATE);
	effect eVisual		= EffectVisualEffect(VFX_AOE_SPELL_CASTIGATE);
	effect eLink;
	int nSaved;

	ApplyEffectAtLocation(DURATION_TYPE_INSTANT, eVisual, lTarget);
	object oTarget = GetFirstObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_SMALL, lTarget);
	
	// Make sure spell target is valid
	while (GetIsObjectValid(oTarget))
	{
		// check to see if hostile
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, oCaster)) 
		{
			eLink = EffectLinkEffects(eHit, eStr);
			eLink = EffectLinkEffects(eLink, eDex);
			eLink = EffectLinkEffects(eLink, eCon);
			ApplyEffectToObject(DURATION_TYPE_INSTANT, eLink, oTarget);
	    	SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId(), TRUE));
		}
		
       oTarget = GetNextObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_SMALL, lTarget, TRUE, OBJECT_TYPE_CREATURE);
	}
}