//::///////////////////////////////////////////////
//:: Kelgore's Grave Mist
//:: mt_s0_gravemist
//:: Purpose: Cold + tired
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Nov 5, 2015
//:: Description:
//:: You create a mist that casuses cold damage and fatigue.
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
// End of Spell Cast Hook

    //Declare major variables
    effect eAOE = EffectAreaOfEffect(AOE_PER_SHROUDING_FOG);
    location lTarget = GetSpellTargetLocation();
    int nCasterLvl = GetCasterLevel(OBJECT_SELF);
	
	int nDuration = nCasterLvl;

    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nCasterLvl = (nCasterLvl + 3);
    }	
    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nCasterLvl = (nCasterLvl + 2);
    }	
    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
	
    if (GetHasFeat(3101)) // If have winters blast, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
		
    int nMetaMagic = GetMetaMagicFeat();
	
    //Make metamagic check for extend
    if (nMetaMagic == METAMAGIC_EXTEND)
    {
        nDuration = nDuration *2;	//Duration is +100%
    }
	
    //Create the AOE of mist object at the selected location
    ApplyEffectAtLocation(DURATION_TYPE_TEMPORARY, eAOE, lTarget,TurnsToSeconds(nDuration));
	
	// Create the damage and tiredness
    //Get the spell target location as opposed to the spell target.
    effect eVis = EffectVisualEffect(VFX_IMP_GREASE);	
	float fDelay;

    //Declare the spell shape, size and the location.  Capture the first target object in the shape.
    object oTarget = GetFirstObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_HUGE, lTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);
	
    //Cycle through the targets within the spell shape until an invalid object is captured.
    while (GetIsObjectValid(oTarget))
    {
			//Fire cast spell at event for the specified target
			SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId()));
			
			//Get the distance between the explosion and the target to calculate delay
			fDelay = GetDistanceBetweenLocations(lTarget, GetLocation(oTarget))/20;
			
			if (!MyResistSpell(OBJECT_SELF, oTarget, fDelay))
			{
				//Roll damage for each target
				int nDamage = d6(1);				
				
				//Resolve metamagic
				if (nMetaMagic & METAMAGIC_EXTEND)
				{
					nDuration = nDuration * 2;
				}
				
				//Adjust the damage based on the Reflex Save, Evasion and Improved Evasion.
				nDamage = GetReflexAdjustedDamage(nDamage, oTarget, GetSpellSaveDC(), SAVING_THROW_TYPE_COLD);
				
				//Set the damage effect
				effect eDam = EffectDamage(nDamage, DAMAGE_TYPE_COLD);
				
				if(nDamage > 0)
				{
					// Apply effects to the currently selected target.
					DelayCommand(fDelay, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eDam, oTarget, RoundsToSeconds(nDuration)));
					//This visual effect is applied to the target object not the location as above.  This visual effect
					//represents the flame that erupts on the target not on the ground.
					DelayCommand(fDelay, ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget));
				}
				
				if (GetHasFeat(5212,OBJECT_SELF,TRUE)) // Diabolism
				{
					int nLevelDiabolist = GetLevelByClass(96, OBJECT_SELF);
					if(nLevelDiabolist == 10)
						nDamage = 3;
					else if(nLevelDiabolist == 5)
						nDamage = 2;
					else
						nDamage = 1;	
					
	                effect eDam2 = EffectDamage(nDamage, DAMAGE_TYPE_NEGATIVE);
					ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam2, oTarget);
				}

				if (GetHasFeat(5213,OBJECT_SELF,TRUE)) // Vile Diabolism
				{
					nDamage = 1;
	                effect eDam3 = EffectDamage(nDamage, DAMAGE_TYPE_MAGICAL);
					ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam3, oTarget);
				}										
			 }
 		
       //Select the next target within the spell shape.
       oTarget = GetNextObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_HUGE, lTarget, TRUE, OBJECT_TYPE_CREATURE);
    }	
	
}