//::///////////////////////////////////////////////
//:: Great Thunderclap
//:: mt_s0_greatthunderclap
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Dec 29, 2007
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
// End of Spell Cast Hook

    //Declare major variables
    object oCaster = OBJECT_SELF;
    int nCasterLvl = GetCasterLevel(oCaster);
	int nSpellSaveDC = GetSpellSaveDC();
	float fDuration = 6.0f;
    int nMetaMagic = GetMetaMagicFeat();
    float fDelay;
	float fMaxDelay;
    float nSize =  RADIUS_SIZE_HUGE;	// AFW-OEI 12/06/2006: Colossal -> Huge
    effect eVis = EffectVisualEffect( VFX_HIT_SPELL_BALAGARN_IRON_HORN );	// NWN2 VFX
    effect eShake = EffectVisualEffect(VFX_FNF_SCREEN_BUMP);
	
    //Get the spell target location as opposed to the spell target.
    location lTarget = GetSpellTargetLocation();
	
    //Limit Caster level for the purposes of damage
    if (nCasterLvl > 20)
    {
        nCasterLvl = 20;
    }

    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nCasterLvl = (nCasterLvl + 3);
		nSpellSaveDC = (nSpellSaveDC + 3);
        fDuration = (fDuration + 3.0f);
    }	
    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nCasterLvl = (nCasterLvl + 2);
		nSpellSaveDC = (nSpellSaveDC + 2);
        fDuration = (fDuration + 2.0f);
    }	
    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
		nSpellSaveDC = (nSpellSaveDC + 1);
        fDuration = (fDuration + 1.0f);
    }	
	
    if (GetHasFeat(3093)) // If have clap of thunder, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
		
    ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eShake, OBJECT_SELF, RoundsToSeconds(d3(1)));
	
    //Apply epicenter explosion on caster
    //ApplyEffectAtLocation(DURATION_TYPE_INSTANT, eExplode, GetLocation(OBJECT_SELF));
    //Declare the spell shape, size and the location.  Capture the first target object in the shape.
    object oTarget = GetFirstObjectInShape(SHAPE_SPHERE, nSize, lTarget, TRUE, OBJECT_TYPE_CREATURE);
	
    //Cycle through the targets within the spell shape until an invalid object is captured.
    while (GetIsObjectValid(oTarget))
    {
        // * spell should not affect the caster
     	if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF) && (oTarget != oCaster))
    	{
            //Fire cast spell at event for the specified target
            SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId()));
			
            //Get the distance between the explosion and the target to calculate delay
            fDelay = GetDistanceBetweenLocations(lTarget, GetLocation(oTarget))/20;
			
			if (fDelay > fMaxDelay)
			{
				fMaxDelay = fDelay;
			}
			
			// First effect, will save or be stunned.
			effect eStun =EffectStunned();
	        if (!MySavingThrow(SAVING_THROW_WILL, oTarget, nSpellSaveDC, SAVING_THROW_TYPE_SONIC))
				ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eStun, oTarget, fDuration);
			
			// Second effect, fortitude save or be deafened.
			effect eDeaf = EffectDeaf();
	        if (!MySavingThrow(SAVING_THROW_FORT, oTarget, nSpellSaveDC, SAVING_THROW_TYPE_SONIC))
				ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eDeaf, oTarget, fDuration);
			
			// Third effect, reflex save or be knocked down.
            effect eTrip = EffectKnockdown();
	        if (!MySavingThrow(SAVING_THROW_REFLEX, oTarget, nSpellSaveDC, SAVING_THROW_TYPE_SONIC))
            {
                   // Apply effects to the currently selected target.
                   DelayCommand(fDelay, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eTrip, oTarget, fDuration));
				   
                   //This visual effect is applied to the target object not the location as above.  This visual effect
                   //represents the flame that erupts on the target not on the ground.
                   DelayCommand(fDelay, ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget));
            }
        }
		
       //Select the next target within the spell shape.
       oTarget = GetNextObjectInShape(SHAPE_SPELLCONE, nSize, lTarget, TRUE, OBJECT_TYPE_CREATURE);
    }
	
	fMaxDelay += 0.5f;
	effect eCone = EffectVisualEffect( VFX_DUR_CONE_SONIC );
	ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eCone, OBJECT_SELF, fMaxDelay);
}