//::///////////////////////////////////////////////
//:: Halaster's Blacksphere
//:: mt_s0_halastersblacksphere
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Oct 17, 2015
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	//Declare major variables
	object oTarget = GetSpellTargetObject();
	int nSpellId = GetSpellId();
	int nCasterLvl = GetCasterLevel(OBJECT_SELF);
	
	if (nCasterLvl > 20)
		nCasterLvl = 20;

	// For Force Specialization feat from Argent Savant.		
	int nSpecialization = 0; 	
	if (GetHasFeat(5218,OBJECT_SELF,TRUE))
		nSpecialization = 1;

	// Invisible Needle		
	if (GetHasFeat(3096,OBJECT_SELF,TRUE))
		nSpecialization += 1;
				
	int nDamage = d6(nCasterLvl) + (nSpecialization * nCasterLvl);	
		
	effect eVis;	
	effect eOrbEffect;
	int nDamageType;
	
    //Get the spell target location as opposed to the spell target.
    location lTarget = GetSpellTargetLocation();

	// Calculate the damage type.
	nDamageType	= DAMAGE_TYPE_BLUDGEONING;
	eVis = EffectVisualEffect(VFX_HIT_SPELL_TRANSMUTATION);
		  
	int nMax = (nCasterLvl*6)+2;
	nDamage = ApplyMetamagicVariableMods( nDamage, nMax );					
		
    //Declare the spell shape, size and the location.  Capture the first target object in the shape.
    oTarget = GetFirstObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_MEDIUM, lTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);

	//Cycle through the targets within the spell shape until an invalid object is captured.
    while (GetIsObjectValid(oTarget))
    {
		if(!MyResistSpell(OBJECT_SELF, oTarget))
		{							
			//Fire cast spell at event for the specified target
			SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, nSpellId));				
			
			//Apply the effects
			ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
			
			// Do reflex saving throw to avoid the ill effects.
            if (MySavingThrow(SAVING_THROW_REFLEX, oTarget, GetSpellSaveDC() + nSpecialization, SAVING_THROW_TYPE_ALL))
			{
				nDamage = (nDamage + 1) / 2;
			}
			else
			{
				// They also are trapped.
				effect eStun = EffectStunned();
				ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eStun, oTarget, RoundsToSeconds(nCasterLvl));
			}
						
			effect eDamage = EffectDamage(nDamage,nDamageType);
			ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);

			if (GetHasFeat(5212,OBJECT_SELF,TRUE)) // Diabolism
			{
				int nLevelDiabolist = GetLevelByClass(96, OBJECT_SELF);
				if(nLevelDiabolist == 10)
					nDamage = 3;
				else if(nLevelDiabolist == 5)
					nDamage = 2;
				else
					nDamage = 1;	
				
                effect eDam2 = EffectDamage(nDamage, DAMAGE_TYPE_NEGATIVE);
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam2, oTarget);
			}

			if (GetHasFeat(5213,OBJECT_SELF,TRUE)) // Vile Diabolism
			{
				nDamage = 1;
                effect eDam3 = EffectDamage(nDamage, DAMAGE_TYPE_MAGICAL);
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam3, oTarget);
			}												
		}					
		
		//Select the next target within the spell shape.
    	oTarget = GetNextObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_SMALL, lTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);
    }
}