//::///////////////////////////////////////////////
//:: Hellfire Blast
//:: mt_s0_hellfireblast
//:: Created By: Joshua Kalis (Greg)
//:: Created On: January 4, 2007
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 
#include "cmi_inc_sneakattack"

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	//Declare major variables
	object oTarget = GetSpellTargetObject();
    object oCaster = OBJECT_SELF;
    int nCasterLvl = GetLevelByClass(83, oCaster);

	if (nCasterLvl < 1)
		nCasterLvl = 1;
		
	if (nCasterLvl > 10)
		nCasterLvl = 10;

	nCasterLvl = 4;
		
    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nCasterLvl = (nCasterLvl + 3);
    }	
    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nCasterLvl = (nCasterLvl + 2);
    }	
    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
	
    if (GetHasFeat(5036)) // If have fire adept, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    if (GetHasFeat(3094)) // If have fiery burst, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    if (GetHasFeat(5264)) // If have bloodline of fire, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 2);
    }	
				
	int nDamage = d6(nCasterLvl);	
		
	effect eVis;	
	effect eOrbEffect;
	int nDamageType;
	int nSpellId = GetSpellId();
	
    //Get the spell target location as opposed to the spell target.
    location lTarget = GetSpellTargetLocation();

	// Calculate the damage type.
	nDamageType	= DAMAGE_TYPE_POSITIVE;
	eVis = EffectVisualEffect(VFX_HIT_SPELL_FIRE);
		  
	if (GetIsObjectValid(oTarget))
	{
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
		{		
		
			int nRangedTouch = TouchAttackRanged(oTarget);
			if (nRangedTouch != TOUCH_ATTACK_RESULT_MISS)
			{
				if (GetHasFeat(2992,OBJECT_SELF,TRUE))
				{
					nDamage += 2;
				}
				int nMax = (nCasterLvl*8)+2;
				
				nDamage = ApplyMetamagicVariableMods( nDamage, nMax );

				if (nRangedTouch == TOUCH_ATTACK_RESULT_CRITICAL)
				{
					nDamage = nDamage * 2;					
				}
				
				if (StringToInt(Get2DAString("cmi_options","Value",CMI_OPTIONS_SneakAttackSpells)))
				{	nDamage += EvaluateSneakAttack(oTarget, OBJECT_SELF);	}
				
				effect eDamage = EffectDamage(nDamage,nDamageType);
				
				//Fire cast spell at event for the specified target
				SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId()));				

				//Apply the effects
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);
			}
		}	
	}			
}