//::///////////////////////////////////////////////
//:: Ice Burst
//:: mt_s0_iceburst
//:: Created By: Joshua Kalis
//:: Created On: Apr 16, 2008
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
// End of Spell Cast Hook

    //Declare major variables
    object oCaster = OBJECT_SELF;
    int nCasterLvl = GetCasterLevel(oCaster);
	int nSpellSaveDC = GetSpellSaveDC();
	
	if (nCasterLvl > 10)
		nCasterLvl = 10;

    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nCasterLvl = (nCasterLvl + 3);
        nSpellSaveDC = (nSpellSaveDC + 3);
    }	
    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nCasterLvl = (nCasterLvl + 2);
        nSpellSaveDC = (nSpellSaveDC + 2);
    }	
    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
        nSpellSaveDC = (nSpellSaveDC + 1);
    }	
	
    if (GetHasFeat(3101)) // If have winters blast, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
				
    int nMetaMagic = GetMetaMagicFeat();
    int nDamage, nDamage2;
    int nVariable = nCasterLvl/3;
    float fDelay;
    effect eVis = EffectVisualEffect(VFX_HIT_SPELL_ICE);
    effect eDam,eDam2, eSlow;
	
    //Get the spell target location as opposed to the spell target.
    location lTarget = GetSpellTargetLocation();
	
    //Declare the spell shape, size and the location.  Capture the first target object in the shape.
    object oTarget = GetFirstObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_HUGE, lTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);
	
    //Cycle through the targets within the spell shape until an invalid object is captured.
    while (GetIsObjectValid(oTarget))
    {
        if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
    	{
            //fDelay = GetRandomDelay(0.75, 2.25);
            //Fire cast spell at event for the specified target
            SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId()));
			
            if (!MyResistSpell(OBJECT_SELF, oTarget, fDelay))
    	    {
                //Roll damage for each target
                nDamage = d4(nCasterLvl);
                nDamage2 = nCasterLvl;
				
                //Resolve metamagic
        	    if (nMetaMagic & METAMAGIC_MAXIMIZE)
                {
                    nDamage = 4 * nCasterLvl;
                    nDamage2 = 6 + nCasterLvl;
                }
    	        else if (nMetaMagic & METAMAGIC_EMPOWER)
                {
                   nDamage = nDamage + (nDamage / 2);
                   nDamage2 = nDamage2 + (nDamage2 / 2);
                }

				int nDmgType = DAMAGE_TYPE_COLD;
				int nSaveThrow = SAVING_THROW_TYPE_COLD;	
				
				//Set the damage effect
                eDam = EffectDamage(nDamage2, nDmgType);
                eDam2 = EffectDamage(nDamage, DAMAGE_TYPE_BLUDGEONING);
				eSlow = EffectKnockdown();
				
				// Apply effects to the currently selected target.
                ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam, oTarget);

				//This visual effect is applied to the target object not the location as above.  This visual effect
                //represents the impact that erupts on the target not on the ground.
                ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
				
				// Now target must make reflex save or be slowed for 4 rounds.
                if (!MySavingThrow(SAVING_THROW_REFLEX, oTarget, nSpellSaveDC, nSaveThrow))
	                ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eSlow, oTarget, RoundsToSeconds(4));
					
             }
        }
       //Select the next target within the spell shape.
       oTarget = GetNextObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_HUGE, lTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);
    }
}