//::///////////////////////////////////////////////
//:: Kauper's Quickblast
//:: mt_s0_kaupersquickblast
//:: Purpose: Spell - Kauper's Quickblast
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Dec 29, 2007
//:: Description: based on Kaedrin's non-acid version
//:: Evocation, Wiz/Sor 1
//:: 1 cold/fire/elec to maximum of 5/5/5
//::
//:: You cause a multi-energy orb to fly from your 
//:: to take 1 point of cold/elec/fire every 
//:: level to a maximum of 5 points each.
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 
#include "cmi_ginc_spells"

void mainSpell();
void main()
{
	AssignCommand(JXGetCaster(), mainSpell());
}

void mainSpell()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        JXPostSpellCastCode();
        return;
    }

	//Declare major variables
	object oTarget = JXGetSpellTargetObject();
	int nCasterLvl = JXGetCasterLevel(OBJECT_SELF);

	if (nCasterLvl > 5)
		nCasterLvl = 5;

	int nDamage = nCasterLvl;	
		
	effect eVis;	
	effect eOrbEffect;
	int nDamageType;
	int nSpellId = JXGetSpellId();
	
	if (GetIsObjectValid(oTarget))
	{
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
		{		
				//Fire cast spell at event for the specified target
				SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, JXGetSpellId()));				

                if (MySavingThrow(SAVING_THROW_REFLEX, oTarget, JXGetSpellSaveDC(), SAVING_THROW_TYPE_ALL)) {
					nDamage = (nDamage + 1) / 2;
				}
				
				//Apply the cold effect
				int nDamageType = DAMAGE_TYPE_COLD;	
				if (GetHasFeat(FEAT_FROSTMAGE_PIERCING_COLD))
				{
					nDamageType = DAMAGE_TYPE_MAGICAL;
				}	
				eVis = EffectVisualEffect(VFX_HIT_SPELL_ICE);
				effect eDamage = EffectDamage(nDamage,nDamageType);
				JXApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
				JXApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);

				//Apply the fire effect
				nDamageType	= DAMAGE_TYPE_FIRE;
				eVis = EffectVisualEffect(VFX_HIT_SPELL_FIRE);
				eDamage = EffectDamage(nDamage,nDamageType);
				JXApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
				JXApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);

				//Apply the electricity effect
				nDamageType	= DAMAGE_TYPE_ELECTRICAL;
				eVis = EffectVisualEffect(VFX_HIT_SPELL_LIGHTNING);
				eDamage = EffectDamage(nDamage,nDamageType);
				JXApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
				JXApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);
		}	
	}			


	JXPostSpellCastCode();
}