//::///////////////////////////////////////////////
//:: Laeral's Silver Lance
//:: mt_s0_laeralslance
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Oct 17, 2015
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	//Declare major variables
	object oTarget = GetSpellTargetObject();
	int nCasterLvl = GetCasterLevel(OBJECT_SELF);		
	effect eVis;	
	int nDamageType;
	int nSpellId = GetSpellId();

	// For Force Specialization feat from Argent Savant.		
	int nSpecialization = 0; 	
	if (GetHasFeat(5218,OBJECT_SELF,TRUE))
		nSpecialization = 1;	

	// Invisible Needle		
	if (GetHasFeat(3096,OBJECT_SELF,TRUE))
		nSpecialization += 1;
				  
	if (GetIsObjectValid(oTarget))
	{
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
		{				
			if(!MyResistSpell(OBJECT_SELF, oTarget))
			{															
				int nDamage = d6(4) + 3 + nSpecialization;	
				nDamageType	= DAMAGE_TYPE_MAGICAL;
				eVis = EffectVisualEffect(VFX_HIT_SPELL_ELDRITCH);
				effect eDamage = EffectDamage(nDamage,nDamageType);
				
				//Fire cast spell at event for the specified target
				SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, nSpellId));				
	
				//Apply the effects
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);				
				
				// Do fortitude saving throw to avoid the ill effects.
                if (!MySavingThrow(SAVING_THROW_FORT, oTarget, GetSpellSaveDC() + nSpecialization, SAVING_THROW_TYPE_ALL))
				{
					effect eKnockdown = EffectKnockdown();
					ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eKnockdown, oTarget, 12.0f + IntToFloat(nSpecialization));				
				}				
			}
		}	
	}			
}