//::///////////////////////////////////////////////
//:: Launch Bolt
//:: mt_s0_launchbolt
//:: Created By: Joshua Kalis (Greg)
//:: Created On: January 1, 2007
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 
#include "cmi_inc_sneakattack"

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	//Declare major variables
	object oCaster = OBJECT_SELF;
	object oTarget = GetSpellTargetObject();
	int nCasterLvl = GetCasterLevel(oCaster);
	int nBonus = 0;
	
	nCasterLvl = 1;
	int nDamage = d8(nCasterLvl);	

    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nBonus = (nBonus + 3);
    }	
    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nBonus = (nBonus + 2);
    }	
    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nBonus = (nBonus + 1);
    }	

    if (GetHasFeat(93)) // Weapon Focus: Light Crossbow
    {
        nBonus = (nBonus + 1);
    }	
				
	effect eVis;	
	effect eOrbEffect;
	int nDamageType;
	int nSpellId = GetSpellId();
	
	nDamageType	= DAMAGE_TYPE_PIERCING;
	eVis = EffectVisualEffect(VFX_HIT_SPELL_HEALING_STING);
	eOrbEffect = EffectDeaf();
		  
	if (GetIsObjectValid(oTarget))
	{
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, oCaster))
		{				
			int nRangedTouch = TouchAttackRanged(oTarget, FALSE, nBonus);
			if (nRangedTouch != TOUCH_ATTACK_RESULT_MISS)
			{
				if(!MyResistSpell(oCaster, oTarget))
				{		
					if (GetHasFeat(2992,oCaster,TRUE))
					{
						nDamage += 2;
					}
					if (nRangedTouch == TOUCH_ATTACK_RESULT_CRITICAL)
					{
						nDamage = nDamage * 2;					
					}
					if (StringToInt(Get2DAString("cmi_options","Value",CMI_OPTIONS_SneakAttackSpells)))
					{	nDamage += EvaluateSneakAttack(oTarget, OBJECT_SELF);	}
				
					effect eDamage = EffectDamage(nDamage,nDamageType);
					
					//Fire cast spell at event for the specified target
					SignalEvent(oTarget, EventSpellCastAt(oCaster, GetSpellId()));				
	
					//Apply the effects
					ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
					ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);
					
					if (GetHasFeat(5212,OBJECT_SELF,TRUE)) // Diabolism
					{
						int nLevelDiabolist = GetLevelByClass(96, OBJECT_SELF);
						if(nLevelDiabolist == 10)
							nDamage = 3;
						else if(nLevelDiabolist == 5)
							nDamage = 2;
						else
							nDamage = 1;	
						
		                effect eDam2 = EffectDamage(nDamage, DAMAGE_TYPE_NEGATIVE);
						ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam2, oTarget);
					}

					if (GetHasFeat(5213,OBJECT_SELF,TRUE)) // Vile Diabolism
					{
						nDamage = 1;
		                effect eDam3 = EffectDamage(nDamage, DAMAGE_TYPE_MAGICAL);
						ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam3, oTarget);
					}															
				}
			}
		}	
	}			
}