//::///////////////////////////////////////////////
//:: Launch Stone
//:: mt_s0_launchstone
//:: Created By: Joshua Kalis (Greg)
//:: Created On: January 1, 2007
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 
#include "cmi_inc_sneakattack"

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	//Declare major variables
	object oCaster = OBJECT_SELF;
	object oTarget = GetSpellTargetObject();
	int nCasterLvl = GetCasterLevel(oCaster);
	int nBonus = 0;
	
    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nBonus = (nBonus + 3);
    }	
    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nBonus = (nBonus + 2);
    }	
    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nBonus = (nBonus + 1);
    }	
	
	nCasterLvl = 1;
	int nDamage = d4(nCasterLvl) + nBonus;	
		
	effect eVis;	
	effect eOrbEffect;
	int nDamageType;
	int nSpellId = GetSpellId();
	
	nDamageType	= DAMAGE_TYPE_BLUDGEONING;
	eVis = EffectVisualEffect(VFX_HIT_SPELL_HEALING_STING);
	eOrbEffect = EffectDeaf();
		  
	if (GetIsObjectValid(oTarget))
	{
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, oCaster))
		{		
			int nRangedTouch = TouchAttackRanged(oTarget, FALSE, nBonus);
			if (nRangedTouch != TOUCH_ATTACK_RESULT_MISS)
			{
				if(!MyResistSpell(oCaster, oTarget))
				{		
					if (GetHasFeat(2992,oCaster,TRUE))
					{
						nDamage += 2;
					}
					if (nRangedTouch == TOUCH_ATTACK_RESULT_CRITICAL)
					{
						nDamage = nDamage * 2;					
					}
					if (StringToInt(Get2DAString("cmi_options","Value",CMI_OPTIONS_SneakAttackSpells)))
					{	nDamage += EvaluateSneakAttack(oTarget, OBJECT_SELF);	}
					
					effect eDamage = EffectDamage(nDamage,nDamageType);
					
					//Fire cast spell at event for the specified target
					SignalEvent(oTarget, EventSpellCastAt(oCaster, GetSpellId()));				
	
					//Apply the effects
					ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
					ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);				
				}
			}
		}	
	}			
}