//::///////////////////////////////////////////////
//:: Lesser Sonic Orb
//:: mt_s0_lessersonic_orb
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Dec 29, 2007
//:: Description: based on Kaedrin's non-acid version
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	//Declare major variables
	object oTarget = GetSpellTargetObject();
	int nCasterLvl = GetCasterLevel(OBJECT_SELF);
	nCasterLvl = nCasterLvl / 2;
	if (nCasterLvl > 5)
		nCasterLvl = 5;
	int nDamage = d8(nCasterLvl);	
		
	effect eVis;	
	effect eOrbEffect;
	int nDamageType;
	int nSpellId = GetSpellId();
	
	nDamageType	= DAMAGE_TYPE_SONIC;
	eVis = EffectVisualEffect(VFX_HIT_SPELL_SONIC);
		  
	if (GetIsObjectValid(oTarget))
	{
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
		{		
		
			int nRangedTouch = TouchAttackRanged(oTarget);
			if (nRangedTouch != TOUCH_ATTACK_RESULT_MISS)
			{
				if(!MyResistSpell(OBJECT_SELF, oTarget))
				{				
				
					if (GetHasFeat(2992,OBJECT_SELF,TRUE))
						nDamage += 2;
						
					int nMax = (nCasterLvl*8)+2;
					nDamage = ApplyMetamagicVariableMods( nDamage, nMax );
					if (nRangedTouch == TOUCH_ATTACK_RESULT_CRITICAL)
						nDamage = nDamage * 2;
											
					effect eDamage = EffectDamage(nDamage,nDamageType);
					
					//Fire cast spell at event for the specified target
					SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId()));				
	
					//Apply the effects
					ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
					ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);					
				}
			}
		}	
	}			
}