//::///////////////////////////////////////////////
//:: Life Fades
//:: mt_s0_lifefades
//:: Purpose: Life Fades
//:: Created By: Joshua Kalis (Greg)
//:: Created On: September 19, 2015
//:: Description: Touch damage + fatigue
//:: Mystery
//::
//:: Touch attack spell.
//:://////////////////////////////////////////////

#include "x2_inc_spellhook"
#include "ginc_nx1spells"

void main()
{
    if (!X2PreSpellCastCode())
    {
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
// End of Spell Cast Hook

//Declare major variables
	object	oTarget			=	GetSpellTargetObject();
	object	oCaster			=	OBJECT_SELF;
	effect	eVis			=	EffectVisualEffect(VFX_HIT_SPELL_TOUCH_OF_FATIGUE);
	
	int nLevelShadowcaster = GetLevelByClass(99, OBJECT_SELF);
	int nLevelMasterOfShadow = GetLevelByClass(100, OBJECT_SELF);
	int nLevelNoctumancer = GetLevelByClass(101, OBJECT_SELF);
	int nLevelShadowTheurge = GetLevelByClass(103, OBJECT_SELF);
	int nCasterLvl = nLevelShadowcaster + nLevelMasterOfShadow + nLevelNoctumancer + nLevelShadowTheurge;
	
	if(nCasterLvl > 5)
		nCasterLvl = 5;
		
    if (GetHasFeat(5198)) // If have mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    if (GetHasFeat(5199)) // If have greater mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	

	int nDamage = d6(nCasterLvl);	
    if (GetHasFeat(5197)) // If have maximize damage.
    {
        nDamage = (nCasterLvl * 6);
    }			
    if (GetHasFeat(5196)) // If have empower, double damage
    {
        nDamage = (nDamage * 2);
    }				
	
	effect eDamage = EffectDamage(nDamage, DAMAGE_TYPE_MAGICAL, DAMAGE_POWER_NORMAL, TRUE);
	
	//discriminate targets
    if (GetIsObjectValid(oTarget))
    {
        if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
        {
			if (TouchAttackMelee(oTarget))
			{
				// Damage first then fatigue
				SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId(), TRUE));								
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);
				
				//saving throw
				if (!MySavingThrow(SAVING_THROW_FORT, oTarget, GetSpellSaveDC(), SAVING_THROW_TYPE_SPELL, oCaster))
				{
					ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
					ApplyEffectToObject(DURATION_TYPE_TEMPORARY,EffectSlow(), oTarget, RoundsToSeconds(nCasterLvl));
				}
			}
		}
	}
}