//::///////////////////////////////////////////////
//:: Lightning Ring
//:: mt_s0_lightningring
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Oct 24, 2015
//:://////////////////////////////////////////////

#include "x2_inc_spellhook"
#include "x0_i0_spells"

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	// Main Variables
	int nCasterLvl = GetCasterLevel(OBJECT_SELF) / 2;
	if(nCasterLvl < 6)
		nCasterLvl = 6;	

    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nCasterLvl = (nCasterLvl + 3);
    }	
    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nCasterLvl = (nCasterLvl + 2);
    }	
    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
	
    if (GetHasFeat(3098)) // If have storm bolt, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
				
	int nDamage = 0;	
    int nMetaMagic = GetMetaMagicFeat();
			 	
	// Remove lingering effects
    RemoveEffectsFromSpell(OBJECT_SELF, GetSpellId());	

	// Protection from lightning
	effect eElectricalProtection = EffectDamageReduction(20, DAMAGE_TYPE_ELECTRICAL , 0);
	effect eVis = EffectVisualEffect(VFX_DUR_SPELL_ENERGY_IMMUNITY);
	eElectricalProtection = SupernaturalEffect(eElectricalProtection);		
	ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eElectricalProtection, OBJECT_SELF, RoundsToSeconds(nCasterLvl));
	
	// Attack those around you with 1d6 lightning each round
	location lAreaTarget = GetLocation(OBJECT_SELF);
	object oTarget = GetFirstObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_SMALL, lAreaTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);

	//Cycle through the targets within the spell shape until an invalid object is captured.
	while (GetIsObjectValid(oTarget))
	{
		effect eLightning =  EffectDamage(d6(1), DAMAGE_TYPE_ELECTRICAL);
		eVis = EffectVisualEffect(VFX_IMP_LIGHTNING_S);
		
        if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
		{
			if(!MyResistSpell(OBJECT_SELF, oTarget))
			{							
				//Fire cast spell at event for the specified target
				SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId()));				
	
				//Apply the effects
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eLightning, oTarget);
				DelayCommand(RoundsToSeconds(1), ApplyEffectToObject(DURATION_TYPE_INSTANT, eLightning, oTarget));
				DelayCommand(RoundsToSeconds(2), ApplyEffectToObject(DURATION_TYPE_INSTANT, eLightning, oTarget));
				DelayCommand(RoundsToSeconds(3), ApplyEffectToObject(DURATION_TYPE_INSTANT, eLightning, oTarget));
				DelayCommand(RoundsToSeconds(4), ApplyEffectToObject(DURATION_TYPE_INSTANT, eLightning, oTarget));
				DelayCommand(RoundsToSeconds(5), ApplyEffectToObject(DURATION_TYPE_INSTANT, eLightning, oTarget));
			}					
		}
	
		if (GetHasFeat(5212,OBJECT_SELF,TRUE)) // Diabolism
		{
			int nLevelDiabolist = GetLevelByClass(96, OBJECT_SELF);
			if(nLevelDiabolist == 10)
				nDamage = 3;
			else if(nLevelDiabolist == 5)
				nDamage = 2;
			else
				nDamage = 1;	
			
	              effect eDam2 = EffectDamage(nDamage, DAMAGE_TYPE_NEGATIVE);
			ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam2, oTarget);
		}
	
		if (GetHasFeat(5213,OBJECT_SELF,TRUE)) // Vile Diabolism
		{
			nDamage = 1;
	              effect eDam3 = EffectDamage(nDamage, DAMAGE_TYPE_MAGICAL);
			ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam3, oTarget);
		}						
			
		//Select the next target within the spell shape.
		oTarget = GetNextObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_SMALL, lAreaTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);
	}
	
	// Attack the target of the spell with lightning bolts continuously.
	oTarget = GetSpellTargetObject();
    location lTarget = GetLocation(oTarget);
	location lTarget2 = GetSpellTargetLocation();
    effect eLightning = EffectBeam(VFX_BEAM_LIGHTNING, OBJECT_SELF, BODY_NODE_HAND);
	effect eDamage;
    eVis  = EffectVisualEffect(VFX_HIT_SPELL_LIGHTNING);

    object oNextTarget, oTarget2;
    float fDelay;
    int nCnt = 1;
	
	// If you target a location, this will spawn in an invisible creature to act as the endpoint on the beam, then delete itself
	object oPoint = CreateObject(OBJECT_TYPE_CREATURE, "c_attachspellnode" , lTarget2);
	SetScriptHidden(oPoint, TRUE);
	ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLightning, oPoint, 1.0);
	ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oPoint);
	DestroyObject(oPoint, 2.0);
	
    oTarget2 = GetNearestObject(OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE, OBJECT_SELF, nCnt);
    while(GetIsObjectValid(oTarget2) && GetDistanceToObject(oTarget2) <= 30.0)
    {
        //Get first target in the lightning area by passing in the location of first target and the casters vector (position)
        oTarget = GetFirstObjectInShape(SHAPE_SPELLCYLINDER, 30.0, lTarget2, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE, GetPosition(OBJECT_SELF));
		//PrettyDebug("investigating target " + GetName(oTarget));
         while (GetIsObjectValid(oTarget))
        {
           //Exclude the caster from the damage effects
           if (oTarget != OBJECT_SELF && oTarget2 == oTarget)
           {
                if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
            	{
                   //Fire cast spell at event for the specified target
					//PrettyDebug("Signaling Lightning Bolt on " + GetName(oTarget));
                   SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, SPELL_LIGHTNING_BOLT));
                   //Make an SR check
                   if (!MyResistSpell(OBJECT_SELF, oTarget))
        	       {
                        //Roll damage
                        nDamage =  d6(nCasterLvl);
        		        //Enter Metamagic conditions
        		        if (nMetaMagic == METAMAGIC_MAXIMIZE)
        		        {
        			         nDamage = 6 * nCasterLvl;//Damage is at max
                        }
        		        if (nMetaMagic == METAMAGIC_EMPOWER)
        		        {
        			         nDamage = nDamage + (nDamage/2); //Damage/Healing is +50%
                        }
                        //Adjust damage based on Reflex Save, Evasion and Improved Evasion
                        nDamage = GetReflexAdjustedDamage(nDamage, oTarget, GetSpellSaveDC(),SAVING_THROW_TYPE_ELECTRICITY);
                        //Set damage effect
                        eDamage = EffectDamage(nDamage, DAMAGE_TYPE_ELECTRICAL);
                        if(nDamage > 0)
                        {
                            fDelay = GetSpellEffectDelay(GetLocation(oTarget), oTarget);
                            //Apply VFX impcat, damage effect and lightning effect
                            DelayCommand(fDelay, ApplyEffectToObject(DURATION_TYPE_INSTANT,eDamage,oTarget));
                            DelayCommand(fDelay, ApplyEffectToObject(DURATION_TYPE_INSTANT,eVis,oTarget));
                        }
                    }
                    ApplyEffectToObject(DURATION_TYPE_TEMPORARY,eLightning,oTarget,1.0);
                    //Set the currect target as the holder of the lightning effect
                    oNextTarget = oTarget;
                    eLightning = EffectBeam(VFX_BEAM_LIGHTNING, oNextTarget, BODY_NODE_CHEST);
                }
           }
           //Get the next object in the lightning cylinder
           oTarget = GetNextObjectInShape(SHAPE_SPELLCYLINDER, 30.0, lTarget2, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE, GetPosition(OBJECT_SELF));
        }
        nCnt++;
        oTarget2 = GetNearestObject(OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE, OBJECT_SELF, nCnt);
    }						
}