//::///////////////////////////////////////////////
//:: Lullaby
//:: mt_s0_lullaby
//:: -2 Will and -5 Listen / Spot
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{
/* 
  Spellcast Hook Code 
  Added 2003-06-20 by Georg
  If you want to make changes to all spells,
  check x2_inc_spellhook.nss to find out more 
*/
    if (!X2PreSpellCastCode())
    {
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
// End of Spell Cast Hook

    //Declare major variables
    object oTarget;
    object oLowest;
    effect eWill =  EffectSavingThrowDecrease(SAVING_THROW_WILL, 2, SAVING_THROW_TYPE_ALL);
	effect eDur = EffectVisualEffect( VFX_DUR_SLEEP );
	effect eListen = EffectSkillDecrease(SKILL_LISTEN, 5);
	effect eSpot = EffectSkillDecrease(SKILL_SPOT, 5);
    
	effect eLink = EffectLinkEffects( eWill, eDur);
	
    int bContinueLoop;
    int nHD = 4 + d4();
    int nMetaMagic = GetMetaMagicFeat();
    int nCurrentHD;
    int bAlreadyAffected;
    int nMax = 9;// maximun hd creature affected
    int nLow;
    int nDuration = GetCasterLevel(OBJECT_SELF);
    nDuration = 2 + nDuration;

    string sSpellLocal = "BIOWARE_SPELL_LOCAL_SLEEP_" + ObjectToString(OBJECT_SELF);
    //Enter Metamagic conditions
    if (nMetaMagic == METAMAGIC_MAXIMIZE)
    {
        nHD = 8;//Damage is at max
    }
    if (nMetaMagic == METAMAGIC_EMPOWER)
    {
        nHD = nHD + (nHD/2); //Damage/Healing is +50%
    }
    else if (nMetaMagic == METAMAGIC_EXTEND)
    {
        nDuration = nDuration *2;	//Duration is +100%
    }
	
	float fDelay;
    oTarget = GetFirstObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_HUGE, GetSpellTargetLocation());
    //If no valid targets exists ignore the loop
    if (GetIsObjectValid(oTarget))
    {
        bContinueLoop = TRUE;
    }
	
    //Get the first creature in the spell area
    oTarget = GetFirstObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_HUGE, GetSpellTargetLocation());
    while (GetIsObjectValid(oTarget))
    {
        //Make faction check to ignore allies
    	if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
    	{
            //Get the local variable off the target and determined if the spell has already checked them.
            if (!MyResistSpell(OBJECT_SELF, oTarget, fDelay))
            {
	            if (!MySavingThrow(SAVING_THROW_WILL, oTarget, GetSpellSaveDC(), SAVING_THROW_TYPE_ALL))
				{
					ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLink, oTarget, RoundsToSeconds(nDuration));			
					ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eListen, oTarget, RoundsToSeconds(nDuration));			
					ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eSpot, oTarget, RoundsToSeconds(nDuration));			
				}					
            }
        }
        //Get the next target in the shape
        oTarget = GetNextObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_HUGE, GetSpellTargetLocation());
    }
}