//::///////////////////////////////////////////////
//:: Snilloc's Major Missle
//:: mt_s0_majormissle
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Jan 1, 2007
//:://////////////////////////////////////////////
//:: Purpose: 
/*
// A missile of magical energy darts forth from your
// fingertip and strikes its target. The
// missile deals 1d4+1 points of damage.  
//
// For every two extra levels of experience past 1st, you
// gain an additional missile up to 15 missles.
*/

#include "nwn2_inc_spells"
#include "NW_I0_SPELLS"    
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
// End of Spell Cast Hook

    //Declare major variables
    object oTarget = GetSpellTargetObject();
    int nCasterLvl = GetCasterLevel(OBJECT_SELF);
    int nMissiles = (nCasterLvl + 1)/2;
    effect eVis = EffectVisualEffect(VFX_IMP_MAGBLUE);
    float fDelay, fTime, fTime2;
	int nSpell = GetSpellId();
	int nPathType = PROJECTILE_PATH_TYPE_DEFAULT;
	location lSourceLoc = GetLocation( OBJECT_SELF );
	location lTarget = GetLocation( oTarget );
    int nCnt;
	float fTravelTime;

	// Starts at +1 damage.
	int nSpecialization = 1; 
	
	// Force Specialization	
	if (GetHasFeat(5218,OBJECT_SELF,TRUE))
		nSpecialization += 1;

	// Invisible Needle		
	if (GetHasFeat(3096,OBJECT_SELF,TRUE))
		nSpecialization += 1;
		
    if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
    {
        //Fire cast spell at event for the specified target
        SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, SPELL_MAGIC_MISSILE));
        
		//Limit missiles to five
        if (nMissiles > 15)
        {
            nMissiles = 15;
        }

		// Bonus Missile		
		int nLevelForceMissileMage = GetLevelByClass(104, OBJECT_SELF);
		if (GetHasFeat(5226,OBJECT_SELF,TRUE))
		{
			if(nLevelForceMissileMage == 5)
				nMissiles = nMissiles + 2;
			else
				nMissiles = nMissiles + 1;
		}		
		
		//Apply a single damage hit for each missile instead of as a single mass
		for (nCnt = 1; nCnt <= nMissiles; nCnt++)
		{
			fTravelTime = GetProjectileTravelTime( lSourceLoc, lTarget, nPathType );
			if ( nCnt == 0 )	fDelay = 0.0f;
			else				fDelay = GetRandomDelay( 0.1f, 0.5f ) + (0.5f * IntToFloat(nCnt));
			
			/*
			fTime = fDelay + ((nCnt - 1) * 0.25);
			fTime2 = ((nCnt - 1) * 0.25);
			*/			        
			
			//Make SR Check
	        if (!MyResistSpell(OBJECT_SELF, oTarget, fDelay))
		  	{
                //Roll damage
                int nDam = d4(1) + nSpecialization;

				//Enter Metamagic conditions
                nDam = ApplyMetamagicVariableMods(nDam, 15);

                //Set damage effect
                effect eDam = EffectDamage(nDam, DAMAGE_TYPE_MAGICAL);
				
                //Apply the MIRV and damage effect
                DelayCommand(fDelay + fTravelTime, ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam, oTarget));
                DelayCommand(fDelay + fTravelTime, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis, oTarget));
			}
			
			DelayCommand( fDelay, SpawnSpellProjectile(OBJECT_SELF, oTarget, lSourceLoc, lTarget, nSpell, nPathType) );
       	}
		
		int nDamage = 1;
		if (GetHasFeat(5212,OBJECT_SELF,TRUE)) // Diabolism
		{
			int nLevelDiabolist = GetLevelByClass(96, OBJECT_SELF);
			if(nLevelDiabolist == 10)
				nDamage = 3;
			else if(nLevelDiabolist == 5)
				nDamage = 2;
			else
				nDamage = 1;	
			
               effect eDam2 = EffectDamage(nDamage, DAMAGE_TYPE_NEGATIVE);
			ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam2, oTarget);
		}

		if (GetHasFeat(5213,OBJECT_SELF,TRUE)) // Vile Diabolism
		{
			nDamage = 1;
               effect eDam3 = EffectDamage(nDamage, DAMAGE_TYPE_MAGICAL);
			ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam3, oTarget);
		}						
	}
}