//::///////////////////////////////////////////////
//:: Mass Resist Energy (Was mass cure light wounds)
//:: mt_s0_massenergy
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Jan 19, 2008
//:://////////////////////////////////////////////

#include "nwn2_inc_spells"
#include "NW_I0_SPELLS"    
#include "x2_inc_spellhook" 

// Brock H. - OEI 10/06/05 -- Added code to heal faction, then nearby, and cap based on level
int CureFaction( int nMaxToCure, effect eVis, effect eVis2, int nCasterLvl, int nMetaMagic ); 
int CureNearby( int nMaxToCure, effect eVis, effect eVis2, int nCasterLvl, int nMetaMagic ); 

void main()
{
    if (!X2PreSpellCastCode())
    {
		// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }


    //Declare major variables
    int nCasterLvl = GetCasterLevel(OBJECT_SELF);
    
    int nMetaMagic = GetMetaMagicFeat();
    
    effect eVis = EffectVisualEffect( VFX_IMP_SUNSTRIKE );
    effect eVis2 = EffectVisualEffect(VFX_IMP_HEALING_M);
    effect eImpact = EffectVisualEffect(VFX_HIT_CURE_AOE);

	ApplyEffectAtLocation(DURATION_TYPE_INSTANT, eImpact, GetSpellTargetLocation());    

	int nMaxToCure = nCasterLvl;
	int nCuredInFaction = CureFaction( nMaxToCure, eVis, eVis2, nCasterLvl, nMetaMagic );
	nMaxToCure = nMaxToCure - nCuredInFaction;
	CureNearby( nMaxToCure, eVis, eVis2, nCasterLvl, nMetaMagic );

}


void CureObject( object oTarget, effect eVis, effect eVis2, int nCasterLvl, int nMetaMagic )
{
	int nDamagen, nModify, nHurt;
	effect eKill, eHeal;
	float fDelay = GetRandomDelay();
	int nBonus = nCasterLvl;
	if ( nBonus > 20 )
		nBonus = 20;

	// * May 2003: Heal Neutrals as well
	if (spellsIsTarget(oTarget, SPELL_TARGET_ALLALLIES, OBJECT_SELF))
	{
        //Fire cast spell at event for the specified target
        SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId()));
		
	    //Declare major variables
	    object oTarget = GetSpellTargetObject();
	    int nDuration = GetCasterLevel(OBJECT_SELF);
	    int nAmount = 30;
	    int nResistance = 20;
	    int nMetaMagic = GetMetaMagicFeat();
	    effect eCold = EffectDamageResistance(DAMAGE_TYPE_COLD, nResistance, nAmount);
	    effect eFire = EffectDamageResistance(DAMAGE_TYPE_FIRE, nResistance, nAmount);
	    effect eAcid = EffectDamageResistance(DAMAGE_TYPE_ACID, nResistance, nAmount);
	    effect eSonic = EffectDamageResistance(DAMAGE_TYPE_SONIC, nResistance, nAmount);
	    effect eElec = EffectDamageResistance(DAMAGE_TYPE_ELECTRICAL, nResistance, nAmount);
	    effect eDur = EffectVisualEffect( VFX_DUR_SPELL_RESIST_ENERGY );
	    //effect eVis = EffectVisualEffect(VFX_IMP_ELEMENTAL_PROTECTION);
	    //effect eDur2 = EffectVisualEffect(VFX_DUR_CESSATE_POSITIVE);
	
	
	    //Link Effects
	    effect eLink = EffectLinkEffects(eCold, eFire);
	    eLink = EffectLinkEffects(eLink, eAcid);
	    eLink = EffectLinkEffects(eLink, eSonic);
	    eLink = EffectLinkEffects(eLink, eElec);
	    eLink = EffectLinkEffects(eLink, eDur);
	    //eLink = EffectLinkEffects(eLink, eDur2);
	
	    //Enter Metamagic conditions
	    if (nMetaMagic == METAMAGIC_EXTEND)
	    {
	    	nDuration = nDuration *2; //Duration is +100%
	    }
	    
	    RemoveEffectsFromSpell(oTarget, GetSpellId());
	
	    //Apply the VFX impact and effects
	    ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLink, oTarget, TurnsToSeconds(nDuration));
	    //ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);			
    }
}

int CureFaction( int nMaxToCure, effect eVis, effect eVis2, int nCasterLvl, int nMetaMagic ) // returns the # cured
{
	int nNumCured = 0;
	int bPCOnly=FALSE;
	object oTarget = GetFirstFactionMember( OBJECT_SELF, bPCOnly );
    while ( GetIsObjectValid(oTarget) && nNumCured < nMaxToCure )
    {
		CureObject( oTarget, eVis, eVis2, nCasterLvl, nMetaMagic );
		nNumCured++;
		oTarget = GetNextFactionMember( OBJECT_SELF, bPCOnly );
	}

	return nNumCured;
}


int CureNearby( int nMaxToCure, effect eVis, effect eVis2, int nCasterLvl, int nMetaMagic ) // returns the # cured
{
	int nNumCured = 0;

    //Get first target in shape
    object oTarget = GetFirstObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_LARGE, GetSpellTargetLocation());
    while ( GetIsObjectValid(oTarget) && nNumCured < nMaxToCure )
    {
		if ( !GetFactionEqual( oTarget, OBJECT_SELF ) ) // We've already done faction checks
		{
 			CureObject( oTarget, eVis, eVis2, nCasterLvl, nMetaMagic );
			nNumCured++;
		}


        //Get next target in the shape
        oTarget = GetNextObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_LARGE, GetSpellTargetLocation());
    }

	return nNumCured;
}