//::///////////////////////////////////////////////
//:: Mesmerizing Shade
//:: mt_s0_mesmerizingshade
//:: Purpose: Mesmerizing Shade
//:: Created By: Joshua Kalis (Greg)
//:: Created On: September 20, 2015
//:: Description: Daze or attack penalty
//:: Mystery
//::
//:: Targets saves against daze or suffers attack penalty
//:://////////////////////////////////////////////

#include "nwn2_inc_spells"
#include "x2_inc_spellhook"

void main()
{
    if (!X2PreSpellCastCode())
    {
	    // If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	// Get necessary objects
	object oCaster		= OBJECT_SELF;
	location lTarget	= GetLocation(oCaster);
	
	// Get caster level and alignment	
	int nLevelShadowcaster = GetLevelByClass(99, OBJECT_SELF);
	int nLevelMasterOfShadow = GetLevelByClass(100, OBJECT_SELF);
	int nLevelNoctumancer = GetLevelByClass(101, OBJECT_SELF);
	int nCasterLvl = nLevelShadowcaster + nLevelMasterOfShadow + nLevelNoctumancer;
	
	if(nCasterLvl > 5)
		nCasterLvl = 5;
	
    if (GetHasFeat(5198)) // If have mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    if (GetHasFeat(5199)) // If have greater mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	

    //int nDamage = d6(nCasterLvl);
    //if (GetHasFeat(5197)) // If have maximize mystery.
    //{
    //    nDamage = 6 * nCasterLvl;
    //}		
    //if (GetHasFeat(5196)) // Empower mystery.
    //{
    //    nDamage = (nDamage * 2);
    //}		
	
    if (GetHasFeat(5194)) // If have extend mystery, double it.
    {
        nCasterLvl = (nCasterLvl * 2);
    }		
	
	// Effects
	effect eDaze         = EffectDazed();
	effect eWeak         = EffectAttackDecrease(1, ATTACK_BONUS_MISC);
	effect eHit			= EffectVisualEffect(VFX_HIT_SPELL_CASTIGATE);
	effect eVisual		= EffectVisualEffect(VFX_AOE_SPELL_CASTIGATE);
	effect eLink;
	int nSaved;

	ApplyEffectAtLocation(DURATION_TYPE_INSTANT, eVisual, lTarget);
	object oTarget = GetFirstObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_SMALL, lTarget);
	
	// Make sure spell target is valid
	while (GetIsObjectValid(oTarget))
	{
		// check to see if hostile
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, oCaster)) 
		{
			eLink = EffectLinkEffects(eHit, eDaze);
			ApplyEffectToObject(DURATION_TYPE_INSTANT, eLink, oTarget);
	    	SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId(), TRUE));
			
			if (!MySavingThrow(SAVING_THROW_WILL, oTarget, GetSpellSaveDC(), SAVING_THROW_TYPE_MIND_SPELLS))
			{
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eDaze, oTarget, IntToFloat(nCasterLvl));
			}
			else
			{
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eWeak, oTarget, IntToFloat(nCasterLvl));
			}
		}
	}
}
