//::///////////////////////////////////////////////
//:: Mordenkainen's Force Missles
//:: mt_s0_mordforcemissles
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Jan 1, 2007
//:://////////////////////////////////////////////
//:: Purpose: 
/*
You create a powerful missile of magical force, which darts from your fingertips 
and unerringly strikes its target, dealing 2d6 points of damage. The missile then 
bursts in a 5-foot blast of force that inflicts half this amount of damage to any 
creatures in the area (other than the primary target). The primary target is not 
entitled to a saving throw against the burst, but creatures affected by the burst 
may attempt a Reflex save for half damage.

If the missiles' burst areas overlap, secondary targets make only one saving throw 
attempt (and only one SR check, if applicable). A character can be struck by one 
missile (or more) and also be caught in the burst of another missile. In such a case, 
the character may attempt a Reflex save to halve the burst damage, and SR might apply.

The missile strikes unerringly, even if the target is in melee or has anything less 
than total cover or concealment. A caster cannot single out specific parts of a 
creature. The spell can target and damage unattended objects.
*/

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
    // End of Spell Cast Hook

	// Main Variables
	int nNumDice = 2;
	int nTargets = 4;
	int nMaxTargets = 4;
	
	int nCasterLvl = GetCasterLevel(OBJECT_SELF);
	nTargets = nCasterLvl / 3;
	if(nTargets > 7)
		nTargets = 7;

	// Bonus Missile		
	int nLevelForceMissileMage = GetLevelByClass(104, OBJECT_SELF);
	if (GetHasFeat(5226,OBJECT_SELF,TRUE))
	{
		if(nLevelForceMissileMage == 5)
			nTargets = nTargets + 2;
		else
			nTargets = nTargets + 1;
	}		
					
	// For Force Specialization feat from Argent Savant.		
	if (GetHasFeat(5218,OBJECT_SELF,TRUE))
		nNumDice = 3;	

	// Invisible Needle		
	if (GetHasFeat(3096,OBJECT_SELF,TRUE))
		nNumDice += 1;
			
    DoMissileStorm(nNumDice, nTargets, SPELL_ISAACS_LESSER_MISSILE_STORM, VFX_IMP_MAGBLUE, DAMAGE_TYPE_MAGICAL, -1, nMaxTargets);	
}