//::///////////////////////////////////////////////
//:: Vhaerun's Nightshield
//:: mt_s0_nightshield
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Jan 19, 2008
//:://////////////////////////////////////////////

#include "nwn2_inc_spells"
#include "NW_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
// End of Spell Cast Hook

    //Declare major variables
    object oTarget = OBJECT_SELF;
    //effect eVis = EffectVisualEffect(VFX_IMP_AC_BONUS);

    effect eSpell = EffectSpellImmunity(SPELL_MAGIC_MISSILE);
    effect eDur = EffectVisualEffect(VFX_DUR_SPELL_SHIELD);
	int nCasterLvl = GetCasterLevel(OBJECT_SELF);
	int nSaveAmt = nCasterLvl / 3;
	
	if(nSaveAmt < 1)
		nSaveAmt = 1;
	if(nSaveAmt > 6)
		nSaveAmt = 6;

    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nCasterLvl = (nCasterLvl + 3);
        nSaveAmt = (nSaveAmt + 3);
    }	
    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nCasterLvl = (nCasterLvl + 2);
        nSaveAmt = (nSaveAmt + 2);
    }	
    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
        nSaveAmt = (nSaveAmt + 1);
    }			
		
    effect eLink = EffectLinkEffects(eDur, eSpell);

    float fDuration = TurnsToSeconds(nCasterLvl); // * Duration 1 turn
	
	// Abjurant Champion
	int nLevelAbjurantChampion = GetLevelByClass(106, OBJECT_SELF);
	
	// Argent Savant Extend Abjuration
	if (GetHasFeat(5238,OBJECT_SELF,TRUE))
		fDuration = fDuration * 2.0;
	
    fDuration = ApplyMetamagicDurationMods(fDuration);
    int nDurType = ApplyMetamagicDurationTypeMods(DURATION_TYPE_TEMPORARY);

	
    //Fire spell cast at event for target
    SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, 417, FALSE));
    
    RemoveEffectsFromSpell(OBJECT_SELF, GetSpellId());
    
	effect eSave = EffectSavingThrowIncrease(SAVING_THROW_TYPE_SPELL, nSaveAmt);	
	SignalEvent(OBJECT_SELF, EventSpellCastAt(OBJECT_SELF, GetSpellId(), FALSE));
	ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eSave, OBJECT_SELF, fDuration);

	//Apply VFX impact and bonus effects
    //ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
    ApplyEffectToObject(nDurType, eLink, oTarget, fDuration);	
}