//::///////////////////////////////////////////////
//:: Mordenkainen's Disruption
//:: mt_s0_nmorddisp
//:: Purpose: Remove all magic
//:: Created By: Joshua Kalis (Greg)
//:: Created On: September 23, 2015
//:: Description: Shadow magic version of greater dispel magic
//:: Initiate Mystery
//::
//:: Shadows fade, greater dispel magic
//:://////////////////////////////////////////////

#include "x0_i0_spells"
#include "x2_inc_spellhook"

void main()
{
    if (!X2PreSpellCastCode())
    {
        return;
    }
// End of Spell Cast Hook

    effect   eVis         = EffectVisualEffect( VFX_HIT_SPELL_ABJURATION );
	effect   eImpact; // Now handled by spells.2da, the ImpactSEF column, but effect required for spellsDispelMagic
    int      nCasterLevel = GetCasterLevel( OBJECT_SELF );
    object   oTarget      = GetSpellTargetObject();
    location lLocal   =     GetSpellTargetLocation();

	int nLevelShadowcaster = GetLevelByClass(99, OBJECT_SELF);
	int nLevelMasterOfShadow = GetLevelByClass(100, OBJECT_SELF);
	int nLevelNoctumancer = GetLevelByClass(101, OBJECT_SELF);
	int nLevelShadowTheurge = GetLevelByClass(103, OBJECT_SELF);
	int nCasterLvl = nLevelShadowcaster + nLevelMasterOfShadow + nLevelNoctumancer + nLevelShadowTheurge;

	if(nCasterLvl > 25)
		nCasterLvl = 25;
	
    if (GetHasFeat(5198)) // If have mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 2);
    }	
    if (GetHasFeat(5199)) // If have greater mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 3);		
    }	
	
	nCasterLvl = (nCasterLvl + 5);

    if (GetIsObjectValid(oTarget))
    {
        //----------------------------------------------------------------------
        // Targeted Dispel - Dispel all
        //----------------------------------------------------------------------
        spellsDispelMagic(oTarget, nCasterLvl, eVis, eImpact);
		
		if (GetHasFeat(5203)) // If have capture magics shadow feat, chance to restore.
		{
		    int nRoll = d100(1);
			
			if(nRoll <= 4)
			{
				ForceRest(OBJECT_SELF);				
			}
		}	
    }
    else
    {
        //----------------------------------------------------------------------
        // Area of Effect - Only dispel best effect
        //----------------------------------------------------------------------
        oTarget = GetFirstObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_HUGE, lLocal, FALSE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_AREA_OF_EFFECT | OBJECT_TYPE_PLACEABLE);
        while (GetIsObjectValid(oTarget))
        {
            if(GetObjectType(oTarget) == OBJECT_TYPE_AREA_OF_EFFECT)
            {
                //--------------------------------------------------------------
                // Handle Area of Effects
                //--------------------------------------------------------------
                spellsDispelAoE(oTarget, OBJECT_SELF, nCasterLvl);
            }
            else if (GetObjectType(oTarget) == OBJECT_TYPE_PLACEABLE)
            {
                SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId()));
            }
            else
            {
                spellsDispelMagic(oTarget, nCasterLvl, eVis, eImpact, FALSE);
				
				if (GetHasFeat(5203)) // If have capture magics shadow feat, chance to restore.
				{
				    int nRoll = d100(1);
					
					if(nRoll <= 4)
					{
						ForceRest(OBJECT_SELF);				
					}
				}	
            }
            oTarget = GetNextObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_HUGE,lLocal, FALSE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_AREA_OF_EFFECT | OBJECT_TYPE_PLACEABLE);
        }
    }

}