//::///////////////////////////////////////////////
//:: Nybor's Stern Reproof
//:: mt_s0_nyborreproof
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Dec 29, 2007
//:://////////////////////////////////////////////
	
#include "x0_I0_SPELLS"
#include "x2_inc_spellhook"

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
// End of Spell Cast Hook

    //Declare major variables
    object oTarget = GetSpellTargetObject();
    int nCasterLvl = GetCasterLevel(OBJECT_SELF);
    int nMetaMagic = GetMetaMagicFeat();
    int nDamage;
	int nBonus = 1;
    effect eDam;
    effect eVis = EffectVisualEffect(VFX_HIT_SPELL_FINGER_OF_DEATH);

    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nCasterLvl = (nCasterLvl + 3);
        nBonus = (nBonus + 3);
    }	
    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nCasterLvl = (nCasterLvl + 2);
        nBonus = (nBonus + 2);
    }	
    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
        nBonus = (nBonus + 1);
    }	
	
	// BMA-OEI 11/9/06: Allow casting on neutral creatures
    //if(spellsIsTarget(oTarget, SPELL_TARGET_SELECTIVEHOSTILE,OBJECT_SELF))
    if(spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE,OBJECT_SELF)) 
	{
        //GZ: I still signal this event for scripting purposes, even if a placeable
        SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId()));
         if (GetObjectType(oTarget) == OBJECT_TYPE_CREATURE) {

            //Make SR check
            if (!MyResistSpell(OBJECT_SELF, oTarget)) {

			     //Make Will save
                 if (!MySavingThrow(SAVING_THROW_WILL, oTarget, GetSpellSaveDC() + nBonus, SAVING_THROW_TYPE_MIND_SPELLS))
                 {
                    //Apply the death effect and VFX impact
                    ApplyEffectToObject(DURATION_TYPE_INSTANT, EffectDeath(), oTarget);
                    //ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
                 }
                 else
                 {	// make another save or be dazed.
	                 if (!MySavingThrow(SAVING_THROW_WILL, oTarget, GetSpellSaveDC() + nBonus, SAVING_THROW_TYPE_ALL))
						ApplyEffectToObject(DURATION_TYPE_TEMPORARY, EffectDazed(), oTarget, 16.0f);					 	
				 }
                 ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);		// play the impact effect regardless of save
            }
        }
    }
}