//::///////////////////////////////////////////////
//:: Prison of Night
//:: mt_s0_prisonofnight
//:: Purpose: Prison of Night
//:: Created By: Joshua Kalis (Greg)
//:: Created On: October 18, 2015
//:: Description: Traps subject, fortitude to escape, 1D6 cold per round
//:: Mystery
//::
//:: Traps and harms one subject
//:://////////////////////////////////////////////

#include "nwn2_inc_spells"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {
		// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
// End of Spell Cast Hook


    //Declare major variables
    object oTarget = GetSpellTargetObject();
	
    float fDuration = TurnsToSeconds(GetCasterLevel(OBJECT_SELF));
	int nLevelShadowcaster = GetLevelByClass(99, OBJECT_SELF);
	int nLevelMasterOfShadow = GetLevelByClass(100, OBJECT_SELF);
	int nLevelNoctumancer = GetLevelByClass(101, OBJECT_SELF);
	int nLevelShadowTheurge = GetLevelByClass(103, OBJECT_SELF);
	int nCasterLvl = nLevelShadowcaster + nLevelMasterOfShadow + nLevelNoctumancer + nLevelShadowTheurge;
	
    if (GetHasFeat(5198)) // If have mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    if (GetHasFeat(5199)) // If have greater mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    int nBonus = 12 + nCasterLvl;
		
    if (GetHasFeat(5194)) // If have extend mystery, double it.
    {
        nCasterLvl = (nCasterLvl * 2);
    }		
	fDuration = RoundsToSeconds(nCasterLvl);

    //Make sure the target is a monster
	if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
	{
		//Make a Fortitude Save
		if (!MySavingThrow(SAVING_THROW_FORT, oTarget, GetSpellSaveDC()+8, SAVING_THROW_TYPE_ALL))
		{
			//Declare major variables
		    effect eTrapped = EffectStunned();
			effect eAcid = EffectDamageResistance(DAMAGE_TYPE_ACID, 99000, 99000);
			effect eBludgeoning = EffectDamageResistance(DAMAGE_TYPE_BLUDGEONING, 99000, 99000);
			effect eDivine = EffectDamageResistance(DAMAGE_TYPE_DIVINE, 99000, 99000);
			effect eElectrical = EffectDamageResistance(DAMAGE_TYPE_ELECTRICAL, 99000, 99000);
			effect eFire = EffectDamageResistance(DAMAGE_TYPE_FIRE, 99000, 99000);
			effect eMagical = EffectDamageResistance(DAMAGE_TYPE_MAGICAL, 99000, 99000);
			effect eNegative = EffectDamageResistance(DAMAGE_TYPE_NEGATIVE, 99000, 99000);
			effect ePiercing = EffectDamageResistance(DAMAGE_TYPE_PIERCING, 99000, 99000);
			effect ePositive = EffectDamageResistance(DAMAGE_TYPE_POSITIVE, 99000, 99000);
			effect eSlashing = EffectDamageResistance(DAMAGE_TYPE_SLASHING, 99000, 99000);
			effect eSonic = EffectDamageResistance(DAMAGE_TYPE_SONIC, 99000, 99000);
			effect eVis = EffectVisualEffect(VFX_DUR_SPELL_GLOBE_INV_GREAT);
			eTrapped = EffectLinkEffects(eTrapped, eVis);
			eTrapped = EffectLinkEffects(eTrapped, eAcid);
			eTrapped = EffectLinkEffects(eTrapped, eBludgeoning);
			eTrapped = EffectLinkEffects(eTrapped, eDivine);
			eTrapped = EffectLinkEffects(eTrapped, eElectrical);
			eTrapped = EffectLinkEffects(eTrapped, eFire);
			eTrapped = EffectLinkEffects(eTrapped, eMagical);
			eTrapped = EffectLinkEffects(eTrapped, eNegative);
			eTrapped = EffectLinkEffects(eTrapped, ePiercing);
			eTrapped = EffectLinkEffects(eTrapped, ePositive);
			eTrapped = EffectLinkEffects(eTrapped, eSlashing);
			eTrapped = EffectLinkEffects(eTrapped, eSonic);
			ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eTrapped, oTarget, fDuration);		
			SetIsTemporaryEnemy(oTarget, OBJECT_SELF, FALSE, fDuration);
			
		    //Set Damage Over Time
		    int nDamage = d6(1);
		    if (GetHasFeat(5198)) // If have mystery focus, add 1 more.
		    {
		        nDamage = (nDamage + 1);
		    }	
		    if (GetHasFeat(5199)) // If have greater mystery focus, add 1 more.
		    {
		        nDamage = (nDamage + 1);
		    }	
			
		    effect eCold;
		    eCold = EffectDamage(nDamage, DAMAGE_TYPE_COLD, DAMAGE_POWER_NORMAL, FALSE);
		    ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eCold, oTarget, fDuration);
		}
	}		
}