//::///////////////////////////////////////////////
//:: Rainbow Blast
//:: mt_s0_rainbowblast
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Jan 24, 2007
//:://////////////////////////////////////////////
/*
    Does 1d6 per level in a 5ft tube for 30m
*/

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
// End of Spell Cast Hook


    //Declare major variables
	effect eVis;
	int nCasterLvl = GetCasterLevel(OBJECT_SELF);

    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nCasterLvl = (nCasterLvl + 3);
    }	
    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nCasterLvl = (nCasterLvl + 2);
    }	
    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
		
    int nDamage;
    int nMetaMagic = GetMetaMagicFeat();
    effect eDamage;
    object oTarget = GetSpellTargetObject();
    location lTarget = GetLocation(oTarget);
	location lTarget2 = GetSpellTargetLocation();
    object oNextTarget, oTarget2;
    float fDelay;
    int nCnt = 1;
	
    //Set the lightning stream to start at the caster's hands
    effect eLightning = EffectBeam(VFX_BEAM_SONIC, OBJECT_SELF, BODY_NODE_HAND);	
	
	// If you target a location, this will spawn in an invisible creature to act as the endpoint on the beam, then delete itself
	object oPoint = CreateObject(OBJECT_TYPE_CREATURE, "c_attachspellnode" , lTarget2);
	
	SetScriptHidden(oPoint, TRUE);
	
	ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLightning, oPoint, 1.0);
	ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oPoint);
	DestroyObject(oPoint, 2.0);
	
	//CreateObject(OBJECT_TYPE_WAYPOINT, sTarget2, lTarget2);
	//object oPoint = GetObjectByTag(sTarget2);
	//ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLightning, oPoint, 1.0);
	//PrettyDebug("Lightning bolt!  Woo Hoo!");
    oTarget2 = GetNearestObject(OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE, OBJECT_SELF, nCnt);
	
    while(GetIsObjectValid(oTarget2) && GetDistanceToObject(oTarget2) <= 30.0)
    {
        //Get first target in the lightning area by passing in the location of first target and the casters vector (position)
        oTarget = GetFirstObjectInShape(SHAPE_SPELLCYLINDER, 30.0, lTarget2, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE, GetPosition(OBJECT_SELF));
		
		//PrettyDebug("investigating target " + GetName(oTarget));
        while (GetIsObjectValid(oTarget))
        {
           //Exclude the caster from the damage effects
           if (oTarget != OBJECT_SELF && oTarget2 == oTarget)
           {
                if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
            	{
                   //Fire cast spell at event for the specified target
					//PrettyDebug("Signaling Lightning Bolt on " + GetName(oTarget));
                   SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId()));
				   
                   //Make an SR check
                   if (!MyResistSpell(OBJECT_SELF, oTarget))
        	       {
				   		// 1. Calculate how much damage each energy type does.
						if(nCasterLvl < 7) {						
						    //Roll damage
	                        nDamage =  d6(1);
	        		        //Enter Metamagic conditions
	        		        if (nMetaMagic & METAMAGIC_MAXIMIZE)
	        		        {
	        			         nDamage = 6 * nCasterLvl;//Damage is at max
	                        }
	        		        else if (nMetaMagic & METAMAGIC_EMPOWER)
	        		        {
	        			         nDamage = nDamage + (nDamage/2); //Damage/Healing is +50%
	                        }
	                        //Adjust damage based on Reflex Save, Evasion and Improved Evasion
	                        nDamage = GetReflexAdjustedDamage(nDamage, oTarget, GetSpellSaveDC(),SAVING_THROW_TYPE_ALL);
						}
						else if(nCasterLvl < 9) {
						    //Roll damage
	                        nDamage =  d8(1);
	        		        //Enter Metamagic conditions
	        		        if (nMetaMagic & METAMAGIC_MAXIMIZE)
	        		        {
	        			         nDamage = 8 * nCasterLvl;//Damage is at max
	                        }
	        		        else if (nMetaMagic & METAMAGIC_EMPOWER)
	        		        {
	        			         nDamage = nDamage + (nDamage/2); //Damage/Healing is +50%
	                        }
	                        //Adjust damage based on Reflex Save, Evasion and Improved Evasion
	                        nDamage = GetReflexAdjustedDamage(nDamage, oTarget, GetSpellSaveDC(),SAVING_THROW_TYPE_ALL);
						}
						else if(nCasterLvl < 11) {
						    //Roll damage
	                        nDamage =  d10(1);
	        		        //Enter Metamagic conditions
	        		        if (nMetaMagic & METAMAGIC_MAXIMIZE)
	        		        {
	        			         nDamage = 10 * nCasterLvl;//Damage is at max
	                        }
	        		        else if (nMetaMagic & METAMAGIC_EMPOWER)
	        		        {
	        			         nDamage = nDamage + (nDamage/2); //Damage/Healing is +50%
	                        }
	                        //Adjust damage based on Reflex Save, Evasion and Improved Evasion
	                        nDamage = GetReflexAdjustedDamage(nDamage, oTarget, GetSpellSaveDC(),SAVING_THROW_TYPE_ALL);
						}
						else if(nCasterLvl < 13) {
						    //Roll damage
	                        nDamage =  d12(1);
	        		        //Enter Metamagic conditions
	        		        if (nMetaMagic & METAMAGIC_MAXIMIZE)
	        		        {
	        			         nDamage = 12 * nCasterLvl;//Damage is at max
	                        }
	        		        else if (nMetaMagic & METAMAGIC_EMPOWER)
	        		        {
	        			         nDamage = nDamage + (nDamage/2); //Damage/Healing is +50%
	                        }
	                        //Adjust damage based on Reflex Save, Evasion and Improved Evasion
	                        nDamage = GetReflexAdjustedDamage(nDamage, oTarget, GetSpellSaveDC(),SAVING_THROW_TYPE_ALL);
						}
						else if(nCasterLvl < 15) {
						    //Roll damage
	                        nDamage =  d12(1) + 2;
	        		        //Enter Metamagic conditions
	        		        if (nMetaMagic & METAMAGIC_MAXIMIZE)
	        		        {
	        			         nDamage = 14 * nCasterLvl;//Damage is at max
	                        }
	        		        else if (nMetaMagic & METAMAGIC_EMPOWER)
	        		        {
	        			         nDamage = nDamage + (nDamage/2); //Damage/Healing is +50%
	                        }
	                        //Adjust damage based on Reflex Save, Evasion and Improved Evasion
	                        nDamage = GetReflexAdjustedDamage(nDamage, oTarget, GetSpellSaveDC(),SAVING_THROW_TYPE_ALL);
						}
						else if(nCasterLvl < 17) {
						    //Roll damage
	                        nDamage =  d12(1) + 4;
	        		        //Enter Metamagic conditions
	        		        if (nMetaMagic & METAMAGIC_MAXIMIZE)
	        		        {
	        			         nDamage = 16 * nCasterLvl;//Damage is at max
	                        }
	        		        else if (nMetaMagic & METAMAGIC_EMPOWER)
	        		        {
	        			         nDamage = nDamage + (nDamage/2); //Damage/Healing is +50%
	                        }
	                        //Adjust damage based on Reflex Save, Evasion and Improved Evasion
	                        nDamage = GetReflexAdjustedDamage(nDamage, oTarget, GetSpellSaveDC(),SAVING_THROW_TYPE_ALL);
						}
						else {
						    //Roll damage
	                        nDamage =  d12(1) + 6;
	        		        //Enter Metamagic conditions
	        		        if (nMetaMagic & METAMAGIC_MAXIMIZE)
	        		        {
	        			         nDamage = 18 * nCasterLvl;//Damage is at max
	                        }
	        		        else if (nMetaMagic & METAMAGIC_EMPOWER)
	        		        {
	        			         nDamage = nDamage + (nDamage/2); //Damage/Healing is +50%
	                        }
	                        //Adjust damage based on Reflex Save, Evasion and Improved Evasion
	                        nDamage = GetReflexAdjustedDamage(nDamage, oTarget, GetSpellSaveDC(),SAVING_THROW_TYPE_ALL);
						}

						// 2. Apply effect for each of five energy types.						
						// a. Sonic
						// Set visibility effect.
					    eVis  = EffectVisualEffect(VFX_HIT_SPELL_SONIC);

						//Set damage effect
                        eDamage = EffectDamage(nDamage, DAMAGE_TYPE_SONIC);
                        if(nDamage > 0)
                        {
                            fDelay = GetSpellEffectDelay(GetLocation(oTarget), oTarget);
							
                            //Apply VFX impcat, damage effect and lightning effect
                            DelayCommand(fDelay, ApplyEffectToObject(DURATION_TYPE_INSTANT,eDamage,oTarget));
                            DelayCommand(fDelay, ApplyEffectToObject(DURATION_TYPE_INSTANT,eVis,oTarget));
                        }
						
						// b. Acid
						// Set visibility effect.
					    eVis  = EffectVisualEffect(VFX_HIT_SPELL_ACID);

						//Set damage effect
                        eDamage = EffectDamage(nDamage, DAMAGE_TYPE_ACID);
                        if(nDamage > 0)
                        {
                            fDelay = GetSpellEffectDelay(GetLocation(oTarget), oTarget);
                            //Apply VFX impcat, damage effect and lightning effect
                            DelayCommand(fDelay, ApplyEffectToObject(DURATION_TYPE_INSTANT,eDamage,oTarget));
                            DelayCommand(fDelay, ApplyEffectToObject(DURATION_TYPE_INSTANT,eVis,oTarget));
                        }
						
						// c. Fire
						// Set visibility effect.
					    eVis  = EffectVisualEffect(VFX_HIT_SPELL_FIRE);

						//Set damage effect
                        eDamage = EffectDamage(nDamage, DAMAGE_TYPE_FIRE);
                        if(nDamage > 0)
                        {
                            fDelay = GetSpellEffectDelay(GetLocation(oTarget), oTarget);
                            //Apply VFX impcat, damage effect and lightning effect
                            DelayCommand(fDelay, ApplyEffectToObject(DURATION_TYPE_INSTANT,eDamage,oTarget));
                            DelayCommand(fDelay, ApplyEffectToObject(DURATION_TYPE_INSTANT,eVis,oTarget));
                        }

						// d. Cold
						// Set visibility effect.
					    eVis  = EffectVisualEffect(VFX_HIT_SPELL_ICE);

						//Set damage effect
						int nDmgType = DAMAGE_TYPE_COLD;	
						
                        eDamage = EffectDamage(nDamage, nDmgType);
                        if(nDamage > 0)
                        {
                            fDelay = GetSpellEffectDelay(GetLocation(oTarget), oTarget);
                            //Apply VFX impcat, damage effect and lightning effect
                            DelayCommand(fDelay, ApplyEffectToObject(DURATION_TYPE_INSTANT,eDamage,oTarget));
                            DelayCommand(fDelay, ApplyEffectToObject(DURATION_TYPE_INSTANT,eVis,oTarget));
                        }

						// e. Lightning
						// Set visibility effect.
					    eVis  = EffectVisualEffect(VFX_HIT_SPELL_LIGHTNING);

						//Set damage effect
                        eDamage = EffectDamage(nDamage, DAMAGE_TYPE_ELECTRICAL);
                        if(nDamage > 0)
                        {
                            fDelay = GetSpellEffectDelay(GetLocation(oTarget), oTarget);
                            //Apply VFX impcat, damage effect and lightning effect
                            DelayCommand(fDelay, ApplyEffectToObject(DURATION_TYPE_INSTANT,eDamage,oTarget));
                            DelayCommand(fDelay, ApplyEffectToObject(DURATION_TYPE_INSTANT,eVis,oTarget));
                        }
												
					}
                    ApplyEffectToObject(DURATION_TYPE_TEMPORARY,eLightning,oTarget,1.0);
					
                    //Set the currect target as the holder of the lightning effect
                    oNextTarget = oTarget;
                    eLightning = EffectBeam(VFX_BEAM_SONIC, oNextTarget, BODY_NODE_CHEST);
					
					if (GetHasFeat(5212,OBJECT_SELF,TRUE)) // Diabolism
					{
						int nLevelDiabolist = GetLevelByClass(96, OBJECT_SELF);
						if(nLevelDiabolist == 10)
							nDamage = 3;
						else if(nLevelDiabolist == 5)
							nDamage = 2;
						else
							nDamage = 1;	
						
		                effect eDam2 = EffectDamage(nDamage, DAMAGE_TYPE_NEGATIVE);
						ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam2, oTarget);
					}

					if (GetHasFeat(5213,OBJECT_SELF,TRUE)) // Vile Diabolism
					{
						nDamage = 1;
		                effect eDam3 = EffectDamage(nDamage, DAMAGE_TYPE_MAGICAL);
						ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam3, oTarget);
					}						
                }
           }
           //Get the next object in the lightning cylinder
           oTarget = GetNextObjectInShape(SHAPE_SPELLCYLINDER, 30.0, lTarget2, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE, GetPosition(OBJECT_SELF));
        }
        nCnt++;
        oTarget2 = GetNearestObject(OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE, OBJECT_SELF, nCnt);
    }
}