//::///////////////////////////////////////////////
//:: Wall of Fire: On Enter
//:: NW_S0_WallFireA.nss
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Person within the AoE take 4d6 fire damage
    per round.
	
	Reeron modified on 3-9-07
	Removed saving throw check as there is none per 
	PnP rules. Redid damage calculation as damage is 
	2d6 +casterlevel(max casterlevel is 20). It was 
	being capped at max damage=20.
	
	
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: May 17, 2001
//:://////////////////////////////////////////////

// (Update JLR - OEI 07/19/05) -- Changed Dmg to 2d6 + lvl (max 20), double dmg to Undead


#include "X0_I0_SPELLS"
#include "x2_inc_spellhook"

void RunDelay( int nDuration );
void RunDelay2 ( int nCounter );
location lTarget = GetSpellTargetLocation();
string feedback;
object oCaster = OBJECT_SELF;
int nCasterLevel2 = GetCasterLevel(OBJECT_SELF);
int nRand = Random(100)+1;
int nCounter = 0;

void main()
{
    if (!X2PreSpellCastCode())
    {
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
	
    //Declare major variables
    effect eAOE = EffectAreaOfEffect(299);
    effect eDur = EffectVisualEffect( VFX_DUR_SPELL_CREEPING_DOOM );
    effect eLink = EffectLinkEffects(eAOE, eDur);
	int nCasterLvl = nCasterLevel2;
    int nMetaMagic = GetMetaMagicFeat();
	
    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nCasterLvl = (nCasterLvl + 3);
    }	
    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nCasterLvl = (nCasterLvl + 2);
    }	
    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
	
    if (GetHasFeat(3094)) // If have fiery burst, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    if (GetHasFeat(5036)) // fire adept
    {
        nCasterLvl = (nCasterLvl + 1);
    }
    if (GetHasFeat(5264)) // blooding of fire
    {
        nCasterLvl = (nCasterLvl + 1);
    }
	
	int nDuration = nCasterLvl;
	
    //Check Extend metamagic feat.
    if (nMetaMagic & METAMAGIC_EXTEND)
    {
	   nDuration = nDuration * 2;//Duration is +100%
    }
	
    ApplyEffectAtLocation(DURATION_TYPE_TEMPORARY, eLink, lTarget, RoundsToSeconds(nDuration));
	
    //Capture the first target object in the shape.
    object oTarget = GetFirstObjectInShape(SHAPE_SPHERE, 3.3, lTarget, TRUE, OBJECT_TYPE_AREA_OF_EFFECT);
    while (GetIsObjectValid(oTarget))
    {
        //feedback="while";
        //SendMessageToPC(OBJECT_SELF, feedback);
        if (GetObjectType(oTarget) == OBJECT_TYPE_AREA_OF_EFFECT)
        {//if (GZGetDelayedSpellEffectsExpired(39, oTarget, oCaster)) {return;}
		 string AOE = GetTag(oTarget);
         //feedback=AOE;
         //SendMessageToPC(OBJECT_SELF, feedback);
         if (AOE == "VFX_PER_RAISTLIN_FIRERING")
            {
               ApplyEffectToObject( DURATION_TYPE_TEMPORARY, eDur, oTarget, 30.0 );
               if (GetLocalInt(oTarget, "IsThisTheRightOne")<1)
               {
               SetLocalInt(oTarget, "IsThisTheRightOne", nRand);
               //FloatingTextStringOnCreature("nRand set to: "+IntToString(nRand), OBJECT_SELF);
               }

			   int nDamage = 0;
				if (GetHasFeat(5212,OBJECT_SELF,TRUE)) // Diabolism
				{
					int nLevelDiabolist = GetLevelByClass(96, OBJECT_SELF);
					if(nLevelDiabolist == 10)
						nDamage = 3;
					else if(nLevelDiabolist == 5)
						nDamage = 2;
					else
						nDamage = 1;	
					
	                effect eDam2 = EffectDamage(nDamage, DAMAGE_TYPE_NEGATIVE);
					ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam2, oTarget);
				}

				if (GetHasFeat(5213,OBJECT_SELF,TRUE)) // Vile Diabolism
				{
					nDamage = 1;
	                effect eDam3 = EffectDamage(nDamage, DAMAGE_TYPE_MAGICAL);
					ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam3, oTarget);
				}						
			   			   
            }
        }
        oTarget = GetNextObjectInShape(SHAPE_SPHERE, 3.3, lTarget, TRUE, OBJECT_TYPE_AREA_OF_EFFECT);
    }

    DelayCommand(5.9f,RunDelay(nDuration));
}
	
void RunDelay( int nDuration )
{
    if (nCounter < nDuration)
	{
        object oTarget = GetFirstObjectInShape(SHAPE_SPHERE, 3.3, lTarget, TRUE, OBJECT_TYPE_AREA_OF_EFFECT);	
        while (GetIsObjectValid(oTarget))
        {
    
        //feedback="while";
        //SendMessageToPC(OBJECT_SELF, feedback);
            if (GetObjectType(oTarget) == OBJECT_TYPE_AREA_OF_EFFECT)
            {
    		 string AOE = GetTag(oTarget);
             //feedback=AOE;
             //SendMessageToPC(OBJECT_SELF, feedback);
             if (AOE == "VFX_PER_RAISTLIN_FIRERING")
                {
                   if (GetLocalInt(oTarget, "IsThisTheRightOne")==nRand)
                   {
                   //FloatingTextStringOnCreature("nRand = "+IntToString(nRand), OBJECT_SELF);
                   RunDelay2(nCounter+1);
                   }
                   //FloatingTextStringOnCreature("VFX_PER_DELAY_BLAST_FIREBALL", OBJECT_SELF);
                }
            }
            oTarget = GetNextObjectInShape(SHAPE_SPHERE, 3.3, lTarget, TRUE, OBJECT_TYPE_AREA_OF_EFFECT);
        }
        nCounter+=1;
        DelayCommand(6.0f,RunDelay(nDuration));
	}
    else
    {
		DestroyObject(OBJECT_SELF, 1.0);
	}
}

void RunDelay2(int nCounter)
{
    //object oCaster = OBJECT_SELF;
    int nDamage;
    int nMetaMagic = GetMetaMagicFeat();
    int nCasterLevel = GetCasterLevel(oCaster);
	
    effect eDam;
    effect eVis = EffectVisualEffect(VFX_HIT_SPELL_FIRE);

            //Cycle through the targets in the explosion area
            object oTarget = GetFirstObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_SMALL, lTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);
            while(GetIsObjectValid(oTarget))
            {
                    //Fire cast spell at event for the specified target
                    SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, 2444));
                    //Make SR check
                    if (!MyResistSpell(OBJECT_SELF, oTarget))
                    {
                        nDamage = d6(nCounter);
                        //Enter Metamagic conditions
                        if (nMetaMagic & METAMAGIC_MAXIMIZE)
                        {
                            nDamage = 6 * (nCounter);//Damage is at max
                        }
                        else if (nMetaMagic & METAMAGIC_EMPOWER)
                        {
                            nDamage = nDamage + (nDamage/2);//Damage/Healing is +50%
                        }
                        //Change damage according to Reflex, Evasion and Improved Evasion
                        nDamage = GetReflexAdjustedDamage(nDamage, oTarget, GetSpellSaveDC(), SAVING_THROW_TYPE_FIRE, OBJECT_SELF);
						
                        //Set up the damage effect
                        eDam = EffectDamage(nDamage, DAMAGE_TYPE_FIRE);
                        if(nDamage > 0)
                        {
                            //Apply VFX impact and damage effect
                            ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
                            DelayCommand(0.01, ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam, oTarget));
                        }						
                    }
					
                //Get next target in the sequence
                oTarget = GetNextObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_SMALL, lTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);
            }
}		