//::///////////////////////////////////////////////
//:: Ray of Deanimation
//:: mt_s0_rayofdeanimation
//:: Purpose: Touched ranged attack that attempts to harm a construct. 1d6 per level to max of 15d6 of magical damage.
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Nov 5, 2015
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	//Declare major variables
	object oTarget = GetSpellTargetObject();
    int nMetaMagic = GetMetaMagicFeat();
		
	if (GetIsObjectValid(oTarget) && (GetRacialType(oTarget) == RACIAL_TYPE_CONSTRUCT))
	{
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
		{
			int nRangedTouch = TouchAttackRanged(oTarget);
			if (nRangedTouch != TOUCH_ATTACK_RESULT_MISS)
			{
			    //Declare major variables
			    object oCaster = OBJECT_SELF;
			    int nCasterLvl = 20;
			    int nDamage, nDamage2;
				
			    effect eVis = EffectVisualEffect(VFX_HIT_SPELL_ABJURATION);
			    effect eDamage;
				effect eLink;
				
				int nCasterLvL = GetCasterLevel(OBJECT_SELF);
				if(nCasterLvl > 15)
					nCasterLvl = 15;

				nDamage = d6(nCasterLvl);
									
		        if (nMetaMagic == METAMAGIC_EMPOWER)
		        {
		             nDamage = (nDamage * 2);
		        }
		        if (nMetaMagic == METAMAGIC_MAXIMIZE)
		        {
		             nDamage = 15 * 6;
		        }				

				// If have spell specialization feat add +2 to the difficulty
				if (GetHasFeat(2992,OBJECT_SELF,TRUE))
					nDamage += 2;

				eDamage = EffectDamage(nDamage, DAMAGE_TYPE_MAGICAL, DAMAGE_POWER_NORMAL, 0);
				eLink = EffectLinkEffects(eDamage, eVis);
	        	ApplyEffectToObject( DURATION_TYPE_INSTANT, eLink, oTarget);					
			}						
		}	
	}
	else
	{
		SendMessageToPC(OBJECT_SELF, "Ray of Deanimation only works against constructs.");
	}			
}