//::///////////////////////////////////////////////
//:: Ray of Entropy
//:: mt_s0_rayofentropy
//:: Purpose: Touched ranged attack that causes -4 STR/DEX/CON for 1 round/level.
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Nov 5, 2015
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	//Declare major variables
	object oTarget = GetSpellTargetObject();
    int nMetaMagic = GetMetaMagicFeat();
	int nCasterLvl = GetCasterLevel(OBJECT_SELF);
	
    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nCasterLvl = (nCasterLvl + 3);
    }	
    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nCasterLvl = (nCasterLvl + 2);
    }	
    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
	
	float fDelay = 0.0;
		
	if (GetIsObjectValid(oTarget))
	{
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
		{
			int nRangedTouch = TouchAttackRanged(oTarget);
			if (nRangedTouch != TOUCH_ATTACK_RESULT_MISS)
			{
			    //Declare major variables
			    object oCaster = OBJECT_SELF;
			    int nCasterLvl = 20;
			    int nAmount = 4;

				// If have spell specialization feat add +2
				if (GetHasFeat(2992,OBJECT_SELF,TRUE))
					nAmount += 2;
								
			    effect eVis = EffectVisualEffect(VFX_HIT_SPELL_ABJURATION);
			    effect eStr, eDex, eCon;
				effect eLink;
				
                if (!MyResistSpell(OBJECT_SELF, oTarget, fDelay))
        	    {
					eStr = EffectAbilityDecrease(ABILITY_STRENGTH, nAmount);
					eDex = EffectAbilityDecrease(ABILITY_DEXTERITY, nAmount);
					eCon = EffectAbilityDecrease(ABILITY_CONSTITUTION, nAmount);
					eLink = EffectLinkEffects(eStr, eVis);
					eLink = EffectLinkEffects(eLink, eDex);
					eLink = EffectLinkEffects(eLink, eCon);
					
		        	ApplyEffectToObject( DURATION_TYPE_TEMPORARY, eLink, oTarget, RoundsToSeconds(nCasterLvl));					
				}
			}						
		}	
	}			
}