//::///////////////////////////////////////////////
//:: Ray of Ice
//:: mt_s0_rayofice
//:: Purpose: Touched ranged attack that does 1d6/2 levels of cold damage, max 5d6. Failed reflex save holds the target there 3 rounds, -4 dex, -2 attack.
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Nov 5, 2015
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	//Declare major variables
	object oTarget = GetSpellTargetObject();
    int nMetaMagic = GetMetaMagicFeat();
		
	if (GetIsObjectValid(oTarget))
	{
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
		{
			int nRangedTouch = TouchAttackRanged(oTarget);
			if (nRangedTouch != TOUCH_ATTACK_RESULT_MISS)
			{
			    //Declare major variables
			    object oCaster = OBJECT_SELF;
			    int nCasterLvl = 20;
			    int nDamage, nDamage2;
				
			    effect eVis = EffectVisualEffect(VFX_HIT_SPELL_ICE);
			    effect eDamage;
				effect eLink;
				
		        if (!MyResistSpell(OBJECT_SELF, oTarget))
		        {
					int nCasterLvL = GetCasterLevel(OBJECT_SELF) / 2;
					if(nCasterLvl > 5)
						nCasterLvl = 5;
	
				    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
				    {
				        nCasterLvl = (nCasterLvl + 3);
				    }	
				    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
				    {
				        nCasterLvl = (nCasterLvl + 2);
				    }	
				    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
				    {
				        nCasterLvl = (nCasterLvl + 1);
				    }	
					
				    if (GetHasFeat(3101)) // If have winters blast, add 1 more.
				    {
				        nCasterLvl = (nCasterLvl + 1);
				    }	
						
					nDamage = d6(nCasterLvl);					
					
			        if (nMetaMagic == METAMAGIC_EMPOWER)
			        {
			             nDamage = (nDamage * 2);
			        }
			        if (nMetaMagic == METAMAGIC_MAXIMIZE)
			        {
			             nDamage = nCasterLvl * 6;
			        }				
					
					// If have spell specialization feat add +2
					if (GetHasFeat(2992,OBJECT_SELF,TRUE))
						nDamage += 2;
															
					eDamage = EffectDamage(nDamage, DAMAGE_TYPE_COLD, DAMAGE_POWER_NORMAL, 0);
					eLink = EffectLinkEffects(eDamage, eVis);
		        	ApplyEffectToObject( DURATION_TYPE_INSTANT, eLink, oTarget);
					
					// See if they catch fire, reflex saving throw of 14
					if(!MySavingThrow(SAVING_THROW_REFLEX, oTarget, 14))
					{
						effect eSlow = EffectMovementSpeedDecrease(100);
						
						int nAttackPenalty = 2;
						// If have spell specialization feat add +2
						if (GetHasFeat(2992,OBJECT_SELF,TRUE))
							nAttackPenalty += 2;
						
						effect eAttack = EffectAttackDecrease(nAttackPenalty, ATTACK_BONUS_MISC);
						effect eDex = EffectAbilityDecrease(ABILITY_DEXTERITY, 4);
						
						eLink = EffectLinkEffects(eSlow, eAttack);
						eLink = EffectLinkEffects(eLink, eDex);
			        	ApplyEffectToObject( DURATION_TYPE_TEMPORARY, eLink, oTarget, RoundsToSeconds(3));
					}					

					if (GetHasFeat(5212,OBJECT_SELF,TRUE)) // Diabolism
					{
						int nLevelDiabolist = GetLevelByClass(96, OBJECT_SELF);
						if(nLevelDiabolist == 10)
							nDamage = 3;
						else if(nLevelDiabolist == 5)
							nDamage = 2;
						else
							nDamage = 1;	
						
		                effect eDam2 = EffectDamage(nDamage, DAMAGE_TYPE_NEGATIVE);
						ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam2, oTarget);
					}

					if (GetHasFeat(5213,OBJECT_SELF,TRUE)) // Vile Diabolism
					{
						nDamage = 1;
		                effect eDam3 = EffectDamage(nDamage, DAMAGE_TYPE_MAGICAL);
						ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam3, oTarget);
					}																
				}
			}						
		}	
	}			
}