//::///////////////////////////////////////////////
//:: Ray of Light
//:: mt_s0_rayoflight
//:: Purpose: Touched ranged attack that blinds a subject for 1d4+1 rounds.
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Nov 5, 2015
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	//Declare major variables
	object oTarget = GetSpellTargetObject();
    int nMetaMagic = GetMetaMagicFeat();
		
	if (GetIsObjectValid(oTarget))
	{
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
		{
			int nRangedTouch = TouchAttackRanged(oTarget);
			if (nRangedTouch != TOUCH_ATTACK_RESULT_MISS)
			{
			    //Declare major variables
			    object oCaster = OBJECT_SELF;
			    int nCasterLvl = 20;
			    int nTime = d4(1) + 1;
				int nBonus = 4;
				
			    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
			    {
			        nBonus = (nBonus + 3);
			    }	
			    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
			    {
			        nBonus = (nBonus + 2);
			    }	
			    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
			    {
			        nBonus = (nBonus + 1);
			    }	
				
           	    if (nMetaMagic & METAMAGIC_EXTEND)
                {
					nTime = nTime * 2;
				}
				
				// If have spell specialization feat add +2
				if (GetHasFeat(2992,OBJECT_SELF,TRUE))
					nTime += 2;
				
								
			    effect eVis = EffectVisualEffect(VFX_HIT_SPELL_ABJURATION);
			    effect eDamage;
				effect eLink;
				
				// Fortitude Save
				if(!MySavingThrow(SAVING_THROW_FORT, oTarget, GetSpellSaveDC()+ nBonus))
		        {
					eDamage = EffectBlindness();
					eLink = EffectLinkEffects(eDamage, eVis);
		        	ApplyEffectToObject( DURATION_TYPE_TEMPORARY, eLink, oTarget, RoundsToSeconds(nTime));					
					
					int nDamage = 0;
					if (GetHasFeat(5212,OBJECT_SELF,TRUE)) // Diabolism
					{
						int nLevelDiabolist = GetLevelByClass(96, OBJECT_SELF);
						if(nLevelDiabolist == 10)
							nDamage = 3;
						else if(nLevelDiabolist == 5)
							nDamage = 2;
						else
							nDamage = 1;	
						
		                effect eDam2 = EffectDamage(nDamage, DAMAGE_TYPE_NEGATIVE);
						ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam2, oTarget);
					}

					if (GetHasFeat(5213,OBJECT_SELF,TRUE)) // Vile Diabolism
					{
						nDamage = 1;
		                effect eDam3 = EffectDamage(nDamage, DAMAGE_TYPE_MAGICAL);
						ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam3, oTarget);
					}						
				}
			}						
		}	
	}			
}