//::///////////////////////////////////////////////
//:: Ray of Stupidity
//:: mt_s0_rayofstupidity
//:: Purpose: Touched ranged attack that does 1d4+1 intelligence damage.
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Nov 5, 2015
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	//Declare major variables
	object oTarget = GetSpellTargetObject();
    int nMetaMagic = GetMetaMagicFeat();
		
	if (GetIsObjectValid(oTarget))
	{
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
		{
			int nRangedTouch = TouchAttackRanged(oTarget);
			if (nRangedTouch != TOUCH_ATTACK_RESULT_MISS)
			{
			    //Declare major variables
			    object oCaster = OBJECT_SELF;
			    int nCasterLvl = 20;
			    int nDamage, nDamage2;
				
			    effect eVis = EffectVisualEffect(VFX_HIT_SPELL_ABJURATION);
			    effect eDamage;
				effect eLink;
				
		        if (!MyResistSpell(OBJECT_SELF, oTarget))
		        {
					int nCasterLvL = GetCasterLevel(OBJECT_SELF) / 2;
					if(nCasterLvl > 5)
						nCasterLvl = 5;
	
					int nDamage = d4(1) + 1;

					// If have spell specialization feat add +2 intelligence damage
					if (GetHasFeat(2992,OBJECT_SELF,TRUE))
						nDamage += 2;
					
			        if (nMetaMagic == METAMAGIC_EMPOWER)
			        {
			             nDamage = (nDamage * 2);
			        }
			        if (nMetaMagic == METAMAGIC_MAXIMIZE)
			        {
			             nDamage = 7;
			        }				
															
					eDamage = EffectAbilityDecrease(ABILITY_INTELLIGENCE, nDamage);
		        	ApplyEffectToObject( DURATION_TYPE_PERMANENT, eDamage, oTarget);
				}
			}						
		}	
	}			
}