//::///////////////////////////////////////////////
//:: Ray of Weakness
//:: mt_s0_rayofweakness
//:: Purpose: Touched ranged attack that slows targets speed and -2 to attack rolls on successful hit.
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Nov 5, 2015
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	//Declare major variables
	object oTarget = GetSpellTargetObject();
    int nMetaMagic = GetMetaMagicFeat();
		
	if (GetIsObjectValid(oTarget))
	{
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
		{
			int nRangedTouch = TouchAttackRanged(oTarget);
			if (nRangedTouch != TOUCH_ATTACK_RESULT_MISS)
			{
			    //Declare major variables
			    object oCaster = OBJECT_SELF;
			    int nCasterLvl = GetCasterLevel(oCaster);
			    int nDamage, nDamage2;
				
				nDamage = 2;
				nDamage2 = 10;
				
			    effect eVis = EffectVisualEffect(VFX_HIT_SPELL_AVASCULATE);
			    effect eDamage;
				effect eLink;
				
		        if (!MyResistSpell(OBJECT_SELF, oTarget))
		        {	

					// If have spell specialization feat add +2 to attack penalty
					if (GetHasFeat(2992,OBJECT_SELF,TRUE))
					{
						nDamage += 2;
						nDamage2 += 20;
					}
					
			        if (nMetaMagic == METAMAGIC_EMPOWER)
			        {
			             nDamage = (nDamage * 2);
			        }
			        if (nMetaMagic == METAMAGIC_MAXIMIZE)
			        {
			             nDamage = 5 * 6;
			        }				
															
					eDamage = EffectAttackDecrease(nDamage, ATTACK_BONUS_MISC);
					effect eSlow = EffectMovementSpeedDecrease(nDamage2);
					eLink = EffectLinkEffects(eDamage, eVis);
					eLink = EffectLinkEffects(eLink, eSlow);
		        	ApplyEffectToObject( DURATION_TYPE_TEMPORARY, eLink, oTarget, RoundsToSeconds(nCasterLvl));					
				}
			}						
		}	
	}			
}