//::///////////////////////////////////////////////
//:: Red / Gold Dragon Breath
//:: mt_s0_reddragonbreath
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Feb 24, 2008
//:://////////////////////////////////////////////

//float SpellDelay (object oTarget, int nShape);

#include "NW_I0_SPELLS"
#include "x0_i0_spells"
#include "x2_inc_spellhook" 

void main()
{
/* 
  Spellcast Hook Code 
  Added 2003-07-07 by Georg Zoeller
  If you want to make changes to all spells,
  check x2_inc_spellhook.nss to find out more  
*/
    if (!X2PreSpellCastCode())
    {
	    // If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
  		return;
    }
// End of Spell Cast Hook

    //Declare major variables
    int nCasterLvl = GetCasterLevel(OBJECT_SELF);
	
	if(nCasterLvl > 16)
		nCasterLvl = 16;
		
    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nCasterLvl = (nCasterLvl + 3);
    }	
    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nCasterLvl = (nCasterLvl + 2);
    }	
    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
	
    if (GetHasFeat(3094)) // If have fiery burst, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    if (GetHasFeat(5036)) // fire adept
    {
        nCasterLvl = (nCasterLvl + 1);
    }
    if (GetHasFeat(5264)) // bloodline of fire
    {
        nCasterLvl = (nCasterLvl + 2);
    }
	
    int nMetaMagic = GetMetaMagicFeat();
    int nDamage;
    float fDelay;
	effect eCone = EffectVisualEffect(VFX_CONE_RED_DRAGON_FIRE);
	float fMaxDelay = 0.0f; // used to determine duration of eCone effect
    location lTargetLocation = GetSpellTargetLocation();
    object oTarget;

	//Declare the spell shape, size and the location.  Capture the first target object in the shape.
    oTarget = GetFirstObjectInShape(SHAPE_SPELLCONE, 16.0, lTargetLocation, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);
    //Cycle through the targets within the spell shape until an invalid object is captured.
    while(GetIsObjectValid(oTarget))
    {
    	if(spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
    	{
            //Fire cast spell at event for the specified target
            SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId()));
			
            //Get the distance between the target and caster to delay the application of effects
            fDelay = GetDistanceBetween(OBJECT_SELF, oTarget)/20.0;
			if (fDelay > fMaxDelay)
			{
				fMaxDelay = fDelay;
			}
            //Make SR check, and appropriate saving throw(s).
            if(!MyResistSpell(OBJECT_SELF, oTarget, fDelay) && (oTarget != OBJECT_SELF))
            {
                //Detemine damage
                nDamage = d8(nCasterLvl / 2) + 1;
                //Enter Metamagic conditions
                if (nMetaMagic & METAMAGIC_MAXIMIZE)
                {
                    nDamage = 6 * nCasterLvl;//Damage is at max
                }
                else if (nMetaMagic & METAMAGIC_EMPOWER)
                {
                    nDamage = nDamage + (nDamage/2); //Damage/Healing is +50%
                }

                // Apply effects to the currently selected target.
                effect eFire = EffectDamage(nDamage, DAMAGE_TYPE_FIRE);
                effect eVis = EffectVisualEffect(VFX_HIT_SPELL_FIRE);
                if(nDamage > 0)
                {
                    //Apply delayed effects
                    DelayCommand(fDelay, ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget));
                    DelayCommand(fDelay, ApplyEffectToObject(DURATION_TYPE_INSTANT, eFire, oTarget));
                }
				
				if (GetHasFeat(5212,OBJECT_SELF,TRUE)) // Diabolism
				{
					int nLevelDiabolist = GetLevelByClass(96, OBJECT_SELF);
					if(nLevelDiabolist == 10)
						nDamage = 3;
					else if(nLevelDiabolist == 5)
						nDamage = 2;
					else
						nDamage = 1;	
					
	                effect eDam2 = EffectDamage(nDamage, DAMAGE_TYPE_NEGATIVE);
					ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam2, oTarget);
				}
	
				if (GetHasFeat(5213,OBJECT_SELF,TRUE)) // Vile Diabolism
				{
					nDamage = 1;
	                effect eDam3 = EffectDamage(nDamage, DAMAGE_TYPE_MAGICAL);
					ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam3, oTarget);
				}						
            }
        }
        //Select the next target within the spell shape.
        oTarget = GetNextObjectInShape(SHAPE_SPELLCONE, 16.0, lTargetLocation, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);
    }
	fMaxDelay += 0.5f;
	ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eCone, OBJECT_SELF, fMaxDelay);
}