//::///////////////////////////////////////////////
//:: Army of Darkness
//:: mt_s0_sarmydarkness
//:: Purpose: Army of Darkness
//:: Created By: Joshua Kalis (Greg)
//:: Created On: October 18, 2015
//:: Description: Summons multiple shadow elementals.
//:: Mystery
//::
//:: Summons shadow elementals.
//:://////////////////////////////////////////////

#include "nwn2_inc_spells"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {
		// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
// End of Spell Cast Hook


    //Declare major variables	
    location lTarget 	= GetSpellTargetLocation();
    float fDuration = TurnsToSeconds(GetCasterLevel(OBJECT_SELF));
	int nLevelShadowcaster = GetLevelByClass(99, OBJECT_SELF);
	int nLevelMasterOfShadow = GetLevelByClass(100, OBJECT_SELF);
	int nLevelNoctumancer = GetLevelByClass(101, OBJECT_SELF);
	int nLevelShadowTheurge = GetLevelByClass(103, OBJECT_SELF);
	int nCasterLvl = nLevelShadowcaster + nLevelMasterOfShadow + nLevelNoctumancer + nLevelShadowTheurge;
	
    if (GetHasFeat(5198)) // If have mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    if (GetHasFeat(5199)) // If have greater mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }			
    if (GetHasFeat(5194)) // If have extend mystery, double it.
    {
        nCasterLvl = (nCasterLvl * 2);
    }		
	fDuration = RoundsToSeconds(nCasterLvl);
	
	// Summon specific variables
	string sSummon = "shadowelemental";
	
	int nNum = d4(1) + 1;
	int nLoop = 0;
	while(nLoop <= nNum)
	{
		object oSummon = CreateObject(OBJECT_TYPE_CREATURE, sSummon, lTarget, TRUE);
		effect eUnsummon = EffectVisualEffect(VFX_IMP_UNSUMMON);
		effect eVis = EffectVisualEffect(VFX_FNF_SUMMON_EPIC_UNDEAD);
		
		if (GetHasFeat(FEAT_AUGMENT_SUMMONING))
		{
			int nStr = 4;
			int nCon = 4;
			
		    if (GetHasFeat(5198)) // If have mystery focus, add 1 more.
		    {
		        nStr = (nStr + 2);
		        nCon = (nCon + 2);
		    }	
		    if (GetHasFeat(5199)) // If have greater mystery focus, add 1 more.
		    {
		        nStr = (nStr + 4);
		        nCon = (nCon + 4);
		    }	
		
			effect eStr = EffectAbilityIncrease(ABILITY_STRENGTH, nStr);
			effect eCon = EffectAbilityIncrease(ABILITY_CONSTITUTION, nCon);
			effect eAttack = EffectAttackIncrease(nStr, ATTACK_BONUS_MISC);
			effect eHP = EffectTemporaryHitpoints(nCon * 10);
				
			effect eLink = EffectLinkEffects(eStr, eCon);
			eLink = EffectLinkEffects(eLink, eAttack);
			eLink = EffectLinkEffects(eLink, eHP);
			eLink = SupernaturalEffect(eLink);
			
			ApplyEffectToObject(DURATION_TYPE_PERMANENT, eLink, oSummon);
		}
	
		ChangeFaction(oSummon, OBJECT_SELF);
		int nHenchies = GetMaxHenchmen();
		SetMaxHenchmen(nHenchies+50);
		AddHenchman(OBJECT_SELF, oSummon);
		SetMaxHenchmen(nHenchies);
	
		ApplyEffectAtLocation(DURATION_TYPE_INSTANT, eVis, lTarget);
	
		DelayCommand(fDuration, RemoveHenchman(OBJECT_SELF, oSummon));
		DelayCommand(fDuration, DestroyObject(oSummon, 0.1f));
		DelayCommand(fDuration, ApplyEffectAtLocation(DURATION_TYPE_INSTANT, eUnsummon, GetLocation(oSummon)));		
		
	
		nLoop++;
	}		
}