//::///////////////////////////////////////////////
//:: Seeking Ray
//:: mt_s0_seekingray
//:: Purpose: Touched ranged attack that does 4d6 of electrical damage and also gives you a +4 bonus to future attack rolls against the target for 1 round / level.
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Nov 5, 2015
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	//Declare major variables
	object oTarget = GetSpellTargetObject();
    int nMetaMagic = GetMetaMagicFeat();
		
	if (GetIsObjectValid(oTarget))
	{
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
		{
			int nRangedTouch = TouchAttackRanged(oTarget);
			if (nRangedTouch != TOUCH_ATTACK_RESULT_MISS)
			{
			    //Declare major variables
			    object oCaster = OBJECT_SELF;
			    int nCasterLvl = GetCasterLevel(oCaster);
			    int nDamage, nDamage2;
				
			    effect eVis = EffectVisualEffect(VFX_HIT_SPELL_TRANSMUTATION);
			    effect eDamage;
				effect eLink;
				
		        if (!MyResistSpell(OBJECT_SELF, oTarget))
		        {
					int nCasterLvL = GetCasterLevel(OBJECT_SELF) / 2;
					if(nCasterLvl > 4)
						nCasterLvl = 4;
	
				    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
				    {
				        nCasterLvl = (nCasterLvl + 3);
				    }	
				    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
				    {
				        nCasterLvl = (nCasterLvl + 2);
				    }	
				    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
				    {
				        nCasterLvl = (nCasterLvl + 1);
				    }	
					
				    if (GetHasFeat(3098)) // If have storm bolt, add 1 more.
				    {
				        nCasterLvl = (nCasterLvl + 1);
				    }	
						
					int nDamage = d6(nCasterLvl);
										
			        if (nMetaMagic == METAMAGIC_EMPOWER)
			        {
			             nDamage = (nDamage * 2);
			        }
			        if (nMetaMagic == METAMAGIC_MAXIMIZE)
			        {
			             nDamage = nCasterLvl * 6;
			        }				
															
					// If have spell specialization feat add +2
					if (GetHasFeat(2992,OBJECT_SELF,TRUE))
						nDamage += 2;
					
					eDamage = EffectDamage(nDamage, DAMAGE_TYPE_ELECTRICAL, DAMAGE_POWER_NORMAL, 0);
					eLink = EffectLinkEffects(eDamage, eVis);
		        	ApplyEffectToObject( DURATION_TYPE_INSTANT, eLink, oTarget);

					// Not apply attack bonus to caster
					int nBonus = 4;					
					
					// If have spell specialization feat add +2
					if (GetHasFeat(2992,OBJECT_SELF,TRUE))
						nBonus += 2;
					
					effect eBonus = EffectAttackIncrease(nBonus, ATTACK_BONUS_MISC);
		        	ApplyEffectToObject( DURATION_TYPE_TEMPORARY, eBonus, oCaster, RoundsToSeconds(nCasterLvl));
				}
			}						
		}	
	}			
}