//::///////////////////////////////////////////////
//:: Shadow Evocation
//:: mt_s0_shadowevocation
//:: Purpose: Shadow Evocation
//:: Created By: Joshua Kalis (Greg)
//:: Created On: September 20, 2015
//:: Description: Shadow versions of lesser evocation spells
//:: Initiate Mystery
//::
//:: Shadow evocation
//:://////////////////////////////////////////////

#include "nwn2_inc_spells"


void ShadowBolt (object oTarget, int nMetaMagic);

void main()
{
    int nMetaMagic = GetMetaMagicFeat();
    object oTarget = GetSpellTargetObject();
    int nCast;
	int nRadius = 1;
	int nLevelShadowcaster = GetLevelByClass(99, OBJECT_SELF);
	int nLevelMasterOfShadow = GetLevelByClass(100, OBJECT_SELF);
	int nLevelNoctumancer = GetLevelByClass(101, OBJECT_SELF);
	int nLevelShadowTheurge = GetLevelByClass(103, OBJECT_SELF);
	int nCasterLvl = nLevelShadowcaster + nLevelMasterOfShadow + nLevelNoctumancer + nLevelShadowTheurge;
    int nDuration = 1;
	
    if (GetHasFeat(5198)) // If have mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    if (GetHasFeat(5199)) // If have greater mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    if (GetHasFeat(5194)) // If have extend mystery, double it.
    {
        nCasterLvl = (nCasterLvl * 2);
    }	
    if (GetHasFeat(5195)) // If have enlarge mystery, double size.
    {
        nRadius = (nRadius * 2);
    }		
    nDuration = nCasterLvl;		
    float fDuration = RoundsToSeconds(nDuration);
	float fSummonDuration = RoundsToSeconds(nCasterLvl + 3);
    int nDurType = ApplyMetamagicDurationTypeMods(DURATION_TYPE_TEMPORARY);
    effect eVis;


    if (GetIsObjectValid(oTarget))
    {
        if (oTarget == OBJECT_SELF)
        {
            nCast = 1;
        }
        else
        {
            nCast = 2;
        }
    }
    else
    {
        nCast = 3;
    }

    switch (nCast)
    {
        case 1:
			{
	            //eVis = EffectVisualEffect(VFX_IMP_AC_BONUS);
	            effect eAC = EffectACIncrease(4, AC_ARMOUR_ENCHANTMENT_BONUS);
	            effect eMirror = EffectVisualEffect(VFX_DUR_SPELL_MAGE_ARMOR);
	            effect eLink = EffectLinkEffects(eAC, eMirror);
	            //eLink = EffectLinkEffects(eLink, eVis);
	            ApplyEffectToObject(nDurType, eLink, OBJECT_SELF, fDuration);
			}
            break;
        case 2:
			{
	            if (!ResistSpell(OBJECT_SELF, oTarget))
		        {
	               ShadowBolt(oTarget, nMetaMagic);
				}
			}
            break;
        case 3:
			{
	            int nCasterLevel = GetCasterLevel(OBJECT_SELF);
	            effect eSummon = EffectSummonCreature("c_shadow", VFX_HIT_SPELL_SUMMON_CREATURE);
	            ApplyEffectAtLocation(nDurType, eSummon, GetSpellTargetLocation(), fSummonDuration);
			}
            break;
    }
}

void ShadowBolt (object oTarget, int nMetaMagic)
{
    int nDamage;
    int nBolts = GetCasterLevel(OBJECT_SELF)/5;
    int nCnt;
    effect eVis2 = EffectVisualEffect(VFX_HIT_SPELL_EVIL);
    effect eDam;
    effect eBeam = EffectBeam(VFX_BEAM_EVIL, OBJECT_SELF, BODY_NODE_HAND);
    for (nCnt = 0; nCnt < nBolts; nCnt++)
    {
        int nDam = d6(2);
        //Enter Metamagic conditions
        nDamage = ApplyMetamagicVariableMods(nDamage, 12);
        if (ReflexSave(oTarget, GetSpellSaveDC()))
        {
            nDamage = nDamage/2;
        }
        eDam = EffectDamage(nDamage, DAMAGE_TYPE_NEGATIVE);
        DelayCommand(IntToFloat(nCnt), ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis2, oTarget));
        DelayCommand(IntToFloat(nCnt), ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam, oTarget));
    }
    ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eBeam, oTarget, 3.5);
}