//::///////////////////////////////////////////////
//:: Shadow Evocation
//:: mt_s0_shadowevocation
//:: Purpose: Shadow Evocation
//:: Created By: Joshua Kalis (Greg)
//:: Created On: September 20, 2015
//:: Description: Shadow versions of lesser evocation spells
//:: Initiate Mystery
//::
//:: Shadow evocation
//:://////////////////////////////////////////////

#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
// End of Spell Cast Hook

    //Declare major variables
    effect eSummon;

	int nLevelShadowcaster = GetLevelByClass(99, OBJECT_SELF);
	int nLevelMasterOfShadow = GetLevelByClass(100, OBJECT_SELF);
	int nLevelNoctumancer = GetLevelByClass(101, OBJECT_SELF);
	int nLevelShadowTheurge = GetLevelByClass(103, OBJECT_SELF);
	int nCasterLvl = nLevelShadowcaster + nLevelMasterOfShadow + nLevelNoctumancer + nLevelShadowTheurge;
	int nBonus = 1;
    int nDuration = 1;
	float nRadius = 5.0;
	
    if (GetHasFeat(5198)) // If have mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    if (GetHasFeat(5199)) // If have greater mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    nDuration = nCasterLvl;		
    if (GetHasFeat(5194)) // If have extend mystery, double it.
    {
        nDuration = (nDuration * 2);
    }	
    float fDuration = RoundsToSeconds(nDuration);

    if (nCasterLvl <= 7)
    {
        eSummon = EffectSummonCreature("c_shadow",VFX_FNF_SUMMON_UNDEAD);
    }
    else if ((nCasterLvl >= 8) && (nCasterLvl <= 10))
    {
        eSummon = EffectSummonCreature("c_dogshado",VFX_FNF_SUMMON_UNDEAD);
    }
    else if ((nCasterLvl >= 11) && (nCasterLvl <= 14))
    {
        eSummon = EffectSummonCreature("c_shadow7",VFX_FNF_SUMMON_UNDEAD); // change later
    }
    else if ((nCasterLvl >= 15))
    {
        eSummon = EffectSummonCreature("c_shadow9",VFX_FNF_SUMMON_UNDEAD);
    }

    //Apply VFX impact and summon effect
    ApplyEffectAtLocation(DURATION_TYPE_TEMPORARY, eSummon, GetSpellTargetLocation(), RoundsToSeconds(nDuration));
    //ApplyEffectAtLocation(DURATION_TYPE_INSTANT, eVis, GetSpellTargetLocation());
}