//::///////////////////////////////////////////////
//:: Shadow Investiture
//:: mt_s0_shadowinvestiture
//:: Purpose: Shadow Investiture
//:: Created By: Joshua Kalis (Greg)
//:: Created On: September 20, 2015
//:: Description: Shadows
//:: Fundamental Mystery
//::
//:: You cause those near you to gain cold resistance, evasion and the ability to see in darkness.
//:://////////////////////////////////////////////

#include "nwn2_inc_spells"
#include "X0_I0_SPELLS"
#include "x2_inc_spellhook"
#include "ginc_henchman"


void main()
{
    if (!X2PreSpellCastCode())
    {
    // If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
// End of Spell Cast Hook

	int nLevelShadowcaster = GetLevelByClass(99, OBJECT_SELF);
	int nLevelMasterOfShadow = GetLevelByClass(100, OBJECT_SELF);
	int nLevelNoctumancer = GetLevelByClass(101, OBJECT_SELF);
	int nLevelShadowTheurge = GetLevelByClass(103, OBJECT_SELF);
	int nCasterLvl = nLevelShadowcaster + nLevelMasterOfShadow + nLevelNoctumancer + nLevelShadowTheurge;
    int nDuration = 1;
	
    if (GetHasFeat(5198)) // If have mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    if (GetHasFeat(5199)) // If have greater mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }			
    if (GetHasFeat(5194)) // If have extend mystery, double it.
    {
        nCasterLvl = (nCasterLvl * 2);
    }		
    nDuration = nCasterLvl * 12;	
	float fDuration = IntToFloat(nDuration);
	
    location lTarget = GetSpellTargetLocation();
    object oTarget = GetFirstObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_HUGE, lTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);
    //Cycle through the targets within the spell shape until an invalid object is captured.
    while (GetIsObjectValid(oTarget))
    {
        if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
    	{
			effect eDamage = EffectDamage(1, DAMAGE_TYPE_COLD, DAMAGE_POWER_NORMAL);
			ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);
		}
		else
		{
			//Fire cast spell at event for the specified target
			SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId()));

			effect eDur = EffectVisualEffect( VFX_DUR_SPELL_LOWLIGHT_VISION );
			effect eSight = EffectUltravision();
			effect eLink = EffectLinkEffects(eDur, eSight);
			
			effect eCold = EffectDamageResistance(DAMAGE_TYPE_COLD, 15, 2000);
			effect eEvasion = EffectConcealment(10, MISS_CHANCE_TYPE_NORMAL);		
			effect eLink2 = EffectLinkEffects(eCold, eEvasion);
			effect eLink3 = EffectLinkEffects(eLink, eLink2);
			
			//Apply the VFX impact and effects
			ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLink3, oTarget, fDuration);
		}
	
       //Select the next target within the spell shape.
       oTarget = GetNextObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_HUGE, lTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);
    }	
}