//::///////////////////////////////////////////////
//:: Shadows Fade
//:: mt_s0_shadowsfade
//:: Purpose: Shadows Fade 
//:: Created By: Joshua Kalis (Greg)
//:: Created On: September 23, 2015
//:: Description: Shadow magic version of dispel magic
//:: Initiate Mystery
//::
//:: Shadows fade, dispel magic
//:://////////////////////////////////////////////

#include "x0_i0_spells"
#include "x2_inc_spellhook"

void main()
{
    if (!X2PreSpellCastCode())
    {
        return;
    }
// End of Spell Cast Hook

    effect    eVis         = EffectVisualEffect(VFX_HIT_SPELL_ABJURATION);
	effect 	  eImpact; // Required for the spellsDispelMagic function, but this effect is now handled by spells.2da
					   //   function never uses this value, anyway.
    object    oTarget      = GetSpellTargetObject();
    location  lLocal       = GetSpellTargetLocation();

	int nLevelShadowcaster = GetLevelByClass(99, OBJECT_SELF);
	int nLevelMasterOfShadow = GetLevelByClass(100, OBJECT_SELF);
	int nLevelNoctumancer = GetLevelByClass(101, OBJECT_SELF);
	int nCasterLvl = nLevelShadowcaster + nLevelMasterOfShadow + nLevelNoctumancer;

	if(nCasterLvl > 10)
		nCasterLvl = 10;
	
    if (GetHasFeat(5198)) // If have mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    if (GetHasFeat(5199)) // If have greater mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	

    if (GetIsObjectValid(oTarget))
    {
        //----------------------------------------------------------------------
        // Targeted Dispel - Dispel all
        //----------------------------------------------------------------------
        spellsDispelMagic(oTarget, nCasterLvl, eVis, eImpact);

		if (GetHasFeat(5203)) // If have capture magics shadow feat, chance to restore.
		{
		    int nRoll = d100(1);
			
			if(nRoll <= 2)
			{
				ForceRest(OBJECT_SELF);				
			}
		}			 		 
    }
    else
    {
        //----------------------------------------------------------------------
        // Area of Effect - Only dispel best effect
        //----------------------------------------------------------------------

        oTarget = GetFirstObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_LARGE, lLocal, FALSE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_AREA_OF_EFFECT | OBJECT_TYPE_PLACEABLE );
        while (GetIsObjectValid(oTarget))
        {
            if(GetObjectType(oTarget) == OBJECT_TYPE_AREA_OF_EFFECT)
            {
                //--------------------------------------------------------------
                // Handle Area of Effects
                //--------------------------------------------------------------
                spellsDispelAoE(oTarget, OBJECT_SELF, nCasterLvl);
				
				if(nRoll <= 2)
				{
					ForceRest(OBJECT_SELF);				
				}
            }
            else if (GetObjectType(oTarget) == OBJECT_TYPE_PLACEABLE)
            {
                SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId()));
            }
            else
            {
                spellsDispelMagic(oTarget, nCasterLvl, eVis, eImpact, FALSE);
				
				if (GetHasFeat(5203)) // If have capture magics shadow feat, chance to restore.
				{
				    int nRoll = d100(1);
					
					if(nRoll <= 2)
					{
						ForceRest(OBJECT_SELF);				
					}
				}	
            }

           oTarget = GetNextObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_LARGE,lLocal, FALSE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_AREA_OF_EFFECT | OBJECT_TYPE_PLACEABLE);
        }
    }
}

