//::///////////////////////////////////////////////
//:: Shadow Skin
//:: mt_s0_shadowskin
//:: Purpose: Shadow Skin
//:: Created By: Joshua Kalis (Greg)
//:: Created On: September 19, 2015
//:: Description: Damage resistance
//:: Mystery
//::
//:: Gain DR.
//:://////////////////////////////////////////////

#include "nwn2_inc_spells"
#include "nw_i0_spells"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
// End of Spell Cast Hook


    //Declare major variables
    effect eVis1 = EffectVisualEffect( VFX_DUR_DEATH_ARMOR );
    object oTarget = GetSpellTargetObject();

	int nLevelShadowcaster = GetLevelByClass(99, OBJECT_SELF);
	int nLevelMasterOfShadow = GetLevelByClass(100, OBJECT_SELF);
	int nLevelNoctumancer = GetLevelByClass(101, OBJECT_SELF);
	int nLevelShadowTheurge = GetLevelByClass(103, OBJECT_SELF);
	int nCasterLvl = nLevelShadowcaster + nLevelMasterOfShadow + nLevelNoctumancer + nLevelShadowTheurge;
	
    if (GetHasFeat(5198)) // If have mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    if (GetHasFeat(5199)) // If have greater mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    int nBonus = 12 + nCasterLvl;
		
    if (GetHasFeat(5194)) // If have extend mystery, double it.
    {
        nCasterLvl = (nCasterLvl * 2);
    }		
    float fDuration = HoursToSeconds(nCasterLvl);
    int nAmount = nCasterLvl * 500;
	int nProtection = 0;
	
	if(nCasterLvl < 5)
		nProtection = 5;
	else if(nCasterLvl < 10)
		nProtection = 10;
	else if(nCasterLvl < 20)
		nProtection = 15;
	else
		nProtection = 20;
			
    //Fire cast spell at event for the specified target
    SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, SPELL_STONESKIN, FALSE));

    int nDurType = ApplyMetamagicDurationTypeMods(DURATION_TYPE_TEMPORARY);

    effect eStone = EffectDamageReduction(10, GMATERIAL_METAL_ADAMANTINE, nAmount, DR_TYPE_GMATERIAL);	// JLR-OEI 02/14/06: NWN2 3.5 -- New Damage Reduction Rules
	eStone = EffectLinkEffects( eStone, eVis1 );

    //Apply the linked effects.
    //ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis2, oTarget);
    //ApplyEffectToObject(nDurType, eVis1, oTarget, fDuration);
    ApplyEffectToObject(nDurType, eStone, oTarget, fDuration);
}