//::///////////////////////////////////////////////
//:: Sharp Shadows
//:: mt_s0_sharpshadows
//:: Purpose: Sharp Shadows
//:: Created By: Joshua Kalis (Greg)
//:: Created On: September 19, 2015
//:: Description: Shadows that hit back
//:: Initiate Mystery
//::
//:: When people strike the caster they take magic damage.
//:://////////////////////////////////////////////

#include "x2_inc_spellhook"
#include "x0_i0_spells"

void main()
{
    if (!X2PreSpellCastCode())
    {
	    // If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
		return;
    }

// End of Spell Cast Hook

    //Declare major variables
    effect eVis = EffectVisualEffect(448);

	int nLevelShadowcaster = GetLevelByClass(99, OBJECT_SELF);
	int nLevelMasterOfShadow = GetLevelByClass(100, OBJECT_SELF);
	int nLevelNoctumancer = GetLevelByClass(101, OBJECT_SELF);
	int nLevelShadowTheurge = GetLevelByClass(103, OBJECT_SELF);
	int nCasterLvl = nLevelShadowcaster + nLevelMasterOfShadow + nLevelNoctumancer + nLevelShadowTheurge;
    int nDuration = 1;
	
    if (GetHasFeat(5198)) // If have mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    if (GetHasFeat(5199)) // If have greater mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }		
    if (GetHasFeat(5194)) // If have extend mystery, double it.
    {
        nCasterLvl = (nCasterLvl * 2);
    }	
    nDuration = nCasterLvl * 60;		
    float fDuration = IntToFloat(nDuration);
	
    int nDamage = nDuration * 2;
    int nMetaMagic = GetMetaMagicFeat();
    object oTarget = OBJECT_SELF;
    effect eShield = EffectDamageShield(nDamage, DAMAGE_BONUS_1d6, DAMAGE_TYPE_MAGICAL);
    effect eDur = EffectVisualEffect(VFX_DUR_CESSATE_POSITIVE);

    //Link effects
    effect eLink = EffectLinkEffects(eShield, eDur);
    eLink = EffectLinkEffects(eLink, eVis);

    //Fire cast spell at event for the specified target
    SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId(), FALSE));

    // 2003-07-07: Stacking Spell Pass, Georg
    RemoveEffectsFromSpell(oTarget, GetSpellId());

    //Apply the VFX impact and effects
    ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLink, oTarget, fDuration);	
}