//::///////////////////////////////////////////////
//:: Shrieking Blast
//:: mt_s0_shriekingblast
//:: Created By: Joshua Kalis (Greg)
//:: Created On: January 4, 2007
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void mainSpell();
void main()
{
	AssignCommand(JXGetCaster(), mainSpell());
}

void mainSpell()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        JXPostSpellCastCode();
        return;
    }

	//Declare major variables
	object oTarget = JXGetSpellTargetObject();
	int nCasterLvl = JXGetCasterLevel(OBJECT_SELF);
	
	if (nCasterLvl > 10)
		nCasterLvl = 10;
	int nDamage = d6(8);	
		
	effect eVis;	
	effect eOrbEffect;
	int nDamageType;
	int nSpellId = JXGetSpellId();
	
    //Get the spell target location as opposed to the spell target.
    location lTarget = JXGetSpellTargetLocation();

	// Calculate the damage type.
	nDamageType	= DAMAGE_TYPE_SONIC;
	eVis = EffectVisualEffect(VFX_HIT_SPELL_SONIC);
	eOrbEffect = EffectDeaf();
		  
	int nMax = (nCasterLvl*8)+2;
	nDamage = ApplyMetamagicVariableMods( nDamage, nMax );					
	effect eDamage = EffectDamage(nDamage,nDamageType);

	//Declare the spell shape, size and the location.  Capture the first target object in the shape.
    oTarget = GetFirstObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_HUGE, lTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);

	//Cycle through the targets within the spell shape until an invalid object is captured.
    while (GetIsObjectValid(oTarget))
    {
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
		{		
			//Fire cast spell at event for the specified target
			SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, JXGetSpellId()));				

			//Apply the effects
			JXApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
			JXApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);

	        if (!MySavingThrow(SAVING_THROW_FORT, oTarget, JXGetSpellSaveDC(), SAVING_THROW_TYPE_SONIC))
				JXApplyEffectToObject(DURATION_TYPE_TEMPORARY, eOrbEffect, oTarget, 12.0f);
			else
				JXApplyEffectToObject(DURATION_TYPE_PERMANENT, eOrbEffect, oTarget);
		}
					
		//Select the next target within the spell shape.
        oTarget = GetNextObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_HUGE, lTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);
    }
	
	JXPostSpellCastCode();
}