//::///////////////////////////////////////////////
//:: Shriveling
//:: mt_s0_shriveling
//:: Purpose: Spell - Shriveling
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Dec 29, 2007
//:: Description: 
//:: Evocation, Wiz/Sor 2, Cleric 3
//:: 1D4 slashing to target, maximum 10D4.
//::
//:: You cause the target's flesh to rot, taking 1D4 slashing per caster level.
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	// This is an evil spell. Casting it moves you one spot more towards evil.	
	AdjustAlignment(OBJECT_SELF, ALIGNMENT_EVIL, 1);
	
	//Declare major variables
	object oTarget = GetSpellTargetObject();
	int nCasterLvl = GetCasterLevel(OBJECT_SELF);
	
	if (nCasterLvl > 10)
		nCasterLvl = 10;

    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nCasterLvl = (nCasterLvl + 3);
    }	
    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nCasterLvl = (nCasterLvl + 2);
    }	
    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
	
    if (GetHasFeat(3096)) // If have invisible needle, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
				
	int nDamage = d4(nCasterLvl);	
		
	effect eVis;	
	effect eOrbEffect;
	int nDamageType;
	int nSpellId = GetSpellId();
	
	nDamageType	= DAMAGE_TYPE_SLASHING;
	eVis = EffectVisualEffect(VFX_HIT_SPELL_AVASCULATE);
	eOrbEffect = EffectStunned();
		  
	if (GetIsObjectValid(oTarget))
	{
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
		{		
			int nMax = (nCasterLvl*8)+2;
			nDamage = ApplyMetamagicVariableMods( nDamage, nMax );					
			effect eDamage = EffectDamage(nDamage,nDamageType);
				
			//Fire cast spell at event for the specified target
			SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId()));				

			//Apply the effects
			ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
			ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);
			
			if (GetHasFeat(5212,OBJECT_SELF,TRUE)) // Diabolism
			{
				int nLevelDiabolist = GetLevelByClass(96, OBJECT_SELF);
				if(nLevelDiabolist == 10)
					nDamage = 3;
				else if(nLevelDiabolist == 5)
					nDamage = 2;
				else
					nDamage = 1;	
				
                effect eDam2 = EffectDamage(nDamage, DAMAGE_TYPE_NEGATIVE);
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam2, oTarget);
			}

			if (GetHasFeat(5213,OBJECT_SELF,TRUE)) // Vile Diabolism
			{
				nDamage = 1;
                effect eDam3 = EffectDamage(nDamage, DAMAGE_TYPE_MAGICAL);
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam3, oTarget);
			}						
		}	
	}			
}