//::///////////////////////////////////////////////
//:: Skeletal Guard
//:: mt_s0_skeletalguard
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Oct 20, 2015
//:://////////////////////////////////////////////
/*
	Based on NWN original summoning spells.

    Carries out the summoning of the appropriate
    creature for the Summon Monster Series of spells
    1 to 9.  Based on alignment now, has multiple options.
*/

#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
// End of Spell Cast Hook

	// Main Variables
	location lLocation = GetSpellTargetLocation();
	int nSkeletons = d4(1);
	string sSummon = "c_skeletonwarrior";
	
	// Do this more than once
	object oSummon = CreateObject(OBJECT_TYPE_CREATURE, sSummon, lLocation, TRUE);
	effect eVis = EffectVisualEffect(VFX_SPELL_SHADES_SUMMON_CREATURE);
	effect eUnsummon = EffectVisualEffect(VFX_IMP_UNSUMMON);
	int nCasterLvl = GetCasterLevel(OBJECT_SELF);
	float fDuration = HoursToSeconds(48);

	if (GetHasFeat(FEAT_AUGMENT_SUMMONING))
	{
		effect eStr = EffectAbilityIncrease(ABILITY_STRENGTH, 4);
		effect eCon = EffectAbilityIncrease(ABILITY_CONSTITUTION, 4);
		effect eLink = EffectLinkEffects(eStr, eCon);
		eLink = SupernaturalEffect(eLink);
		ApplyEffectToObject(DURATION_TYPE_PERMANENT, eLink, oSummon);
	}

	effect eTurnResistant = EffectTurnResistanceIncrease(10);
	ApplyEffectToObject(DURATION_TYPE_PERMANENT, eTurnResistant, oSummon);
	
	ChangeFaction(oSummon, OBJECT_SELF);
	int nHenchies = GetMaxHenchmen();
	SetMaxHenchmen(nHenchies+50);
	AddHenchman(OBJECT_SELF, oSummon);
	SetMaxHenchmen(nHenchies);

	ApplyEffectAtLocation(DURATION_TYPE_INSTANT, eVis, lLocation);

	DelayCommand(fDuration, RemoveHenchman(OBJECT_SELF, oSummon));
	DelayCommand(fDuration, DestroyObject(oSummon, 0.1f));
	DelayCommand(fDuration, ApplyEffectAtLocation(DURATION_TYPE_INSTANT, eUnsummon, GetLocation(oSummon)));
}