//::///////////////////////////////////////////////
//:: Snilloc's Snowball
//:: mt_s0_snillocsnowball
//:: Created By: Joshua Kalis (Greg)
//:: Created On: January 1, 2007
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void mainSpell()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	//Declare major variables
	object oTarget = GetSpellTargetObject();
	int nCasterLvl = GetCasterLevel(OBJECT_SELF);
	int nBonus = 0;
	
	nCasterLvl = 1;

    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nCasterLvl = (nCasterLvl + 3);
        nBonus = (nBonus + 3);
    }	
    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nCasterLvl = (nCasterLvl + 2);
        nBonus = (nBonus + 2);
    }	
    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
        nBonus = (nBonus + 1);
    }	
	
    if (GetHasFeat(3101)) // If have winters blast, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
        nBonus = (nBonus + 1);
    }	
		
	int nDamage = d6(1) + nBonus;	
		
	effect eVis;	
	int nDamageType;
	int nSpellId = GetSpellId();
	
	int nDamageType = DAMAGE_TYPE_COLD;	
	eVis = EffectVisualEffect(VFX_HIT_SPELL_ICE);
		  
	if (GetIsObjectValid(oTarget))
	{
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
		{				
			int nRangedTouch = TouchAttackRanged(oTarget);
			if (nRangedTouch != TOUCH_ATTACK_RESULT_MISS)
			{
				if(!MyResistSpell(OBJECT_SELF, oTarget))
				{		
					if (GetHasFeat(2992,OBJECT_SELF,TRUE))
					{
						nDamage += 2;
					}
					if (nRangedTouch == TOUCH_ATTACK_RESULT_CRITICAL)
					{
						nDamage = nDamage * 2;					
					}
				
					effect eDamage = EffectDamage(nDamage,nDamageType);
					
					//Fire cast spell at event for the specified target
					SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId()));				
	
					//Apply the effects
					ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
					ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);					
					
					if (GetHasFeat(5212,OBJECT_SELF,TRUE)) // Diabolism
					{
						int nLevelDiabolist = GetLevelByClass(96, OBJECT_SELF);
						if(nLevelDiabolist == 10)
							nDamage = 3;
						else if(nLevelDiabolist == 5)
							nDamage = 2;
						else
							nDamage = 1;	
						
		                effect eDam2 = EffectDamage(nDamage, DAMAGE_TYPE_NEGATIVE);
						ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam2, oTarget);
					}

					if (GetHasFeat(5213,OBJECT_SELF,TRUE)) // Vile Diabolism
					{
						nDamage = 1;
		                effect eDam3 = EffectDamage(nDamage, DAMAGE_TYPE_MAGICAL);
						ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam3, oTarget);
					}						
				}
			}
		}	
	}			
}