//::///////////////////////////////////////////////
//:: Sonic Orb
//:: mt_s0_sonicorb
//:: Created By: Joshua Kalis (Greg)
//:: Created On: January 1, 2007
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"

#include "x2_inc_spellhook" 

void main()
{

    if (!X2PreSpellCastCode())
    {
	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	//Declare major variables
	object oTarget = GetSpellTargetObject();
	int nCasterLvl = GetCasterLevel(OBJECT_SELF);
	
	if (nCasterLvl > 15)
		nCasterLvl = 15;
	int nDamage = d6(nCasterLvl);	
		
	effect eVis;	
	effect eOrbEffect;
	int nDamageType;
	int nSpellId = GetSpellId();
	
	nDamageType	= DAMAGE_TYPE_SONIC;
	eVis = EffectVisualEffect(VFX_HIT_SPELL_SONIC);
	eOrbEffect = EffectDeaf();
		  
	if (GetIsObjectValid(oTarget))
	{
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
		{		
		
			int nRangedTouch = TouchAttackRanged(oTarget);
			if (nRangedTouch != TOUCH_ATTACK_RESULT_MISS)
			{
				if(!MyResistSpell(OBJECT_SELF, oTarget))
				{		
						
					if (GetHasFeat(2992,OBJECT_SELF,TRUE))
						nDamage += 2;
					if (nRangedTouch == TOUCH_ATTACK_RESULT_CRITICAL)
						nDamage = nDamage * 2;
					int nMax = (nCasterLvl*8)+2;
					nDamage = ApplyMetamagicVariableMods( nDamage, nMax );					
					effect eDamage = EffectDamage(nDamage,nDamageType);
					
					//Fire cast spell at event for the specified target
					SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId()));				
	
					//Apply the effects
					ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
					ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);
					
	                if  (!MySavingThrow(SAVING_THROW_FORT, oTarget, GetSpellSaveDC(), SAVING_THROW_TYPE_SONIC))
						ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eOrbEffect, oTarget, 6.0f);
					
				
				}
			}
		}	
	}			



}