//::///////////////////////////////////////////////
//:: Soul Puppet
//:: mt_s0_soulpuppet
//:: Purpose: Dark Soul
//:: Created By: Joshua Kalis (Greg)
//:: Created On: October 18, 2015
//:: Description: Dominate Monster
//:: Mystery
//::
//:: Dominate a monster
//:://////////////////////////////////////////////

#include "nwn2_inc_spells"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {
		// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
// End of Spell Cast Hook


    //Declare major variables
    object oTarget = GetSpellTargetObject();
	
    float fDuration = TurnsToSeconds(GetCasterLevel(OBJECT_SELF));
	int nLevelShadowcaster = GetLevelByClass(99, OBJECT_SELF);
	int nLevelMasterOfShadow = GetLevelByClass(100, OBJECT_SELF);
	int nLevelNoctumancer = GetLevelByClass(101, OBJECT_SELF);
	int nLevelShadowTheurge = GetLevelByClass(103, OBJECT_SELF);
	int nCasterLvl = nLevelShadowcaster + nLevelMasterOfShadow + nLevelNoctumancer + nLevelShadowTheurge;
	
    if (GetHasFeat(5198)) // If have mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    if (GetHasFeat(5199)) // If have greater mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    int nBonus = 12 + nCasterLvl;
		
    if (GetHasFeat(5194)) // If have extend mystery, double it.
    {
        nCasterLvl = (nCasterLvl * 2);
    }		
	fDuration = TurnsToSeconds(nCasterLvl);
	
	//Declare major variables
	int nDamageLimit = nCasterLvl * 10;
    effect eDom = EffectDominated();
    eDom = GetScaledEffect(eDom, oTarget);
    effect eDur = EffectVisualEffect(VFX_DUR_SPELL_DOM_MONSTER);
	effect eLink = EffectLinkEffects(eDom, eDur);

    int nRacial = GetRacialType(oTarget);
    //Fire cast spell at event for the specified target
    SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, SPELL_DOMINATE_MONSTER, FALSE));
	
    //Make sure the target is a monster
	if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
	{
          //Make SR Check
          if (!MyResistSpell(OBJECT_SELF, oTarget))
          {
               //Make a Will Save
               if (!MySavingThrow(SAVING_THROW_WILL, oTarget, GetSpellSaveDC()+8, SAVING_THROW_TYPE_MIND_SPELLS))
    	       {
                    //Apply linked effects and VFX Impact
                    ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLink, oTarget, fDuration);		
                }
           }
     }
		
	
}