//::///////////////////////////////////////////////
//:: Steel Shadows
//:: mt_s0_steelshadows
//:: Purpose: Steel Shadows
//:: Created By: Joshua Kalis (Greg)
//:: Created On: September 19, 2015
//:: Description: Protective shadow magic.
//:: Initiate Mystery
//::
//:: You get a +3 armor and a +3 shield bonus to AC for 10 minutes a level.
//:://////////////////////////////////////////////

#include "x2_inc_spellhook"

void main()
{
   // If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run
    // this spell.
    if (!X2PreSpellCastCode())
    {
        return;
    }

    //Declare major variables
    object oTarget = GetSpellTargetObject();

	int nLevelShadowcaster = GetLevelByClass(99, OBJECT_SELF);
	int nLevelMasterOfShadow = GetLevelByClass(100, OBJECT_SELF);
	int nLevelNoctumancer = GetLevelByClass(101, OBJECT_SELF);
	int nLevelShadowTheurge = GetLevelByClass(103, OBJECT_SELF);
	int nCasterLvl = nLevelShadowcaster + nLevelMasterOfShadow + nLevelNoctumancer + nLevelShadowTheurge;
	int nBonus = 1;
    int nDuration = 1;
	
    if (GetHasFeat(5198)) // If have mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    if (GetHasFeat(5199)) // If have greater mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
	
	if(nCasterLvl < 7)
		nBonus = 1;
	else if(nCasterLvl < 13)
		nBonus = 2;
	else if(nCasterLvl < 19)
		nBonus = 3;
	else
		nBonus = 4;
	
    if (GetHasFeat(5194)) // If have extend mystery, double it.
    {
        nCasterLvl = (nCasterLvl * 2);
    }	
	
    nDuration = nCasterLvl * 60 * 10;	
	
    float fDuration = IntToFloat(nDuration);

    //Fire cast spell at event for the specified target
    SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, SPELL_MAGE_ARMOR, FALSE));

    //Set the armor bonuses
    effect eAC1 = EffectACIncrease(nBonus, AC_ARMOUR_ENCHANTMENT_BONUS);
    effect eAC2 = EffectACIncrease(nBonus, AC_SHIELD_ENCHANTMENT_BONUS);
    effect eLink = EffectLinkEffects(eAC1, eAC2);
    effect eDur = EffectVisualEffect(VFX_DUR_SPELL_MAGE_ARMOR);
    effect eLink2 = EffectLinkEffects(eLink, eDur);

    //Apply the armor bonuses and the VFX impact
    ApplyEffectToObject(2, eLink2, oTarget, fDuration);
}