//::///////////////////////////////////////////////
//:: Stone Sphere
//:: mt_s0_stonesphere
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Jan 13, 2007
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void mainSpell()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	//Declare major variables
	object oTarget = GetSpellTargetObject();
	int nCasterLvl = GetCasterLevel(OBJECT_SELF);
	int nRadius = RADIUS_SIZE_SMALL;
	
	if (nCasterLvl > 15)
		nCasterLvl = 15;

    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nCasterLvl = (nCasterLvl + 3);
		nRadius = RADIUS_SIZE_MEDIUM;
    }	
    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nCasterLvl = (nCasterLvl + 2);
    }	
    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
	
    if (GetHasFeat(3096)) // If have invisible needle, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
				
	int nDamage = d6(nCasterLvl);	
		
	effect eVis;	
	effect eOrbEffect;
	int nDamageType;
	int nSpellId = GetSpellId();
	
    //Get the spell target location as opposed to the spell target.
    location lTarget = GetSpellTargetLocation();

	// Calculate the damage type.
	nDamageType	= DAMAGE_TYPE_BLUDGEONING;
	eVis = EffectVisualEffect(VFX_HIT_SPELL_TRANSMUTATION);
		  
	int nMax = (nCasterLvl*6)+2;
	nDamage = ApplyMetamagicVariableMods( nDamage, nMax );					
	effect eDamage = EffectDamage(nDamage,nDamageType);
		
    //Declare the spell shape, size and the location.  Capture the first target object in the shape.
    oTarget = GetFirstObjectInShape(SHAPE_SPHERE, nRadius, lTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);

	//Cycle through the targets within the spell shape until an invalid object is captured.
    while (GetIsObjectValid(oTarget))
    {
		if(!MyResistSpell(OBJECT_SELF, oTarget))
		{							
			//Fire cast spell at event for the specified target
			SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId()));				

			//Apply the effects
			ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
			ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);

			if (GetHasFeat(5212,OBJECT_SELF,TRUE)) // Diabolism
			{
				int nLevelDiabolist = GetLevelByClass(96, OBJECT_SELF);
				if(nLevelDiabolist == 10)
					nDamage = 3;
				else if(nLevelDiabolist == 5)
					nDamage = 2;
				else
					nDamage = 1;	
				
                effect eDam2 = EffectDamage(nDamage, DAMAGE_TYPE_NEGATIVE);
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam2, oTarget);
			}

			if (GetHasFeat(5213,OBJECT_SELF,TRUE)) // Vile Diabolism
			{
				nDamage = 1;
                effect eDam3 = EffectDamage(nDamage, DAMAGE_TYPE_MAGICAL);
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam3, oTarget);
			}						
		}			
				
		//Select the next target within the spell shape.
    	oTarget = GetNextObjectInShape(SHAPE_SPHERE, nRadius, lTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);
    }	
}