//::///////////////////////////////////////////////
//:: Stop Heart
//:: mt_s0_stopheart
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Oct 24, 2015
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	// This is an evil spell. Casting it moves you one spot more towards evil.	
	AdjustAlignment(OBJECT_SELF, ALIGNMENT_EVIL, 1);
	
	//Declare major variables
	object oTarget = GetSpellTargetObject();
	int nCasterLvl = GetCasterLevel(OBJECT_SELF);
	
	effect eVis;	
	effect eOrbEffect;
	int nDamageType;
	int nSpellId = GetSpellId();
	
	nDamageType	= DAMAGE_TYPE_BLUDGEONING;
	eVis = EffectVisualEffect(VFX_HIT_SPELL_SONIC);
	eOrbEffect = EffectKnockdown();
	int nRacialType = GetRacialType(oTarget);
	int nCurrentHP = GetCurrentHitPoints(oTarget);	
		  
	if (GetIsObjectValid(oTarget) && (
		nRacialType != RACIAL_TYPE_CONSTRUCT &&
		nRacialType != RACIAL_TYPE_OUTSIDER &&
		nRacialType != RACIAL_TYPE_OOZE &&
		nRacialType != RACIAL_TYPE_UNDEAD &&
		nRacialType != RACIAL_TYPE_INCORPOREAL &&
		nRacialType != RACIAL_TYPE_ELEMENTAL
	))
	{
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
		{		
			if(!MyResistSpell(OBJECT_SELF, oTarget))
			{								
				if (!MySavingThrow(SAVING_THROW_FORT, oTarget, GetSpellSaveDC() + 1, SAVING_THROW_TYPE_ALL))
				{
					if(nCurrentHP > 5)
					{
						// Set to 5.
						int nDamage = nCurrentHP - 2;
						effect eBaseDmg = EffectDamage(nDamage, DAMAGE_TYPE_MAGICAL, DAMAGE_POWER_NORMAL, 1);
					}
					effect eOngoingDmg = EffectDamage(1, DAMAGE_TYPE_MAGICAL, DAMAGE_POWER_NORMAL, 1);
					DelayCommand(RoundsToSeconds(1),  ApplyEffectToObject(DURATION_TYPE_INSTANT, eOngoingDmg, oTarget));
					DelayCommand(RoundsToSeconds(2),  ApplyEffectToObject(DURATION_TYPE_INSTANT, eOngoingDmg, oTarget));
					DelayCommand(RoundsToSeconds(3),  ApplyEffectToObject(DURATION_TYPE_INSTANT, eOngoingDmg, oTarget));
					DelayCommand(RoundsToSeconds(4),  ApplyEffectToObject(DURATION_TYPE_INSTANT, eOngoingDmg, oTarget));
					DelayCommand(RoundsToSeconds(5),  ApplyEffectToObject(DURATION_TYPE_INSTANT, eOngoingDmg, oTarget));
					DelayCommand(RoundsToSeconds(6),  ApplyEffectToObject(DURATION_TYPE_INSTANT, eOngoingDmg, oTarget));
					DelayCommand(RoundsToSeconds(7),  ApplyEffectToObject(DURATION_TYPE_INSTANT, eOngoingDmg, oTarget));
				}
			}
		}	
	}		
}