//::///////////////////////////////////////////////
//:: Storm Touch
//:: mt_s0_stormtouch
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Feb 23, 2008
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void mainSpell()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        JXPostSpellCastCode();
        return;
    }

	//Declare major variables
	object oTarget = JXGetSpellTargetObject();
	int nCasterLvl = JXGetCasterLevel(OBJECT_SELF);
	if (nCasterLvl > 9)
		nCasterLvl = 5;
	int nDamage = d6(9);	
		
	effect eVis;	
	effect eOrbEffect;
	int nDamageType;
	int nSpellId = JXGetSpellId();
	
	nDamageType	= DAMAGE_TYPE_ELECTRICAL;
	eVis = EffectVisualEffect(VFX_HIT_SPELL_SONIC);
	eOrbEffect = EffectStunned();
		  
	if (GetIsObjectValid(oTarget))
	{
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
		{		
			int nMax = (nCasterLvl*8)+2;
			nDamage = ApplyMetamagicVariableMods( nDamage, nMax );
									
			effect eDamage = EffectDamage(nDamage,nDamageType);
			
			//Fire cast spell at event for the specified target
			SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, JXGetSpellId()));				

			//Apply the effects
			JXApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
			JXApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);
			
               if (!MySavingThrow(SAVING_THROW_FORT, oTarget, JXGetSpellSaveDC(), SAVING_THROW_TYPE_ELECTRICAL))
				JXApplyEffectToObject(DURATION_TYPE_TEMPORARY, eOrbEffect, oTarget, 12.0f);
		}	
	}			


	JXPostSpellCastCode();
}