//::///////////////////////////////////////////////
//:: Summon Elementals Series
//:: mt_s0_summonelementals
//:: Created By: Joshua Kalis (Greg)
//:: Created On: April 16, 2008
//:://////////////////////////////////////////////
/*
	Based on NWN original summoning spells.

    Carries out the summoning of the appropriate
    creature for the Summon Monster Series of spells
    1 to 9.  Based on alignment now, has multiple options.
*/

effect SetSummonEffect(int nSpellID);
string GetCreature( int nSpellID );
string GetCreatureAnimalDomain( int nSpellID );
int GetEffectID( int nSpellID );


#include "x2_inc_spellhook"
#include "cmi_ginc_spells" 

void mainSpell();
void main()
{
	AssignCommand(JXGetCaster(), mainSpell());
}

void mainSpell()
{

/* 
  Spellcast Hook Code 
  Added 2003-06-23 by GeorgZ
  If you want to make changes to all spells,
  check x2_inc_spellhook.nss to find out more
  
*/

    if (!X2PreSpellCastCode())
    {
	    // If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        JXPostSpellCastCode();
		return;
    }

// End of Spell Cast Hook


    //Declare major variables
    int nSpellID = JXGetSpellId();
    int nDuration = JXGetCasterLevel(OBJECT_SELF) + 3;
    effect eSummon = SetSummonEffect(nSpellID);
	
    if (GetHasFeat(5036) & (nSpellID = 2432 || 2433 || 2434))
    {
        nDuration = (nDuration + 1);
    }

    //Make metamagic check for extend
    int nMetaMagic = JXGetMetaMagicFeat();
    if (nMetaMagic & METAMAGIC_EXTEND)
    {
        nDuration = nDuration * 2;	//Duration is +100%
    }
    //Apply the VFX impact and summon effect

    JXApplyEffectAtLocation(DURATION_TYPE_TEMPORARY, eSummon, JXGetSpellTargetLocation(), RoundsToSeconds(nDuration));
	DelayCommand(6.0f, BuffSummons(OBJECT_SELF));
	
	JXPostSpellCastCode();
}


effect SetSummonEffect(int nSpellID)
{
 	int nFNF_Effect = GetEffectID( nSpellID );
  
    string sSummon = "c_cat";

	sSummon = GetCreatureAnimalDomain( nSpellID );
    effect eSummonedMonster = EffectSummonCreature(sSummon, nFNF_Effect);
    return eSummonedMonster;
}



string GetCreatureAnimalDomain( int nSpellID )
{
	int nRoll = d4();
	string sSummon = "c_cat";
	int pcClass = GetClassByPosition(1, OBJECT_SELF);
	int goodEvil = GetAlignmentGoodEvil(OBJECT_SELF);
	int lawChaos = GetAlignmentLawChaos(OBJECT_SELF);
	
	switch (nSpellID)
	{
	case (2429): // Huge Water Elemental
       {
         	sSummon = "c_elmwaterhuge";
       }
	break;
	case (2430): // Greater Water Elemental
       {
         	sSummon = "c_elmwatergreater";
       }
	break;
	case (2431): // Elder Water Elemental
       {
         	sSummon = "c_elmwaterelder";
       }
	break;
	case (2432): // Huge Fire Elemental
       {
         	sSummon = "c_elmfirehuge";
       }
	break;
	case (2433): // Greater Fire Elemental
       {
         	sSummon = "c_elmfiregreater";
       }
	break;
	case (2434): // Elder Fire Elemental
       {
         	sSummon = "c_elmfireelder";
       }
	break;
	case (2435): // Huge Earth Elemental
       {
         	sSummon = "c_elmearthhuge";
       }
	break;
	case (2436): // Greater Earth Elemental
       {
         	sSummon = "c_elmearthgreater";
       }
	break;
	case (2437): // Elder Earth Elemental
       {
         	sSummon = "c_elmearthelder";
       }
	break;
	case (2438): // Huge Air Elemental
       {
         	sSummon = "c_elmairhuge";
       }
	break;
	case (2439): // Greater Air Elemental
       {
         	sSummon = "c_elmairgreater";
       }
	break;
	case (2440): // Elder Air Elemental
       {
         	sSummon = "c_elmairelder";
       }
	break;
	}
	return sSummon;
}


string GetCreature( int nSpellID )
{
	int nRoll = d3();
	string sSummon = "c_chicken";

	switch ( nSpellID )
	{
	case (SPELL_SUMMON_CREATURE_I):
        {
            sSummon = "c_badger";
        }
	break;
	case (SPELL_SUMMON_CREATURE_II):
		{
            sSummon = "c_boar";
        }
	break;
	case (SPELL_SUMMON_CREATURE_III):
        {
            sSummon = "c_dogwolf";
        }
	break;
	case (SPELL_SUMMON_CREATURE_IV):
        {
            sSummon = "c_bear";
        }
	break;
	case (SPELL_SUMMON_CREATURE_V):
        {
            sSummon = "c_doghell";
        }
	break;
	case (SPELL_SUMMON_CREATURE_VI):
        {
            sSummon = "c_bugbear";
        }
	break;
	case (SPELL_SUMMON_CREATURE_VII):
        {
            switch (nRoll)
            {
               case 1:	sSummon = "c_impfire";		break;
               case 2:	sSummon = "c_impice";		break;
               case 3:	sSummon = "c_ratdire";		break;
            }
        }
	break;
	case (SPELL_SUMMON_CREATURE_VIII):
        {
            switch (nRoll)
            {
               case 1:	sSummon = "c_impfire";		break;
               case 2:	sSummon = "c_impice";		break;
               case 3:	sSummon = "c_ratdire";		break;
            }
        }
	break;
	case (SPELL_SUMMON_CREATURE_IX):
        {
            switch (nRoll)
            {
               case 1:	sSummon = "c_impfire";		break;
               case 2:	sSummon = "c_impice";		break;
               case 3:	sSummon = "c_ratdire";		break;
            }
        }
	break;
	}

	return sSummon;
}

int GetEffectID( int nSpellID )
{
	return VFX_HIT_SPELL_SUMMON_CREATURE;
}