//::///////////////////////////////////////////////
//:: Summon Nature's Ally 1-9
//:: mt_s0_summonnaturesally
//:: Purpose: Separate summoning line for druids, better spells than summon creature line.
//:: Created By: Joshua Kalis (Greg)
//:: Created On: October 26, 2015
//:://////////////////////////////////////////////

#include "nwn2_inc_spells"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {
		// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
// End of Spell Cast Hook


    //Declare major variables	
	int nCasterLvl = GetCasterLevel(OBJECT_SELF);
	
    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nCasterLvl = (nCasterLvl + 3);
    }	
    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nCasterLvl = (nCasterLvl + 2);
    }	
    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
	
    if (GetHasFeat(3100)) // If have summon elemental, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	

	int nSpellId = GetSpellId();
	int nNum = d4(1) + 1;
    location lTarget 	= GetSpellTargetLocation();
    float fDuration = TurnsToSeconds(nCasterLvl);		
	fDuration = RoundsToSeconds(nCasterLvl + 3);

	int nMetaMagic = GetMetaMagicFeat();
    if (nMetaMagic & METAMAGIC_EXTEND)
    {
        fDuration = fDuration * 2.0;	//Duration is +100%
    }
	
	// Summon specific variables
	string sSummon = "c_dogwolf";
	nNum = 1;
	
	// If it is current level only 1 summoned, else 1-5 depending on how much weaker they are.
	// Level X   = 1
	// Level X-1 = 1d3
	// Level X-2 = 1d4+1	
	//
	if(nSpellId == 2618) // I
	{
		// Level 1 - Dire Rat, Wolf, Panther
		// 100% level 1
		int nChoice = d3(1);
		
		if(nChoice == 1)
			sSummon = "c_ratdire";
		else if(nChoice == 2)
			sSummon = "c_panther";
		else
			sSummon = "c_dogwolf";
	}
	else if(nSpellId == 2619) // II
	{
		// Level 2 - Dire Badger, Giant Spider, Small Elemental, Worg
		// 90% level 2
		// 10% level 1
		int nGoLower = d100(1);
		
		if(nGoLower >= 11)
		{
			int nChoice = d4(1);
			
			if(nChoice == 1)
				sSummon = "c_badgerdire";
			else if(nChoice == 2)
				sSummon = "c_spidgiant";
			else if(nChoice == 3)
				sSummon = "c_worg";
			else
			{
				nChoice = d4(1);
				
				if(nChoice == 1)
					sSummon = "c_s2_elmairsm";
				else if(nChoice == 2)
					sSummon = "c_s2_elmearthsm";
				else if(nChoice == 3)
					sSummon = "c_s2_elmfiresm";
				else
					sSummon = "c_s2_elmwatersm";
			}
		}
		else
		{
			nNum = d3(1);
			
			int nChoice = d3(1);
			
			if(nChoice == 1)
				sSummon = "c_ratdire";
			else if(nChoice == 2)
				sSummon = "c_panther";
			else
				sSummon = "c_dogwolf";
		}
	}
	else if(nSpellId == 2620) // III
	{
		// Level 3 - Brown Bear, Dire Wolf, Snow Leopard, Stag Beetle
		// 70% level 3
		// 20% level 2
		// 10% level 1
		int nGoLower = d100(1);
		
		if(nGoLower <= 70 )
		{
			int nChoice = d4(1);
			
			if(nChoice == 1)
				sSummon = "c_bear";
			else if(nChoice == 2)
				sSummon = "c_dogwolfdire";
			else if(nChoice == 3)
				sSummon = "c_snowleopard";
			else
				sSummon = "c_beetlestag";
		}
		else if(nGoLower >= 71 && nGoLower < 90)
		{
			nNum = d3(1);
			
			int nChoice = d4(1);
			
			if(nChoice == 1)
				sSummon = "c_badgerdire";
			else if(nChoice == 2)
				sSummon = "c_spidgiant";
			else if(nChoice == 3)
				sSummon = "c_worg";
			else
			{
				nChoice = d4(1);
				
				if(nChoice == 1)
					sSummon = "c_s2_elmairsm";
				else if(nChoice == 2)
					sSummon = "c_s2_elmearthsm";
				else if(nChoice == 3)
					sSummon = "c_s2_elmfiresm";
				else
					sSummon = "c_s2_elmwatersm";
			}
		}
		else
		{
			nNum = d4(1)+1;
			
			int nChoice = d3(1);
			
			if(nChoice == 1)
				sSummon = "c_ratdire";
			else if(nChoice == 2)
				sSummon = "c_panther";
			else
				sSummon = "c_dogwolf";
		}
	}
	else if(nSpellId == 2621) // IV
	{
		// Level 4 - Deinonychus, Dire Wolverine, Dryad, Medium Elemental
		// 70% level 4
		// 20% level 3
		// 10% level 2
		int nGoLower = d100(1);
		
		if(nGoLower <= 70 )
		{
			int nChoice = d4(1);
			
			if(nChoice == 1)
				sSummon = "c_deinonychus";
			else if(nChoice == 2)
				sSummon = "c_wolverinedire";
			else if(nChoice == 3)
				sSummon = "c_dryad";
			else
			{
				nChoice = d4(1);
				
				if(nChoice == 1)
					sSummon = "c_elmair";
				else if(nChoice == 2)
					sSummon = "c_elmearth";
				else if(nChoice == 3)
					sSummon = "c_elmfire";
				else
					sSummon = "c_elmwater";
			}
		}
		else if(nGoLower >= 71 && nGoLower < 90)
		{
			nNum = d3(1);
						
			int nChoice = d4(1);
			
			if(nChoice == 1)
				sSummon = "c_bear";
			else if(nChoice == 2)
				sSummon = "c_dogwolfdire";
			else if(nChoice == 3)
				sSummon = "c_snowleopard";
			else
				sSummon = "c_beetlestag";
		}
		else
		{
			nNum = d4(1)+1;
			
			int nChoice = d4(1);
			
			if(nChoice == 1)
				sSummon = "c_direbadger";
			else if(nChoice == 2)
				sSummon = "c_spidgiant";
			else if(nChoice == 3)
				sSummon = "c_worg";
			else
			{
				nChoice = d4(1);
				
				if(nChoice == 1)
					sSummon = "c_s2_elmairsm";
				else if(nChoice == 2)
					sSummon = "c_s2_elmearthsm";
				else if(nChoice == 3)
					sSummon = "c_s2_elmfiresm";
				else
					sSummon = "c_s2_elmwatersm";
			}
		}
	}
	else if(nSpellId == 2622) // V
	{
		// Level 5 - Celestial Bear, Dire Boar, Djinni, Large Elemental, Phase Spider, Winter Wolf
		// 70% level 5
		// 20% level 4
		// 10% level 3
		int nGoLower = d100(1);
		
		if(nGoLower <= 70 )
		{
			int nChoice = d6(1);
			
			if(nChoice == 1)
				sSummon = "c_celestialbear";
			else if(nChoice == 2)
				sSummon = "c_boardire";
			else if(nChoice == 3)
				sSummon = "c_djinni";
			else if(nChoice == 4)
				sSummon = "c_spidphase";
			else if(nChoice == 5)
				sSummon = "c_dogwolfwin";
			else
			{
				nChoice = d4(1);
				
				if(nChoice == 1)
					sSummon = "c_elmaigreaterr";
				else if(nChoice == 2)
					sSummon = "c_elmearthgreater";
				else if(nChoice == 3)
					sSummon = "c_elmfiregreater";
				else
					sSummon = "c_elmwatergreater";
			}
		}
		else if(nGoLower >= 71 && nGoLower < 90)
		{
			nNum = d3(1);
						
			int nChoice = d4(1);
			
			if(nChoice == 1)
				sSummon = "c_deinonychus";
			else if(nChoice == 2)
				sSummon = "c_wolverinedire";
			else if(nChoice == 3)
				sSummon = "c_dryad";
			else
			{
				nChoice = d4(1);
				
				if(nChoice == 1)
					sSummon = "c_elmair";
				else if(nChoice == 2)
					sSummon = "c_elmearth";
				else if(nChoice == 3)
					sSummon = "c_elmfire";
				else
					sSummon = "c_elmwater";
			}
		}
		else
		{
			nNum = d4(1)+1;
			
			int nChoice = d4(1);
			
			if(nChoice == 1)
				sSummon = "c_bear";
			else if(nChoice == 2)
				sSummon = "c_dogwolfdire";
			else if(nChoice == 3)
				sSummon = "c_snowleopard";
			else
				sSummon = "c_beetlestag";
		}
	}
	else if(nSpellId == 2623) // VI
	{
		// Level 6 - Dire Bear, Fiendish Monstrous Spider, Pixie
		// 70% level 6
		// 20% level 5
		// 10% level 4
		int nGoLower = d100(1);
		
		if(nGoLower <= 70 )
		{
			int nChoice = d3(1);
			
			if(nChoice == 1)
				sSummon = "c_fiendish_spider";
			else if(nChoice == 2)
				sSummon = "c_beardire";
			else
				sSummon = "c_pixie";
		}
		else if(nGoLower >= 71 && nGoLower < 90)
		{
			nNum = d3(1);
						
			int nChoice = d6(1);
			
			if(nChoice == 1)
				sSummon = "c_celestialbear";
			else if(nChoice == 2)
				sSummon = "c_boardire";
			else if(nChoice == 3)
				sSummon = "c_djinni";
			else if(nChoice == 4)
				sSummon = "c_spidphase";
			else if(nChoice == 5)
				sSummon = "c_dogwolfwin";
			else
			{
				nChoice = d4(1);
				
				if(nChoice == 1)
					sSummon = "c_elmairgreater";
				else if(nChoice == 2)
					sSummon = "c_elmearthgreater";
				else if(nChoice == 3)
					sSummon = "c_elmfiregreater";
				else
					sSummon = "c_elmwatergreater";
			}
		}
		else
		{
			nNum = d4(1)+1;
			
			int nChoice = d4(1);
			
			if(nChoice == 1)
				sSummon = "c_deinonychus";
			else if(nChoice == 2)
				sSummon = "c_wolverinedire";
			else if(nChoice == 3)
				sSummon = "c_dryad";
			else
			{
				nChoice = d4(1);
				
				if(nChoice == 1)
					sSummon = "c_elmair";
				else if(nChoice == 2)
					sSummon = "c_elmearth";
				else if(nChoice == 3)
					sSummon = "c_elmfire";
				else
					sSummon = "c_elmwater";
			}
		}
	}
	else if(nSpellId == 2624) // VII
	{
		// Level 7 - Huge Elemental, Megaraptor
		// 70% level 7
		// 20% level 6
		// 10% level 5
		int nGoLower = d100(1);
		
		if(nGoLower <= 70 )
		{
			int nChoice = d4(1);
			
			if(nChoice == 1)
				sSummon = "c_megaraptor";
			else
			{
				nChoice = d4(1);
				
				if(nChoice == 1)
					sSummon = "c_elmairhuge";
				else if(nChoice == 2)
					sSummon = "c_elmearthhuge";
				else if(nChoice == 3)
					sSummon = "c_elmfirehuge";
				else
					sSummon = "c_elmwaterhuge";
			}
		}
		else if(nGoLower >= 71 && nGoLower < 90)
		{
			nNum = d3(1);
						
			int nChoice = d6(1);
			
			if(nChoice == 1)
				sSummon = "c_celestialbear";
			else if(nChoice == 2)
				sSummon = "c_boardire";
			else if(nChoice == 3)
				sSummon = "c_djinni";
			else if(nChoice == 4)
				sSummon = "c_spidphase";
			else if(nChoice == 5)
				sSummon = "c_dogwolfwin";
			else
			{
				nChoice = d4(1);
				
				if(nChoice == 1)
					sSummon = "c_elmairgreater";
				else if(nChoice == 2)
					sSummon = "c_elmearthgreater";
				else if(nChoice == 3)
					sSummon = "c_elmfiregreater";
				else
					sSummon = "c_elmwatergreater";
			}
		}
		else
		{
			nNum = d4(1)+1;
			
			int nChoice = d4(1);
			
			if(nChoice == 1)
				sSummon = "c_deinonychus";
			else if(nChoice == 2)
				sSummon = "c_wolverinedire";
			else if(nChoice == 3)
				sSummon = "c_dryad";
			else
			{
				nChoice = d4(1);
				
				if(nChoice == 1)
					sSummon = "c_elmair";
				else if(nChoice == 2)
					sSummon = "c_elmearth";
				else if(nChoice == 3)
					sSummon = "c_elmfire";
				else
					sSummon = "c_elmwater";
			}
		}
	}
	else if(nSpellId == 2625) // VIII
	{
		// Level 8 - Celestial Dire Bear, Slyph
		// 70% level 8
		// 20% level 7
		// 10% level 6
		int nGoLower = d100(1);
		
		if(nGoLower <= 70 )
		{
			int nChoice = d3(1);
			
			if(nChoice == 1)
				sSummon = "c_slyph";
			else
				sSummon = "c_celestialdbear";
		}
		else if(nGoLower >= 71 && nGoLower < 90)
		{
			nNum = d3(1);
						
			int nChoice = d4(1);
			
			if(nChoice == 1)
				sSummon = "c_megaraptor";
			else
			{
				nChoice = d4(1);
				
				if(nChoice == 1)
					sSummon = "c_elmairhuge";
				else if(nChoice == 2)
					sSummon = "c_elmearthhuge";
				else if(nChoice == 3)
					sSummon = "c_elmfirehuge";
				else
					sSummon = "c_elmwaterhuge";
			}
		}
		else
		{
			nNum = d4(1)+1;
			
			int nChoice = d6(1);
			
			if(nChoice == 1)
				sSummon = "c_celestialbear";
			else if(nChoice == 2)
				sSummon = "c_boardire";
			else if(nChoice == 3)
				sSummon = "c_djinni";
			else if(nChoice == 4)
				sSummon = "c_spidphase";
			else if(nChoice == 5)
				sSummon = "c_dogwolfwin";
			else
			{
				nChoice = d4(1);
				
				if(nChoice == 1)
					sSummon = "c_elmairgreater";
				else if(nChoice == 2)
					sSummon = "c_elmearthgreater";
				else if(nChoice == 3)
					sSummon = "c_elmfiregreater";
				else
					sSummon = "c_elmwatergreater";
			}
		}
	}
	else if(nSpellId == 2626) // IX
	{
		// Level 9 - Elder Elemental
		// 70% level 9
		// 20% level 8
		// 10% level 7
		int nGoLower = d100(1);
		
		if(nGoLower <= 70 )
		{
			int nChoice = d3(1);
			
			nChoice = d4(1);
			
			if(nChoice == 1)
				sSummon = "c_elmairelder";
			else if(nChoice == 2)
				sSummon = "c_elmearthelder";
			else if(nChoice == 3)
				sSummon = "c_elmfireelder";
			else
				sSummon = "c_elmwaterelder";
		}
		else if(nGoLower >= 71 && nGoLower < 90)
		{
			nNum = d3(1);
						
			int nChoice = d3(1);
			
			if(nChoice == 1)
				sSummon = "c_slyph";
			else
				sSummon = "c_celestialdbear";
		}
		else
		{
			nNum = d4(1)+1;
			
			int nChoice = d4(1);
			
			if(nChoice == 1)
				sSummon = "c_megaraptor";
			else
			{
				nChoice = d4(1);
				
				if(nChoice == 1)
					sSummon = "c_elmairhuge";
				else if(nChoice == 2)
					sSummon = "c_elmearthhuge";
				else if(nChoice == 3)
					sSummon = "c_elmfirehuge";
				else
					sSummon = "c_elmwaterhuge";
			}
		}
	}
	
	int nLoop = 0;
	while(nLoop <= nNum)
	{
		object oSummon = CreateObject(OBJECT_TYPE_CREATURE, sSummon, lTarget, TRUE);
		effect eUnsummon = EffectVisualEffect(VFX_IMP_UNSUMMON);
		effect eVis = EffectVisualEffect(VFX_FNF_SUMMON_EPIC_UNDEAD);
		
		if (GetHasFeat(FEAT_AUGMENT_SUMMONING))
		{
			int nStr = 4;
			int nCon = 4;
					
			effect eStr = EffectAbilityIncrease(ABILITY_STRENGTH, nStr);
			effect eCon = EffectAbilityIncrease(ABILITY_CONSTITUTION, nCon);
			effect eAttack = EffectAttackIncrease(nStr, ATTACK_BONUS_MISC);
			effect eHP = EffectTemporaryHitpoints(nCon * 10);
				
			effect eLink = EffectLinkEffects(eStr, eCon);
			eLink = EffectLinkEffects(eLink, eAttack);
			eLink = EffectLinkEffects(eLink, eHP);
			eLink = SupernaturalEffect(eLink);
			
			ApplyEffectToObject(DURATION_TYPE_PERMANENT, eLink, oSummon);
		}
	
		ChangeFaction(oSummon, OBJECT_SELF);
		int nHenchies = GetMaxHenchmen();
		SetMaxHenchmen(nHenchies+50);
		AddHenchman(OBJECT_SELF, oSummon);
		SetMaxHenchmen(nHenchies);
	
		ApplyEffectAtLocation(DURATION_TYPE_INSTANT, eVis, lTarget);
	
		DelayCommand(fDuration, RemoveHenchman(OBJECT_SELF, oSummon));
		DelayCommand(fDuration, DestroyObject(oSummon, 0.1f));
		DelayCommand(fDuration, ApplyEffectAtLocation(DURATION_TYPE_INSTANT, eUnsummon, GetLocation(oSummon)));		
		
		nLoop++;
	}		
}