//::///////////////////////////////////////////////
//:: Summon Undead I-V
//:: mt_s0_summonundead
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Oct 24, 2015
//:://////////////////////////////////////////////
/*
	Based on NWN original summoning spells.

    Carries out the summoning of the appropriate
    creature for the Summon Monster Series of spells
    1 to 9.  Based on alignment now, has multiple options.
*/

effect SetSummonEffect(int nSpellID);


#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
// End of Spell Cast Hook

    //Declare major variables
    int nSpellID = GetSpellId();
    int nCasterLvl = GetCasterLevel(OBJECT_SELF) + 3;
	
    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nCasterLvl = (nCasterLvl + 3);
    }	
    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nCasterLvl = (nCasterLvl + 2);
    }	
    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
	
    if (GetHasFeat(3100)) // If have summon elemental, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	

	int nDuration = nCasterLvl;	
    effect eSummon = SetSummonEffect(nSpellID);

    //Make metamagic check for extend
    int nMetaMagic = GetMetaMagicFeat();
    if (nMetaMagic & METAMAGIC_EXTEND)
    {
        nDuration = nDuration * 2;	//Duration is +100%
    }
    //Apply the VFX impact and summon effect

    ApplyEffectAtLocation(DURATION_TYPE_TEMPORARY, eSummon, GetSpellTargetLocation(), RoundsToSeconds(nDuration));
}


effect SetSummonEffect(int nSpellID)
{
 	int nFNF_Effect = VFX_HIT_SPELL_SUMMON_CREATURE;
	int pcClass = GetClassByPosition(1, OBJECT_SELF);
	int goodEvil = GetAlignmentGoodEvil(OBJECT_SELF);
	int lawChaos = GetAlignmentLawChaos(OBJECT_SELF);	
	string sSummon = "c_cat";
	int nSpellId = GetSpellId();

	if(nSpellId == 2598) // Summon Undead I
		sSummon = "c_skeleton";
	if(nSpellId == 2598) // Summon Undead II
		sSummon = "c_zombie";
		
	if(nSpellId == 2598) // Summon Undead III
		sSummon = "c_ghoul";
	if(nSpellId == 2598) // Summon Undead IV
		sSummon = "c_ghast";
	else if(nSpellId == 2598) // Summon Undead V
	{
		int nDie = d3(1);
		
		if(nDie == 1)
			sSummon = "c_mummy";		   
		else if(nDie == 2)
			sSummon = "c_shadow";		   
		else
			sSummon = "c_wight";
	}
	else // Error
		sSummon = "c_skeleton";
	
    effect eSummonedMonster = EffectSummonCreature(sSummon, nFNF_Effect);
    return eSummonedMonster;
}