//::///////////////////////////////////////////////
//:: Summon Wyvern
//:: mt_s0_summonwyvern
//:: Created By: Joshua Kalis (Greg)
//:: Created On: April 16, 2008
//:://////////////////////////////////////////////
/*
	Based on NWN original summoning spells.

    Carries out the summoning of the appropriate
    creature for the Summon Monster Series of spells
    1 to 9.  Based on alignment now, has multiple options.
*/

effect SetSummonEffect(int nSpellID);
int GetEffectID( int nSpellID );

#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
// End of Spell Cast Hook

    //Declare major variables
    int nSpellID = GetSpellId();
    int nCasterLvl = GetCasterLevel(OBJECT_SELF) + 3;

    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nCasterLvl = (nCasterLvl + 3);
    }	
    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nCasterLvl = (nCasterLvl + 2);
    }	
    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
	
    if (GetHasFeat(3100)) // If have summon elemental, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
		
	int nDuration = nCasterLvl;
    effect eSummon = SetSummonEffect(nSpellID);

    //Make metamagic check for extend
    int nMetaMagic = GetMetaMagicFeat();
    if (nMetaMagic & METAMAGIC_EXTEND)
    {
        nDuration = nDuration * 2;	//Duration is +100%
    }
    //Apply the VFX impact and summon effect

    ApplyEffectAtLocation(DURATION_TYPE_TEMPORARY, eSummon, GetSpellTargetLocation(), RoundsToSeconds(nDuration));
}

effect SetSummonEffect(int nSpellID)
{
    int nLevel = GetCasterLevel(OBJECT_SELF);
 	int nFNF_Effect = GetEffectID( nSpellID );
  
    string sSummon = "c_cat";
	
	   		if(nLevel < 12)
			{
         		sSummon = "c_wyvern";
			}
			else if(nLevel < 16)
			{
         		sSummon = "f_wyvern";
			}
			else
			{
         		sSummon = "g_wyvern_2";
			}

    effect eSummonedMonster = EffectSummonCreature(sSummon, nFNF_Effect);
    return eSummonedMonster;
}

int GetEffectID( int nSpellID )
{
	return VFX_HIT_SPELL_SUMMON_CREATURE;
}