//::///////////////////////////////////////////////
//:: Theskyn's Hearty Heave
//:: mt_s0_theskynshearty
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Oct 17, 2015
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	//Declare major variables
	object oTarget = GetSpellTargetObject();
	int nSpellId = GetSpellId();
	int nCasterLvl = GetCasterLevel(OBJECT_SELF);
	
	if (nCasterLvl > 8)
		nCasterLvl = 8;

	// For Force Specialization feat from Argent Savant.		
	int nSpecialization = 0; 	
	if (GetHasFeat(5218,OBJECT_SELF,TRUE))
		nSpecialization = 1;

	// Invisible Needle		
	if (GetHasFeat(3096,OBJECT_SELF,TRUE))
		nSpecialization += 1;
				
	int nDamage = d6(1) + (nSpecialization * nCasterLvl);	
		
	effect eVis;	
	effect eOrbEffect;
	int nDamageType;
	
    //Get the spell target location as opposed to the spell target.
    location lTarget = GetSpellTargetLocation();

	// Calculate the damage type.
	nDamageType	= DAMAGE_TYPE_BLUDGEONING;
	eVis = EffectVisualEffect(VFX_HIT_SPELL_TRANSMUTATION);
		  
	int nMax = (nCasterLvl*6)+2;
	nDamage = ApplyMetamagicVariableMods( nDamage, nMax );					
	effect eDamage = EffectDamage(nDamage,nDamageType);
		
    //Declare the spell shape, size and the location.  Capture the first target object in the shape.
    oTarget = GetFirstObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_MEDIUM, lTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);

	//Cycle through the targets within the spell shape until an invalid object is captured.
    while (GetIsObjectValid(oTarget))
    {
		if(!MyResistSpell(OBJECT_SELF, oTarget))
		{							
			//Fire cast spell at event for the specified target
			SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, nSpellId));				

			//Apply the effects
			ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
			ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);
			
			effect eKnockdown = EffectKnockdown();
			
            // * DO a strength check vs. Strength 20 + caster level to limits
            if (d20() + GetAbilityScore(oTarget, ABILITY_STRENGTH) <= 20 + nCasterLvl + d20() )
            {
				ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eKnockdown, oTarget, 12.0f);				
			}								
		}					
		
		//Select the next target within the spell shape.
    	oTarget = GetNextObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_SMALL, lTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);
    }
}