//::///////////////////////////////////////////////
//:: Thunderlance
//:: mt_s0_thunderlance
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Jan 1, 2007
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"

#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	//Declare major variables
	object oTarget = GetSpellTargetObject();
	int nCasterLvl = GetCasterLevel(OBJECT_SELF);		
	effect eVis;	
	int nDamageType;
	int nSpellId = GetSpellId();

    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nCasterLvl = (nCasterLvl + 3);
    }	
    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nCasterLvl = (nCasterLvl + 2);
    }	
    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	

	// For Force Specialization feat from Argent Savant.		
	int nSpecialization = 0; 	
	if (GetHasFeat(5218,OBJECT_SELF,TRUE))
		nSpecialization = 1;	

	// Invisible Needle		
	if (GetHasFeat(3096,OBJECT_SELF,TRUE))
		nSpecialization += 1;
				  
	if (GetIsObjectValid(oTarget))
	{
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
		{				
			if(!MyResistSpell(OBJECT_SELF, oTarget))
			{															
				int nDamage = ((d6(6) + 1) / 2) + nSpecialization;	
				nDamageType	= DAMAGE_TYPE_MAGICAL;
				eVis = EffectVisualEffect(VFX_HIT_SPELL_ELDRITCH);
				effect eDamage = EffectDamage(nDamage,nDamageType);
				
				//Fire cast spell at event for the specified target
				SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, nSpellId));				
	
				//Apply the effects
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);
				
				
				nDamage = (d6(6) + 1) / 2;	
				nDamageType	= DAMAGE_TYPE_PIERCING;
				eDamage = EffectDamage(nDamage,nDamageType);
				
				//Fire cast spell at event for the specified target
				SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, nSpellId));				
	
				//Apply the effects
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eDamage, oTarget);
				
				
				effect eDispelEffect = EffectDispelMagicAll(4, ActionWait( 0.2f));
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eDispelEffect, oTarget);
			}
		}	
	}			
}