//::///////////////////////////////////////////////
//:: Sphere of Ultimate Destruction
//:: mt_s0_ultimatesphere
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Jan 8, 2008
//:://////////////////////////////////////////////

#include "NW_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
// End of Spell Cast Hook

    //Declare major variables including Area of Effect Object
    effect eAOE = EffectAreaOfEffect(AOE_PER_DARKNESS);
    object oTarget = GetSpellTargetObject();
	if (GetIsObjectValid(oTarget))
		SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, SPELL_DARKNESS));
	
    location lTarget = GetSpellTargetLocation();
    int nDuration = GetCasterLevel(OBJECT_SELF);
		
	int nMeta = GetMetaMagicFeat();
	
    //Make sure duration does not equal 0
    if (nDuration < 1)
    {
        nDuration = 1;
    }
    //Check Extend metamagic feat.
    if (nMeta & METAMAGIC_EXTEND)
    {
	   nDuration = nDuration *2;	//Duration is +100%
    }
    //Create an instance of the AOE Object using the Apply Effect function
    ApplyEffectAtLocation(DURATION_TYPE_TEMPORARY, eAOE, lTarget, RoundsToSeconds(nDuration));

	// Now apply the special damage.	
	//Declare major variables
	int nCasterLvl = GetCasterLevel(OBJECT_SELF);
	int nSpellSaveDC = GetSpellSaveDC() + 2;
	
	nCasterLvl = 2;
	
    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nCasterLvl = (nCasterLvl + 3);
        nSpellSaveDC = (nSpellSaveDC + 3);
    }	
    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nCasterLvl = (nCasterLvl + 2);
        nSpellSaveDC = (nSpellSaveDC + 2);
    }	
    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
        nSpellSaveDC = (nSpellSaveDC + 1);
    }	

	
	int nDamage = d8(nCasterLvl);	
	
	
	
	effect eVis;	
	effect eOrbEffect;
	int nDamageType;
	int nSpellId = GetSpellId();
    object oCaster  = OBJECT_SELF;
    effect eBeam    = EffectBeam( VFX_BEAM_TRANSMUTATION, oCaster, BODY_NODE_HAND );	// NWN2 VFX
	int nSave		= 0;
	int nDice;
	
	//Declare the spell shape, size and the location.  Capture the first target object in the shape.
	oTarget = GetFirstObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_HUGE, lTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);

	//Cycle through the targets within the spell shape until an invalid object is captured.
	while (GetIsObjectValid(oTarget))
	{
               nSave = FortitudeSave( oTarget, nSpellSaveDC, SAVING_THROW_TYPE_NONE, oCaster ); // SAVING_THROW_TYPE_DEATH?

               if ( nSave == 0 ) // Saving Throw failed
               {
                   nDice = nCasterLvl * 2; // BCH 03/10/06 - changed to caster level * 2, to reflect
											//	script comment that damage is 2d6 per caster level
			
                   if ( nDice > 60 )
				   	 nDice = 60;	// AFW-OEI 06/06/2007: Cap before doubling for crits.
				
               }
               else if ( nSave == 1 ) // Saving Throw succeeded
               {
					nDice = 10;
                }
               else if ( nSave == 2 )  // Target is immune
               {
               	return; 
			 	// Nothing? pop up some text, maybe?
               }
			
			//if maximized 6 * ndice
			if (nMeta & METAMAGIC_MAXIMIZE)
			{
				nDamage = 6 * nDice;
			}
			else if (nMeta & METAMAGIC_EMPOWER)
			{
				nDamage = d6( nDice );
				nDamage = nDamage + nDamage / 2;
			}
			else
			{
				nDamage = d6( nDice );
			}
			
			// If we should damage the target, apply it now
               if ( nDamage > 0 )
               {
				
					effect eHit = EffectVisualEffect(VFX_HIT_SPELL_TRANSMUTATION);
	                ApplyEffectToObject(DURATION_TYPE_INSTANT, EffectDamage(nDamage, DAMAGE_TYPE_MAGICAL), oTarget);	
					ApplyEffectToObject(DURATION_TYPE_INSTANT, eHit, oTarget);
					int nHP = GetCurrentHitPoints( oTarget );
					
					if (nHP <= 0  )
					{
					    // If they are at or below 0 hit points, disintegrate them!
						ApplyEffectToObject(DURATION_TYPE_INSTANT, EffectDisintegrate( oTarget ), oTarget);
					}
               }
			
			ApplyEffectToObject( DURATION_TYPE_TEMPORARY, eBeam, oTarget, 1.7 );

		//Select the next target within the spell shape.
		oTarget = GetNextObjectInShape(SHAPE_SPHERE, RADIUS_SIZE_HUGE, lTarget, TRUE, OBJECT_TYPE_CREATURE | OBJECT_TYPE_DOOR | OBJECT_TYPE_PLACEABLE);
	}
}