//::///////////////////////////////////////////////
//:: Umbral Hand
//:: mt_s0_umbralhand
//:: Purpose: Fundamental Mystery - Umbral Hand
//:: Created By: Joshua Kalis (Greg)
//:: Created On: September 19, 2015
//:: Description: Bonus to 'hand' skills
//:: Fundamental Mystery
//::
//:: You get a bonus to hand related skills.
//:://////////////////////////////////////////////

#include "x2_inc_spellhook"

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
// End of Spell Cast Hook


    //Declare major variables
    object oTarget = GetSpellTargetObject();
    int nLevel = GetCasterLevel(oTarget);
    int nBonus = 2;

	effect eLore1 = EffectSkillIncrease(SKILL_CRAFT_ALCHEMY, nBonus);
    effect eLore2 = EffectSkillIncrease(SKILL_CRAFT_ARMOR, nBonus);
    effect eLore3 = EffectSkillIncrease(SKILL_CRAFT_TRAP, nBonus);
    effect eLore4 = EffectSkillIncrease(SKILL_CRAFT_WEAPON, nBonus);
    effect eLore5 = EffectSkillIncrease(SKILL_DISABLE_TRAP, nBonus);
    effect eLore6 = EffectSkillIncrease(SKILL_OPEN_LOCK, nBonus);
    effect eLore7 = EffectSkillIncrease(SKILL_SLEIGHT_OF_HAND, nBonus);
    effect eVis = EffectVisualEffect( VFX_DUR_SPELL_LEGEND_LORE );

	int nLevelShadowcaster = GetLevelByClass(99, OBJECT_SELF);
	int nLevelMasterOfShadow = GetLevelByClass(100, OBJECT_SELF);
	int nLevelNoctumancer = GetLevelByClass(101, OBJECT_SELF);
	int nLevelShadowTheurge = GetLevelByClass(103, OBJECT_SELF);
	int nCasterLvl = nLevelShadowcaster + nLevelMasterOfShadow + nLevelNoctumancer + nLevelShadowTheurge;
    int nDuration = 1;
	
    if (GetHasFeat(5198)) // If have mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    if (GetHasFeat(5199)) // If have greater mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
		
    if (GetHasFeat(5194)) // If have extend mystery, double it.
    {
        nCasterLvl = (nCasterLvl * 2);
    }	
	
    nDuration = nCasterLvl;	
	float fDuration = IntToFloat(nDuration);
	
    SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId(), FALSE));

	//Apply linked and VFX effects
    ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLore1, oTarget, fDuration);
    ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLore2, oTarget, fDuration);
    ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLore3, oTarget, fDuration);
    ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLore4, oTarget, fDuration);
    ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLore5, oTarget, fDuration);
    ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLore6, oTarget, fDuration);
    ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLore7, oTarget, fDuration);
    ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
}