//::///////////////////////////////////////////////
//:: Viscid Glob
//:: mt_s0_viscidglob
//:: Created By: Joshua Kalis (Greg)
//:: Created On: Jan 1, 2007
//:://////////////////////////////////////////////

#include "X0_I0_SPELLS"
#include "x2_inc_spellhook" 

void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }

	//Declare major variables
	object oTarget = GetSpellTargetObject();
	int nSpellId = GetSpellId();
	int nCasterLvl = GetCasterLevel(OBJECT_SELF);
	int nSpellSaveDC = GetSpellSaveDC();
	
	if (nCasterLvl > 16)
		nCasterLvl = (8+1)/2;

    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nCasterLvl = (nCasterLvl + 3);
        nSpellSaveDC = (nSpellSaveDC + 3);
    }	
    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nCasterLvl = (nCasterLvl + 2);
        nSpellSaveDC = (nSpellSaveDC + 2);
    }	
    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
        nSpellSaveDC = (nSpellSaveDC + 1);
    }	
				
	float nDuration = RoundsToSeconds(nCasterLvl);	
		
	effect eVis;	
	effect eOrbEffect;
	
	eVis = EffectVisualEffect(VFX_DUR_SPELL_WEB);
	eOrbEffect = EffectStunned();
		  
	if (GetIsObjectValid(oTarget))
	{
		if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
		{				
			if(!MyResistSpell(OBJECT_SELF, oTarget))
			{		
				//Fire cast spell at event for the specified target
				SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId()));				

				//Apply the effects
				ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
				
                if  (!MySavingThrow(SAVING_THROW_FORT, oTarget, nSpellSaveDC, SAVING_THROW_TYPE_ALL))
					ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eOrbEffect, oTarget, nDuration);				
			}
		}	
	}			
}