//::///////////////////////////////////////////////
//:: Widened Eyes
//:: mt_s0_widenedeyes
//:: Purpose: Fundamental Mystery - Widened Eyes
//:: Created By: Joshua Kalis (Greg)
//:: Created On: September 19, 2015
//:: Description: Darkvision
//:: Fundamental Mystery
//::
//:: You cause a single target to gain darkvision.
//:://////////////////////////////////////////////

#include "nwn2_inc_spells"
#include "X0_I0_SPELLS"
#include "x2_inc_spellhook"
#include "ginc_henchman"


void main()
{
    if (!X2PreSpellCastCode())
    {
    // If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
// End of Spell Cast Hook

	int nLevelShadowcaster = GetLevelByClass(99, OBJECT_SELF);
	int nLevelMasterOfShadow = GetLevelByClass(100, OBJECT_SELF);
	int nLevelNoctumancer = GetLevelByClass(101, OBJECT_SELF);
	int nLevelShadowTheurge = GetLevelByClass(103, OBJECT_SELF);
	int nCasterLvl = nLevelShadowcaster + nLevelMasterOfShadow + nLevelNoctumancer + nLevelShadowTheurge;
    int nDuration = 1;
	
    if (GetHasFeat(5198)) // If have mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
    if (GetHasFeat(5199)) // If have greater mystery focus, add 1 more.
    {
        nCasterLvl = (nCasterLvl + 1);
    }	
		
    if (GetHasFeat(5194)) // If have extend mystery, double it.
    {
        nCasterLvl = (nCasterLvl * 2);
    }	
	
    nDuration = nCasterLvl * 60 * 10;	
	float fDuration = IntToFloat(nDuration);

    //Declare major variables
    object oTarget = GetSpellTargetObject();

    //Enter Metamagic conditions
    fDuration = ApplyMetamagicDurationMods(fDuration);
    int nDurType = ApplyMetamagicDurationTypeMods(DURATION_TYPE_TEMPORARY);

    // First, affect Caster...
    int nHenchmen = GetNumHenchmen(oTarget);
    int nCurHenchman = 0;

    // Now process all target critters, starting with the Caster
    while ( GetIsObjectValid(oTarget) )
    {
        //Fire cast spell at event for the specified target
        SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId()));

        effect eDur = EffectVisualEffect( VFX_DUR_SPELL_LOWLIGHT_VISION );
        effect eSight = EffectUltravision();
        effect eLink = EffectLinkEffects(eDur, eSight);

        //Apply the VFX impact and effects
        ApplyEffectToObject(nDurType, eLink, oTarget, fDuration);
    }
}