//::///////////////////////////////////////////////
//:: Wreath of Flames
//:: mt_s0_wreathofflames
//:: Nov 9, 2015
//:://////////////////////////////////////////////

#include "x2_inc_spellhook"
#include "x0_i0_spells"

void main()
{
    if (!X2PreSpellCastCode())
    {
	    // If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
		return;
    }
// End of Spell Cast Hook

    //Declare major variables
    effect eVis = EffectVisualEffect(VFX_DUR_FIRE);
    int nDuration = GetCasterLevel(OBJECT_SELF);

    if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
    {
        nDuration = (nDuration + 1);
    }	
    if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
    {
        nDuration = (nDuration + 2);
    }	
    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
    {
        nDuration = (nDuration + 3);
    }	
    if (GetHasFeat(3094)) // If have fiery burst, add 1 more.
    {
        nDuration = (nDuration + 1);
    }	
    if (GetHasFeat(5036)) // If have fire adept
    {
        nDuration = (nDuration + 1);
    }	
    if (GetHasFeat(5264)) // If have bloodline of fire
    {
        nDuration = (nDuration + 2);
    }	
	
    int nDamage = nDuration * 2;
    int nMetaMagic = GetMetaMagicFeat();
    object oTarget = OBJECT_SELF;
    effect eShield = EffectDamageShield(nDamage, DAMAGE_BONUS_1d6, DAMAGE_TYPE_FIRE);
    effect eDur = EffectVisualEffect(VFX_DUR_FIRE);

    //Link effects
    effect eLink = EffectLinkEffects(eShield, eDur);
    eLink = EffectLinkEffects(eLink, eVis);

    //Fire cast spell at event for the specified target
    SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, GetSpellId(), FALSE));

    //Enter Metamagic conditions
    if (nMetaMagic & METAMAGIC_EXTEND)
    {
        nDuration = nDuration *2; //Duration is +100%
    }

    // 2003-07-07: Stacking Spell Pass, Georg
    RemoveEffectsFromSpell(oTarget, GetSpellId());

    //Apply the VFX impact and effects
    ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eLink, oTarget, RoundsToSeconds(nDuration));	
	
	effect eFireDam = EffectDamageIncrease(d6(1), DAMAGE_TYPE_FIRE);
    ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eFireDam, oTarget, RoundsToSeconds(nDuration));	
}