//::///////////////////////////////////////////////
//:: Zajimarn's Ice Claw Prison
//:: mt_s0_zajimarnsprison
//:: Created By: Brent
//:: Created On: September 7, 2002
//:://////////////////////////////////////////////

#include "x0_i0_spells"
#include "x2_inc_spellhook"
#include "x2_i0_spells"

//int nSpellID = 462;	// GetSpellId() will do the job for us

void RunHandImpact(object oTarget, object oCaster)
{
	//SpawnScriptDebugger();

	int nSpellID = GetSpellId();
    //--------------------------------------------------------------------------
    // Check if the spell has expired (check also removes effects)
    //--------------------------------------------------------------------------
    if (GZGetDelayedSpellEffectsExpired(nSpellID,oTarget,oCaster))
    {
        return;
    }
	
    int nCasterModifiers = GetCasterAbilityModifier(oCaster) + GetCasterLevel(oCaster);
    int nCasterRoll = d20(1) + nCasterModifiers + 11 + -1;
    int nTargetRoll = GetAC(oTarget);
    if (nCasterRoll >= nTargetRoll)
    {
       	int nDC = GetLocalInt(oTarget,"MT_L_SPELL_SAVE_DC_" + IntToString (nSpellID));

		int nDmgType = DAMAGE_TYPE_COLD;	
		
       	int nDam  = MaximizeOrEmpower(8, 1, GetMetaMagicFeat(), 11);
       	int nDam2  = MaximizeOrEmpower(8, 1, GetMetaMagicFeat(), 0);
       	effect eDam = EffectDamage(nDam, DAMAGE_TYPE_BLUDGEONING);
       	effect eDam2 = EffectDamage(nDam, nDmgType);
       	//effect eVis = EffectVisualEffect(VFX_IMP_ACID_L);	// NWN1 VFX
       	effect eVis = EffectVisualEffect( 837 );	// NWN2 VFX: VFX_HIT_BIGBYS_CLENCHED_FIST

       	DelayCommand( 0.8f, ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam, oTarget) );
       	DelayCommand( 0.8f, ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam2, oTarget) );
       	ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);

       	if (!MySavingThrow(SAVING_THROW_FORT, oTarget, nDC))
       	{
			effect eStun = EffectStunned();
			effect eDur = EffectVisualEffect( VFX_DUR_STUN );
			eStun = EffectLinkEffects( eStun, eDur );
           	DelayCommand( 0.8f, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eStun, oTarget, RoundsToSeconds(1)) );
       	}

      	DelayCommand(6.0f,RunHandImpact(oTarget,oCaster));
   	}
}


void main()
{
    if (!X2PreSpellCastCode())
    {	// If code within the PreSpellCastHook (i.e. UMD) reports FALSE, do not run this spell
        return;
    }
    // End of Spell Cast Hook

    object oTarget = GetSpellTargetObject();
	int nSpellID = GetSpellId();

    //--------------------------------------------------------------------------
    // This spell no longer stacks. If there is one hand, that's enough
    //--------------------------------------------------------------------------
    if (GetHasSpellEffect(nSpellID,oTarget) ||  GetHasSpellEffect(463,oTarget)  )
    {
        FloatingTextStrRefOnCreature(100775,OBJECT_SELF,FALSE);
        return;
    }

    int nDuration = GetCasterLevel(OBJECT_SELF);
    int nMetaMagic = GetMetaMagicFeat();
    if (nMetaMagic & METAMAGIC_EXTEND)
    {
         nDuration = nDuration * 2;
    }

    if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, OBJECT_SELF))
    {
        SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, nSpellID, TRUE));
        int nResult = MyResistSpell(OBJECT_SELF, oTarget);

        if(nResult  == 0)
        {
			int nCasterModifier = GetCasterAbilityModifier(OBJECT_SELF);
            effect eHand = EffectVisualEffect(VFX_DUR_BIGBYS_CLENCHED_FIST);
            ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eHand, oTarget, RoundsToSeconds(nDuration));

            //----------------------------------------------------------
            // GZ: 2003-Oct-15
            // Save the current save DC on the character because
            // GetSpellSaveDC won't work when delayed
            //----------------------------------------------------------
            SetLocalInt(oTarget,"MT_L_SPELL_SAVE_DC_" + IntToString (nSpellID), GetSpellSaveDC());
            RunHandImpact(oTarget,OBJECT_SELF );
        }
    }
}