//::///////////////////////////////////////////////
//:: Incendiary Cloud
//:: NW_S0_IncCloud.nss
//:: Copyright (c) 2001 Bioware Corp.
//:://////////////////////////////////////////////
/*
    Person within the AoE take 4d6 fire damage
    per round.
*/
//:://////////////////////////////////////////////
//:: Created By: Preston Watamaniuk
//:: Created On: May 17, 2001
//:://////////////////////////////////////////////
//:: March 2003: Removed movement speed penalty
#include "X0_I0_SPELLS"

void main()
{

    //Declare major variables
    int nMetaMagic = GetMetaMagicFeat();
    int nDamage;
    effect eDam;
    object oTarget;
    //Declare and assign personal impact visual effect.
    effect eVis = EffectVisualEffect(VFX_HIT_SPELL_FIRE);
    float fDelay;
    //Capture the first target object in the shape.
    oTarget = GetEnteringObject();
    //Declare the spell shape, size and the location.
    if (spellsIsTarget(oTarget, SPELL_TARGET_STANDARDHOSTILE, GetAreaOfEffectCreator()))
    {
        //Fire cast spell at event for the specified target
        SignalEvent(oTarget, EventSpellCastAt(OBJECT_SELF, SPELL_INCENDIARY_CLOUD));
        //Make SR check, and appropriate saving throw(s).
       // if(!MyResistSpell(GetAreaOfEffectCreator(), oTarget, fDelay))
      //  {
            fDelay = GetRandomDelay(0.5, 2.0);
            //Roll damage.

			int nCasterLvl = 0;			
			int nBonus = 0;
		    if (GetHasFeat(5028)) // If have archmage SP+3, add 3 more.
		    {
		        nCasterLvl = (nCasterLvl + 3);
		        nBonus = (nBonus + 3);
		    }	
		    else if (GetHasFeat(5027)) // If have archmage SP+2, add 2 more.
		    {
		        nCasterLvl = (nCasterLvl + 2);
		        nBonus = (nBonus + 2);
		    }	
		    else if (GetHasFeat(5026)) // If have archmage SP+1, add 1 more.
		    {
		        nCasterLvl = (nCasterLvl + 1);
		        nBonus = (nBonus + 1);
		    }	
		
		    if (GetHasFeat(3094)) // If have fiery burst
		    {
		        nCasterLvl = (nCasterLvl + 1);
		    }	
		    if (GetHasFeat(5036)) // If have fire adept
		    {
		        nCasterLvl = (nCasterLvl + 1);
		    }	
		    if (GetHasFeat(5264)) // If have bloodline of fire
		    {
		        nCasterLvl = (nCasterLvl + 2);
		    }	
			
            nDamage = d6(4) + nCasterLvl;
            //Enter Metamagic conditions
                if (nMetaMagic == METAMAGIC_MAXIMIZE)
                {
                   nDamage = 24 + nCasterLvl;//Damage is at max
                }
                if (nMetaMagic == METAMAGIC_EMPOWER)
                {
                     nDamage = nDamage + (nDamage/2); //Damage/Healing is +50%
                }
            //Adjust damage for Reflex Save, Evasion and Improved Evasion
            nDamage = GetReflexAdjustedDamage(nDamage, oTarget, GetSpellSaveDC() + nBonus, SAVING_THROW_TYPE_FIRE, GetAreaOfEffectCreator());
            // Apply effects to the currently selected target.
            eDam = EffectDamage(nDamage, DAMAGE_TYPE_FIRE);
            if(nDamage > 0)
            {
                DelayCommand(fDelay, ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam, oTarget));
                DelayCommand(fDelay, ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget));
				
				if (GetHasFeat(5212,OBJECT_SELF,TRUE)) // Diabolism
				{
					int nLevelDiabolist = GetLevelByClass(96, OBJECT_SELF);
					if(nLevelDiabolist == 10)
						nDamage = 3;
					else if(nLevelDiabolist == 5)
						nDamage = 2;
					else
						nDamage = 1;
											
	                effect eDam2 = EffectDamage(nDamage, DAMAGE_TYPE_NEGATIVE);
					ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam2, oTarget);
				}

				if (GetHasFeat(5213,OBJECT_SELF,TRUE)) // Vile Diabolism
				{
					nDamage = 1;
	                effect eDam3 = EffectDamage(nDamage, DAMAGE_TYPE_MAGICAL);
					ApplyEffectToObject(DURATION_TYPE_INSTANT, eDam3, oTarget);
				}																					
            }
       // }
    }
}